package me.evilpeanut;
import java.io.File;
import java.util.Random;

import org.bukkit.ChatColor;
import org.bukkit.DyeColor;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.block.BlockFace;
import org.bukkit.block.Sign;
import org.bukkit.entity.Arrow;
import org.bukkit.entity.Blaze;
import org.bukkit.entity.Boat;
import org.bukkit.entity.CaveSpider;
import org.bukkit.entity.Creeper;
import org.bukkit.entity.Egg;
import org.bukkit.entity.Enderman;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Fireball;
import org.bukkit.entity.Ghast;
import org.bukkit.entity.Giant;
import org.bukkit.entity.IronGolem;
import org.bukkit.entity.MagmaCube;
import org.bukkit.entity.PigZombie;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.entity.Sheep;
import org.bukkit.entity.Silverfish;
import org.bukkit.entity.Skeleton;
import org.bukkit.entity.Slime;
import org.bukkit.entity.Snowball;
import org.bukkit.entity.Spider;
import org.bukkit.entity.TNTPrimed;
import org.bukkit.entity.Wither;
import org.bukkit.entity.Wolf;
import org.bukkit.entity.Zombie;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockDispenseEvent;
import org.bukkit.event.block.BlockFormEvent;
import org.bukkit.event.block.BlockIgniteEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.EntityBlockFormEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.EntityChangeBlockEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.event.entity.EntityExplodeEvent;
import org.bukkit.event.entity.EntityTargetLivingEntityEvent;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.event.hanging.HangingBreakByEntityEvent;
import org.bukkit.event.hanging.HangingBreakEvent;
import org.bukkit.event.hanging.HangingBreakEvent.RemoveCause;
import org.bukkit.event.hanging.HangingPlaceEvent;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerBucketEmptyEvent;
import org.bukkit.event.player.PlayerChangedWorldEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerDropItemEvent;
import org.bukkit.event.player.PlayerEditBookEvent;
import org.bukkit.event.player.PlayerEggThrowEvent;
import org.bukkit.event.player.PlayerGameModeChangeEvent;
import org.bukkit.event.player.PlayerInteractEntityEvent;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerKickEvent;
import org.bukkit.event.player.PlayerLoginEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerPortalEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;
import org.bukkit.event.player.PlayerTeleportEvent;
import org.bukkit.event.player.PlayerLoginEvent.Result;
import org.bukkit.event.vehicle.VehicleCreateEvent;
import org.bukkit.event.vehicle.VehicleMoveEvent;
import org.bukkit.inventory.meta.BookMeta;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

/**
 * @author Reece Aaron Lecrivain
 */
public class EventListener implements Listener {
	private EvilBook plugin;

	/**
	 * Define a new event listener
	 * @param evilBook The parent evilbook plugin
	 */
	public EventListener(EvilBook evilBook) {
		plugin = evilBook;
	}
	
	/**
	 * Called when a player moves
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerMove(PlayerMoveEvent event) {
		plugin.getProfile(event.getPlayer()).lastActionTime = System.currentTimeMillis();
		if (plugin.getProfile(event.getPlayer()).isAway) {
			plugin.getProfile(event.getPlayer()).isAway = false;
			plugin.getProfile(event.getPlayer()).updatePlayerListName(event.getPlayer());
		}
		if (event.getTo().getBlockX() > 12550820 || event.getTo().getBlockX() < -12550820 || event.getTo().getBlockZ() > 12550820 || event.getTo().getBlockZ() < -12550820) {
			event.getPlayer().sendMessage("7The Far Lands are blocked");
			event.setTo(event.getTo().add(event.getTo().getBlockX() > 12550820 ? -2 : event.getTo().getBlockX() < -12550820 ? 2 : 0, 0, event.getTo().getBlockZ() > 12550820 ? -2 : event.getTo().getBlockZ() < -12550820 ? 2 : 0));
			event.getPlayer().teleport(event.getTo());
			event.setCancelled(true);
			return;
		}
		if (!plugin.isInSurvival(event.getPlayer()) && !plugin.isInAdventure(event.getPlayer())) {
			if (plugin.getProfile(event.getPlayer()).jumpAmplifier != 0 && !event.getPlayer().isFlying() && event.getFrom().getY() < event.getTo().getY() && event.getPlayer().getLocation().getBlock().getRelative(BlockFace.DOWN).getType() != Material.AIR) event.getPlayer().setVelocity(event.getPlayer().getVelocity().setY(plugin.getProfile(event.getPlayer()).jumpAmplifier));
			if (plugin.getProfile(event.getPlayer()).runAmplifier != 0 && event.getPlayer().isSprinting()) event.getPlayer().addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 20, plugin.getProfile(event.getPlayer()).runAmplifier), true);
		}
		// Regions
		for (Region region : plugin.regionList) {
			if (region.getLeaveMessage() != null && plugin.isInRegion(region, event.getFrom()) && plugin.isInRegion(region, event.getTo()) == false) {
				event.getPlayer().sendMessage(region.getLeaveMessage());
			} else if (plugin.isInRegion(region, event.getTo())) {
				if (region.getWelcomeMessage() != null && plugin.isInRegion(region, event.getFrom()) == false) event.getPlayer().sendMessage(region.getWelcomeMessage());
				if (region.getWarp() != null) {
					try {
						event.getPlayer().teleport(plugin.warpList.get(region.getWarp()));
					} catch (Exception e) {
						//TODO: Mabey stop this catch happening?
					}
					break;
				}
			}
		}
	}
	
	/**
	 * Called when a player's money balance changes
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerMoneyChange(PlayerMoneyChangeEvent event) {
		//TODO: Use for player money gain achievement
	}
	
	/**
	 * Called when a player throws an egg
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerEggThrow(PlayerEggThrowEvent event) {
		if (event.getPlayer().getNearbyEntities(64, 64, 64).size() >= 400 && plugin.getProfile(event.getPlayer()).rank.isAdmin() == false) event.setHatching(false);
	}

	/**
	 * Called when a player is about to be teleported by a portal
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onPlayerPortal(PlayerPortalEvent event) {
		//TODO: Make portals cancel when they are a region warp portal
		if (event.getFrom().getWorld().getName().equals("SurvivalLand")) {
			event.getPlayer().teleport(plugin.getServer().getWorld("SurvivalLandNether").getSpawnLocation());
		} else if (event.getFrom().getWorld().getName().equals("SurvivalLandNether")) {
			event.getPlayer().teleport(plugin.getServer().getWorld("SurvivalLand").getSpawnLocation());
		}
	}
	
	/**
	 * Called when a player drops an item
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onPlayerDropItem(PlayerDropItemEvent event) {
		if (plugin.getProfile(event.getPlayer()).rank.isAdmin() || plugin.isInSurvival(event.getPlayer())) return;
		int dropCount = 0;
		for (Entity e : event.getPlayer().getLocation().getWorld().getEntities()) if (e.getType() == EntityType.DROPPED_ITEM) dropCount++;
		if (dropCount >= 128) event.setCancelled(true);
	}
	
	/**
	 * Called when a player empties a bucket
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onPlayerBucketEmpty(PlayerBucketEmptyEvent event) {
		Player player = event.getPlayer();
		if (plugin.getProfile(player).rank.isAdmin() == false) {
			player.sendMessage((event.getBucket() == Material.LAVA_BUCKET ? "dLava buckets" : "dWater buckets") + " are an 5Admin donly feature");
			player.sendMessage("dPlease type 6/admin dto learn how to become admin");
			event.setCancelled(true);
			return;
		}
	}
	
	/**
	 * Called when a player dies
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerDeath(PlayerDeathEvent event) {
		Player player = event.getEntity();
		plugin.getProfile(player).deathLocation = player.getLocation();
		if (player.getLastDamageCause() == null) return;
		EntityDamageEvent damageEvent = player.getLastDamageCause();
		EntityDamageEvent.DamageCause damageCause = damageEvent.getCause();
		if (damageEvent instanceof EntityDamageByEntityEvent) {
			EntityDamageByEntityEvent kie = (EntityDamageByEntityEvent)damageEvent;
			Entity damager = kie.getDamager();
			if (damageCause == DamageCause.ENTITY_ATTACK) {
				if (damager instanceof Player)
				{
					Player attackPlayer = (Player) damager;
					event.setDeathMessage(player.getDisplayName() + " was murdered by " + attackPlayer.getDisplayName() + " wielding their " + (attackPlayer.getItemInHand().getType() == Material.AIR ? "fists" : attackPlayer.getItemInHand().getType().toString().toLowerCase().replace("_", " ")));
					return;
				} else if (damager instanceof Zombie) {
					event.setDeathMessage(player.getDisplayName() + " had their brains eaten by a Zombie");
				} else if (damager instanceof Spider) {
					event.setDeathMessage(player.getDisplayName() + " had their flesh devoured by a Spider");
				} else if (damager instanceof CaveSpider) {
					event.setDeathMessage(player.getDisplayName() + " had their flesh devoured by a Cave-Spider");
				} else if (damager instanceof Enderman) {
					event.setDeathMessage(player.getDisplayName() + " had their soul consumed by an Enderman");
				} else if (damager instanceof Silverfish) {
					event.setDeathMessage(player.getDisplayName() + " had their insides ripped out by a Silverfish");
				} else if (damager instanceof MagmaCube) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse burnt to ashes by a Magma-Cube");
				} else if (damager instanceof Slime) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse dissolved in a Slime");
				} else if (damager instanceof Wolf) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse ripped appart by a Wolf");
				} else if (damager instanceof PigZombie) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse cut in two by a Pigman-Zombie");
				} else if (damager instanceof IronGolem) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse crushed by an Iron-Golem");
				} else if (damager instanceof Giant) {
					event.setDeathMessage(player.getDisplayName() + " had their corpse crushed by a Giant");
				}
			} else if (damageCause == DamageCause.PROJECTILE) {
				Projectile pro = (Projectile)damager;
				if (pro.getShooter() instanceof Player) {
					Player attackPlayer = (Player) pro.getShooter();
					if (pro instanceof Arrow) {
						event.setDeathMessage(player.getDisplayName() + " was killed by " + attackPlayer.getDisplayName() + "'s arrow");
					} else if (pro instanceof Snowball) {
						event.setDeathMessage(player.getDisplayName() + " was killed by " + attackPlayer.getDisplayName() + "'s snowball");
					} else if (pro instanceof Egg) {
						event.setDeathMessage(player.getDisplayName() + " was killed by " + attackPlayer.getDisplayName() + "'s egg");
					} else {
						event.setDeathMessage(player.getDisplayName() + " was killed by " + attackPlayer.getDisplayName() + "'s projectile");
					}
					return;
				}
				if (pro instanceof Arrow)
				{
					if ((pro.getShooter() instanceof Skeleton)) {
						event.setDeathMessage(player.getDisplayName() + " had their bones smashed by a Skeleton's arrow");
					} else {
						event.setDeathMessage(player.getDisplayName() + " had their bones smashed by an arrow trap");
					}
				} else if (pro instanceof Snowball) {
					event.setDeathMessage(player.getDisplayName() + " had their blood frozen by a Snowman's snowball");
				} else if (pro instanceof Fireball) {
					if (pro.getShooter() instanceof Ghast) {
						event.setDeathMessage(player.getDisplayName() + " had their insides boiled by a Ghast's fireball");
					} else if ((pro.getShooter() instanceof Blaze)) {
						event.setDeathMessage(player.getDisplayName() + " had their insides boiled by a Blazes's fireball");
					} else if ((pro.getShooter() instanceof Wither)) {
						event.setDeathMessage(player.getDisplayName() + " had their insides boiled by a Wither's fireball");
					} else {
						event.setDeathMessage(player.getDisplayName() + " had their insides boiled by a fireball");
					}
				}
			} else if (damageCause == DamageCause.ENTITY_EXPLOSION) {
				if (damager instanceof Creeper) {
					event.setDeathMessage(player.getDisplayName() + " was blown up by a Creeper");
				} else if (damager instanceof TNTPrimed) {
					event.setDeathMessage(player.getDisplayName() + " was blown up by TNT");
				}
			}
		} else {
			if (damageCause == DamageCause.DROWNING) {
				event.setDeathMessage(player.getDisplayName() + " drowned to death");
			} else if (damageCause == DamageCause.STARVATION) {
				event.setDeathMessage(player.getDisplayName() + " starved to death");
			} else if (damageCause == DamageCause.CONTACT) {
				event.setDeathMessage(player.getDisplayName() + " was playing with a cactus when it pricked back");
			} else if (damageCause == DamageCause.CUSTOM) {
				event.setDeathMessage(player.getDisplayName() + " died");
			} else if (damageCause == DamageCause.FIRE) {
				event.setDeathMessage(player.getDisplayName() + " had their corpse burnt to ashes by fire");
			} else if (damageCause == DamageCause.FIRE_TICK) {
				event.setDeathMessage(player.getDisplayName() + " had their corpse burnt to ashes by fire");
			} else if (damageCause == DamageCause.LAVA) {
				event.setDeathMessage(player.getDisplayName() + " had their corpse burnt to ashes by lava");
			} else if (damageCause == DamageCause.LIGHTNING) {
				event.setDeathMessage(player.getDisplayName() + " had their corpse burnt to ashes by lightning");
			} else if (damageCause == DamageCause.POISON) {
				event.setDeathMessage(player.getDisplayName() + " died from poisoning");
			} else if (damageCause == DamageCause.SUFFOCATION) {
				event.setDeathMessage(player.getDisplayName() + " suffocated to death");
			} else if (damageCause == DamageCause.VOID) {
				event.setDeathMessage(player.getDisplayName() + " was crushed by the never ending black hole");
			} else if (damageCause == DamageCause.FALL) {
				event.setDeathMessage(player.getDisplayName() + " fell to their death");
			} else if (damageCause == DamageCause.SUICIDE) {
				event.setDeathMessage(player.getDisplayName() + " committed suicide");
			} else if (damageCause == DamageCause.MAGIC) {
				event.setDeathMessage(player.getDisplayName() + " was destroyed at the hands of a sourcerer");
			} else if (damageCause == DamageCause.WITHER) {
				event.setDeathMessage(player.getDisplayName() + " was crushed by a wither");
			}
		}
	}
	
	/**
	 * Called when a player attempts to login
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onPlayerLogin(PlayerLoginEvent event) {
		if (event.getResult().equals(Result.KICK_BANNED)) {
			event.setKickMessage("cYou are banned! E-mail us for support at buddypeanut@hotmail.co.uk");
			return;
		}
		plugin.updateWebPlayerStatistics(plugin.getServer().getOnlinePlayers().length + 1);
		/*
		Properties prop = new Properties();
		try {
			File statFile = new File("plugins/EvilBook/Statistics.txt");
			if (statFile.exists()) statFile.createNewFile();
			FileInputStream inputStream = new FileInputStream(statFile);
			prop.load(inputStream);
			inputStream.close();
			String propName = Calendar.getInstance().get(Calendar.DAY_OF_MONTH) + "/" + (Calendar.getInstance().get(Calendar.MONTH) + 1) + "/" + Calendar.getInstance().get(Calendar.YEAR);
			int stat = Integer.getInteger(prop.getProperty(propName)) + 1;
			plugin.logInfo(prop.getProperty(propName));
			plugin.logInfo("" + stat);
			prop.setProperty(propName, prop.getProperty(propName) == null ? "1" : Integer.toString(Integer.getInteger(prop.getProperty(propName)) + 1));
			FileOutputStream outputStream = new FileOutputStream(statFile);
			prop.store(outputStream, "Login statistics");
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		*/
	}
	
	/**
	 * Called when a player joins the server after login
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onPlayerJoin(PlayerJoinEvent event) {
		//
		for (Player player : plugin.getServer().getOnlinePlayers()) {
			if (player != event.getPlayer() && plugin.getProfile(player).isInvisible) event.getPlayer().hidePlayer(player);
		}
		//if (plugin.isInSurvival(event.getPlayer())) event.getPlayer().setScoreboard(plugin.survivalStatsScoreboard);
		plugin.playerProfiles.put(event.getPlayer().getName().toLowerCase(), new PlayerProfile(plugin, event.getPlayer()));
		event.setJoinMessage(null);
		// Statistics
		plugin.statistics.setProperty("Total logins", Long.valueOf(plugin.statistics.getProperty("Total logins")) + 1);
		// Regions
		for (Region region : plugin.regionList) {
			if (plugin.isInRegion(region, event.getPlayer().getLocation())) {
				if (region.getWelcomeMessage() != null) event.getPlayer().sendMessage(region.getWelcomeMessage());
				if (region.getWarp() != null) {
					event.getPlayer().teleport(plugin.warpList.get(region.getWarp()));
					break;
				}
			}
		}
	}
	
	/**
	 * Called when a player respawns
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onPlayerRespawn(PlayerRespawnEvent event) {
		if (plugin.isInSurvival(event.getPlayer())) {
			plugin.setSurvivalInventory(event.getPlayer());
			if (plugin.isInSurvival(event.getPlayer().getWorld().getName())) event.setRespawnLocation(plugin.getServer().getWorld("SurvivalLand").getSpawnLocation());
		}
		// Regions
		for (Region region : plugin.regionList) {
			if (plugin.isInRegion(region, event.getRespawnLocation())) {
				if (region.getWelcomeMessage() != null) event.getPlayer().sendMessage(region.getWelcomeMessage());
				if (region.getWarp() != null) {
					event.getPlayer().teleport(plugin.warpList.get(region.getWarp()));
					break;
				}
			}
		}
	}
	
	/**
	 * Called when a player leaves the server
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onPlayerQuit(PlayerQuitEvent event) {
		plugin.getProfile(event.getPlayer()).saveProfile();
		plugin.playerProfiles.remove(event.getPlayer().getName().toLowerCase());
		event.setQuitMessage(ChatColor.GRAY + event.getPlayer().getName() + " has left the game");
		plugin.updateWebPlayerStatistics(plugin.getServer().getOnlinePlayers().length - 1);
	}
	
	/**
	 * Called when a player is kicked from the server
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onPlayerKick(PlayerKickEvent event) {
		event.setLeaveMessage(ChatColor.GRAY + event.getPlayer().getName() + " has left the game");
	}
	
	/**
	 * Called when a player sends a chat message
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onAsyncPlayerChat(AsyncPlayerChatEvent event) {
		Player player = event.getPlayer();
		plugin.getProfile(player).lastActionTime = System.currentTimeMillis();
		if (plugin.getProfile(player).isAway) {
			plugin.getProfile(player).isAway = false;
			plugin.getProfile(event.getPlayer()).updatePlayerListName(event.getPlayer());
		}
		event.setCancelled(true);
		plugin.broadcastPlayerMessage(player.getName(), plugin.getProfile(player).rank.getPrefix(plugin.getProfile(player)) + " " + plugin.getProfile(player).rank.getColor(plugin.getProfile(player)) 
				+ "<" + player.getDisplayName() + "" + plugin.getProfile(player).rank.getColor(plugin.getProfile(player)) 
				+ "> f" + plugin.toFormattedString(event.getMessage()));
		// Statistics
		plugin.statistics.setProperty("Messages sent", Long.valueOf(plugin.statistics.getProperty("Messages sent")) + 1);
	}
	
	/**
	 * Called when a player edits a book
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerEditBook(PlayerEditBookEvent event) {
		BookMeta book = event.getNewBookMeta();
		for (int page = 1; page <= book.getPageCount(); page++) book.setPage(page, plugin.toFormattedString(book.getPage(page)));
		event.setNewBookMeta(book);
	}
	
	/**
	 * Called when a player interacts with an entity
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerInteractEntity(PlayerInteractEntityEvent event) {
		if (event.getRightClicked().getPassenger() == event.getPlayer()) {
			event.getRightClicked().eject();
		} else if (event.getRightClicked().getType() != EntityType.MINECART_CHEST && event.getRightClicked().getType() != EntityType.MINECART_FURNACE && 
				event.getRightClicked().getType() != EntityType.MINECART_HOPPER && event.getRightClicked().getType() != EntityType.MINECART_MOB_SPAWNER && 
				event.getRightClicked().getType() != EntityType.MINECART_TNT && event.getRightClicked().getType() != EntityType.ITEM_FRAME && 
				event.getRightClicked().getType() != EntityType.FALLING_BLOCK && event.getRightClicked().getType() != EntityType.PRIMED_TNT &&
				event.getRightClicked().getPassenger() == null && event.getRightClicked() != event.getPlayer().getPassenger()) {
			event.getRightClicked().setPassenger(event.getPlayer());
		}
	}
	
	/**
	 * Called when a player interacts with an object or air
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerInteract(PlayerInteractEvent event) {
		Player player = event.getPlayer();
		Block block = event.getClickedBlock();
		if (event.getAction() == Action.RIGHT_CLICK_BLOCK) {
			if (block.getType() == Material.COMMAND && !plugin.getProfile(player.getName()).rank.isAdmin()) {
				player.sendMessage("dCommand Blocks are an 5Admin donly feature");
				player.sendMessage("dPlease type 6/admin dto learn how to become admin");
				event.setCancelled(true);
				return;
			}
			if (plugin.isInSurvival(player) && plugin.getProfile(player.getName()).rank != Rank.ServerHost) {
				if (block.getType() == Material.ENDER_CHEST) {
					player.sendMessage("7Ender chests are blocked in survival");
					event.setCancelled(true);
					return;
				}
				if ((block.getType() == Material.DISPENSER || block.getType() == Material.CHEST || block.getType() == Material.WORKBENCH || block.getType() == Material.FURNACE || block.getType() == Material.BURNING_FURNACE || block.getType() == Material.BREWING_STAND || block.getType() == Material.ANVIL || block.getType() == Material.TRAPPED_CHEST || block.getType() == Material.DROPPER) && plugin.isContainerProtected(event.getClickedBlock().getLocation(), player)) {
					player.sendMessage(ChatColor.GRAY + "You don't have permission to use this " + plugin.blockList.get(block.getType()).get(0).toLowerCase());
					event.setCancelled(true);
					return;
				}
			}
			if (event.hasItem()) {
				if (plugin.getProfile(player).rank.isAdmin() && (plugin.isInSurvival(player.getName()) == false || plugin.getProfile(player).rank == Rank.ServerHost)) {
					if (event.getItem().getType() == Material.GOLD_SPADE) {
						plugin.getProfile(player).actionLocationB = block.getLocation();
						player.sendMessage("7Second point selected (" + block.getX() + ", " + block.getY() + ", " + block.getZ() + ")");
						event.setCancelled(true);
						return;
					}
				}
				if (event.getItem().getType() == Material.INK_SACK) {
					if (block.getType() == Material.SIGN_POST || block.getType() == Material.WALL_SIGN) {
						ChatColor dyeTextColor;
						switch (event.getItem().getData().getData()) {
						case 1: dyeTextColor = ChatColor.RED; break;
						case 2: dyeTextColor = ChatColor.DARK_GREEN; break;
						case 4: dyeTextColor = ChatColor.BLUE; break;
						case 5: dyeTextColor = ChatColor.DARK_PURPLE; break;
						case 6: dyeTextColor = ChatColor.DARK_AQUA; break;
						case 7: dyeTextColor = ChatColor.GRAY; break;
						case 8: dyeTextColor = ChatColor.DARK_GRAY; break;
						case 9: dyeTextColor = ChatColor.LIGHT_PURPLE; break;
						case 10: dyeTextColor = ChatColor.GREEN; break;
						case 11: dyeTextColor = ChatColor.YELLOW; break;
						case 12: dyeTextColor = ChatColor.AQUA; break;
						case 13: dyeTextColor = ChatColor.LIGHT_PURPLE; break;
						case 14: dyeTextColor = ChatColor.GOLD; break;
						case 15: dyeTextColor = ChatColor.WHITE; break;
						default: dyeTextColor = ChatColor.BLACK; break;
						}
						Sign s = (Sign) event.getClickedBlock().getState();
						if (s.getLine(0).length() != 0) s.setLine(0, dyeTextColor + (s.getLine(0).startsWith("") && !s.getLine(0).startsWith("l") && !s.getLine(0).startsWith("k") && !s.getLine(0).startsWith("n") && !s.getLine(0).startsWith("m") && !s.getLine(0).startsWith("o") && !s.getLine(0).startsWith("r") ? s.getLine(0).substring(2, s.getLine(0).length()) : s.getLine(0)));
						if (s.getLine(1).length() != 0) s.setLine(1, dyeTextColor + (s.getLine(1).startsWith("") && !s.getLine(1).startsWith("l") && !s.getLine(1).startsWith("k") && !s.getLine(1).startsWith("n") && !s.getLine(1).startsWith("m") && !s.getLine(1).startsWith("o") && !s.getLine(1).startsWith("r") ? s.getLine(1).substring(2, s.getLine(1).length()) : s.getLine(1)));
						if (s.getLine(2).length() != 0) s.setLine(2, dyeTextColor + (s.getLine(2).startsWith("") && !s.getLine(2).startsWith("l") && !s.getLine(2).startsWith("k") && !s.getLine(2).startsWith("n") && !s.getLine(2).startsWith("m") && !s.getLine(2).startsWith("o") && !s.getLine(2).startsWith("r") ? s.getLine(2).substring(2, s.getLine(2).length()) : s.getLine(2)));
						if (s.getLine(3).length() != 0) s.setLine(3, dyeTextColor + (s.getLine(3).startsWith("") && !s.getLine(3).startsWith("l") && !s.getLine(3).startsWith("k") && !s.getLine(3).startsWith("n") && !s.getLine(3).startsWith("m") && !s.getLine(3).startsWith("o") && !s.getLine(3).startsWith("r") ? s.getLine(3).substring(2, s.getLine(3).length()) : s.getLine(3)));
						s.update();
					} else if (block.getType() == Material.WOOL) {
						byte dyeColor;
						switch (event.getItem().getData().getData()) {
						case 0: dyeColor = 15; break;
						case 1: dyeColor = 14; break;
						case 2: dyeColor = 13; break;
						case 3: dyeColor = 12; break;
						case 4: dyeColor = 11; break;
						case 5: dyeColor = 10; break;
						case 6: dyeColor = 9; break;
						case 7: dyeColor = 8; break;
						case 8: dyeColor = 7; break;
						case 9: dyeColor = 6; break;
						case 10: dyeColor = 5; break;
						case 11: dyeColor = 4; break;
						case 12: dyeColor = 3; break;
						case 13: dyeColor = 2; break;
						case 14: dyeColor = 1; break;
						default: dyeColor = 0; break;
						}
						block.setData(dyeColor);
					}
				}
			}
		} else if (event.getAction() == Action.LEFT_CLICK_BLOCK) {
			if (event.hasItem() && event.getItem().getType() == Material.STICK && event.getItem().getItemMeta().getLore() != null && event.getItem().getItemMeta().getLore().get(0).equals("Preforms ancient magical arts")) {
				if (plugin.getProfile(player).spellBook.size() == 0) {
					player.sendMessage("7You don't have any spells in your spellbook");
				} else {
					plugin.getProfile(player).selectedSpell.preformSpell(event);
				}
			}
		} else if (event.getAction() == Action.RIGHT_CLICK_AIR) {
			if (event.hasItem() && event.getItem().getType() == Material.STICK && event.getItem().getItemMeta() != null && event.getItem().getItemMeta().getLore().size() > 0 && event.getItem().getItemMeta().getLore().get(0).equals("Preforms ancient magical arts")) {
				if (plugin.getProfile(player).spellBook.size() == 0) {
					player.sendMessage("7You don't have any spells in your spellbook");
				} else {
					if (plugin.getProfile(player).selectedSpell == plugin.getProfile(player).spellBook.get(plugin.getProfile(player).spellBook.size() - 1)) {
						plugin.getProfile(player).selectedSpell = plugin.getProfile(player).spellBook.get(0);
						player.sendMessage("5Changed spell to d" + plugin.getProfile(player).selectedSpell.name);
					} else {
						plugin.getProfile(player).selectedSpell = plugin.getProfile(player).spellBook.get(plugin.getProfile(player).spellBook.indexOf(plugin.getProfile(player).selectedSpell) + 1);
						player.sendMessage("5Changed spell to d" + plugin.getProfile(player).selectedSpell.name);
					}
				}
			}
		}
		/* TODO: Add ledgit way to obtain wands
		if (player.getItemInHand().getTypeId() == 280 && player.getName().equals("EvilPeanut")) {
			ItemMeta meta = player.getItemInHand().getItemMeta();
			meta.setLore(Arrays.asList("Preforms ancient magical arts"));
			player.getItemInHand().setItemMeta(meta);	
			plugin.getProfile(player).addSpell(Spell.LightningStrikeI);
			plugin.getProfile(player).addSpell(Spell.ShockWaveI);
			plugin.getProfile(player).addSpell(Spell.ShockWaveII);
			plugin.getProfile(player).addSpell(Spell.InstantGrow);
		}
		*/
	}
	
	/**
	 * Called when a player sends a command
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onPlayerCommandPreprocess(PlayerCommandPreprocessEvent event) {
		Player player = event.getPlayer();
		if (plugin.getProfile(player).rank == Rank.ServerHost) return;
		if (event.getMessage().equalsIgnoreCase("/evilbook:stop")) {
			event.setCancelled(true); 
			return;
		}
		if (System.currentTimeMillis() - plugin.getProfile(player).lastMessageTime <= 250 && event.getMessage().equals(plugin.getProfile(player).lastMessage)) {
			player.kickPlayer("cSpam is not tollerated");
			event.setCancelled(true);
			return;
		}
		plugin.getProfile(player).lastMessage = event.getMessage();
		plugin.getProfile(player).lastMessageTime = System.currentTimeMillis();
		if (plugin.commandBlacklist.containsKey(event.getMessage().toLowerCase().split(" ")[0]) == false) return;
		if (plugin.getProfile(player).rank.getID() < plugin.commandBlacklist.get(event.getMessage().toLowerCase().split(" ")[0])) {
			if (plugin.getProfile(player).rank.isAdmin() == false && plugin.commandBlacklist.get(event.getMessage().toLowerCase().split(" ")[0]) >= Rank.Admin.getID()) {
				player.sendMessage("dThis is an 5Admin donly command");
				player.sendMessage("dPlease type 6/admin dto learn how to become admin");
			} else if (plugin.commandBlacklist.get(event.getMessage().toLowerCase().split(" ")[0]) == Rank.ServerHost.getID()) {
				player.sendMessage("7This command is blocked for security reasons");
			} else {
				player.sendMessage("7This command is for higher ranks only");
			}
			event.setCancelled(true);
			return;
		}
    }
	
	/**
	 * Called when a player teleports
	 */
	//TODO: Change some of this to onPlayerWorldChange
	@EventHandler(priority = EventPriority.NORMAL)
	public void onPlayerTeleport(PlayerTeleportEvent event) {
		try {
			Player player = event.getPlayer();
			if (event.getTo().getBlockX() > 12550820 || event.getTo().getBlockX() < -12550820 || event.getTo().getBlockZ() > 12550820 || event.getTo().getBlockZ() < -12550820) {
				player.sendMessage("7The Far Lands are blocked");
				event.setCancelled(true);
				return;
			}
			for (String world : plugin.paidWorldList) {
				if (event.getTo().getWorld().getName().toLowerCase().endsWith(world.toLowerCase())) {
					if (plugin.getProfile(player).rank != Rank.ServerHost && !plugin.getPrivateWorldProperty(event.getTo().getWorld().getName().split("plugins/EvilBook/Private worlds/")[1], "AllowedPlayers").contains(player.getName()) && !plugin.getProfile(player).allowedPrivateWorlds.contains(event.getTo().getWorld().getName().split("plugins/EvilBook/Private worlds/")[1].toLowerCase())) {
						player.sendMessage("7You don't have access to this private world");
						event.setCancelled(true);
						return;
					}
				}
			}
			if (event.getTo().getWorld().getName().equals("NewAmentrix")) {
				if (!plugin.getProfile(player).isAllowedNewWorld) {
					player.sendMessage("7You don't have access to the new world");
					event.setCancelled(true);
					return;
				}
			} else if (plugin.isInSurvival(event.getTo().getWorld().getName())) {
				if (plugin.getProfile(player).rank.getID() < Rank.Architect.getID()) {
					player.sendMessage("7The survival world requires architect rank");
					event.setCancelled(true);
					return;
				}
			} else if (event.getTo().getWorld().getName().equals("FlatLand") && plugin.getProfile(player).rank.getID() < plugin.commandBlacklist.get("/flatland")) {
				player.sendMessage("7You have to be a higher rank to access the flat lands");
				event.setCancelled(true);
			} else if (event.getTo().getWorld().getName().equals("SpaceLand") && plugin.getProfile(player).rank.getID() < plugin.commandBlacklist.get("/spaceland")) {
				player.sendMessage("7You have to be a higher rank to access the space lands");
				event.setCancelled(true);
			}
			if (event.getTo().getWorld() != event.getFrom().getWorld() && event.getFrom().getWorld().getName() != "SurvivalLandNether" && event.getFrom().getWorld().getName() != "Amentrix_nether" && event.getFrom().getWorld().getName() != "Amentrix_the_end") plugin.getProfile(player.getName()).setWorldLastPosition(event.getFrom());
			// Regions
			for (Region region : plugin.regionList) {
				if (region.getLeaveMessage() != null && plugin.isInRegion(region, event.getFrom()) && plugin.isInRegion(region, event.getTo()) == false) {
					event.getPlayer().sendMessage(region.getLeaveMessage());
				} else if (plugin.isInRegion(region, event.getTo())) {
					if (region.getWelcomeMessage() != null && plugin.isInRegion(region, event.getFrom()) == false) event.getPlayer().sendMessage(region.getWelcomeMessage());
					if (region.getWarp() != null) {
						event.getPlayer().teleport(plugin.warpList.get(region.getWarp()));
						break;
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			event.getPlayer().sendMessage("cFailed to teleport");
			event.setCancelled(true);
		}
	}
	
	/**
	 * Called when a player changes world
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onPlayerWorldChange(PlayerChangedWorldEvent event) {
		Player player = event.getPlayer();
		if (plugin.isInSurvival(player) && !plugin.isInSurvival(event.getFrom().getName())) {
			player.setGameMode(GameMode.SURVIVAL);
			plugin.setCreativeInventory(player);
			plugin.getSurvivalInventory(player);
			ExperienceManager exp = new ExperienceManager(player);
			exp.setExp(plugin.getProfile(player).survivalXP);
			player.sendMessage("7Welcome to the survival world");
		} else if ((!plugin.isInSurvival(player) && !plugin.isInAdventure(player)) && (plugin.isInSurvival(event.getFrom().getName()) || plugin.isInAdventure(event.getFrom().getName()))) {
			plugin.setSurvivalInventory(player);
			plugin.getCreativeInventory(player);
			player.setGameMode(GameMode.CREATIVE);
			ExperienceManager exp = new ExperienceManager(player);
			plugin.getProfile(player).survivalXP = exp.getCurrentExp();
			exp.setExp(0);
			if (player.getWorld().getName().equals("FlatLand")) {
				player.sendMessage("7Welcome to the flat lands");
			} else if (player.getWorld().getName().equals("SpaceLand")) {
				player.sendMessage("7Welcome to the space lands");
			}
		} else if (plugin.isInAdventure(player)) {
			ExperienceManager exp = new ExperienceManager(player);
			player.setGameMode(GameMode.ADVENTURE);
			player.getInventory().clear();
			exp.setExp(0);
			player.sendMessage("7Welcome to the adventure lands");
		}
		// Statistics
		plugin.statistics.setProperty(player.getWorld().getName() + " times visited", Long.valueOf(plugin.statistics.getProperty(player.getWorld().getName() + " times visited")) + 1);
	}
	
	/**
	 * Called when a player has their game mode changed
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onPlayerGameModeChange(PlayerGameModeChangeEvent event) {
		if (plugin.getProfile(event.getPlayer()).rank == Rank.ServerHost) return;
		if ((event.getNewGameMode() != GameMode.SURVIVAL && plugin.isInSurvival(event.getPlayer())) || (event.getNewGameMode() != GameMode.ADVENTURE && plugin.isInAdventure(event.getPlayer()))) event.setCancelled(true);
	}
	
	/**
	 * Called when a block is dispensed
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onBlockDispense(BlockDispenseEvent event) {
		if (event.getItem().getType() == Material.WATER_BUCKET || event.getItem().getType() == Material.LAVA_BUCKET) event.setCancelled(true);
	}

	/**
	 * Called when a block is ignited
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onBlockIgnite(BlockIgniteEvent event) {
		if (event.getCause() != BlockIgniteEvent.IgniteCause.FLINT_AND_STEEL) event.setCancelled(true);
	}
	
	/**
	 * Called when a block is formed
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onBlockForm(BlockFormEvent event) {
		if (event.getNewState().getType() == Material.SNOW && plugin.isInSurvival(event.getBlock().getWorld().getName()) == false) event.setCancelled(true);
	}
	
	/**
	 * Called when a block is broken
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onBlockBreak(BlockBreakEvent event) {
		Block block = event.getBlock();
		Player player = event.getPlayer();
		if (plugin.isInSurvival(event.getPlayer()) && event.getPlayer().getItemInHand().getType() == Material.STICK && event.getPlayer().getItemInHand().getItemMeta().getLore() != null && event.getPlayer().getItemInHand().getItemMeta().getLore().get(0).equals("Preforms ancient magical arts")) {
			event.setCancelled(true);
			return;
		}
		if (plugin.getProfile(player).rank.isAdmin()) {
			if (plugin.isInSurvival(player.getWorld().getName()) == false || plugin.getProfile(player).rank == Rank.ServerHost) {
				if (event.getPlayer().getItemInHand().getType() == Material.GOLD_SPADE) {
					plugin.getProfile(player).actionLocationA = block.getLocation();
					player.sendMessage("7First point selected (" + block.getX() + ", " + block.getY() + ", " + block.getZ() + ")");
					event.setCancelled(true);
					return;
				}
			}
		}
		// Regions
		if (plugin.isInProtectedRegion(block.getLocation(), player) == true) {
			player.sendMessage("cYou don't have permission to build here");
			event.setCancelled(true);
			return;
		}
		//
		if (plugin.isInSurvival(player) && (block.getType() == Material.DISPENSER || block.getType() == Material.CHEST || block.getType() == Material.WORKBENCH || block.getType() == Material.FURNACE || block.getType() == Material.BURNING_FURNACE || block.getType() == Material.BREWING_STAND || block.getType() == Material.ANVIL || block.getType() == Material.TRAPPED_CHEST || block.getType() == Material.DROPPER)) {
			if (plugin.isContainerProtected(block.getLocation(), player)) {
				player.sendMessage(ChatColor.GRAY + "You don't have permission to break the " + plugin.blockList.get(block.getType()).get(0).toLowerCase());
				event.setCancelled(true);
				return;
			}
			plugin.unprotectContainer(event.getBlock().getLocation());
			player.sendMessage(ChatColor.GRAY + plugin.blockList.get(block.getType()).get(0) + " protection removed");
		}
		if (block.getType() == Material.SIGN_POST || block.getType() == Material.WALL_SIGN) {
			File timeSignFile = new File("plugins/EvilBook/Dynamic Signs/" + block.getWorld().getName() + block.getLocation().getBlockX() + block.getLocation().getBlockY() + block.getLocation().getBlockZ() + ".db");
			if (timeSignFile.exists()) timeSignFile.delete();
		}
		// Statistics
		plugin.statistics.setProperty(player.getWorld().getName() + " blocks broken", Long.valueOf(plugin.statistics.getProperty(player.getWorld().getName() + " blocks broken")) + 1);
	}
	
	/**
	 * Called when a block is placed
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onBlockPlace(BlockPlaceEvent event) {
		Player player = event.getPlayer();
		Block block = event.getBlock();
		if (plugin.getProfile(player).rank.getID() < Rank.AdvancedBuilder.getID() && (block.getType() == Material.ANVIL || block.getType() == Material.SAPLING || block.getType() == Material.SAND || block.getType() == Material.GRAVEL || block.getType() == Material.VINE)) {
			player.sendMessage("dThis block requires 5Advanced Builder drank or higher");
			event.setCancelled(true);
			return;
		}
		if (plugin.getProfile(player).rank.isAdmin() == false && (block.getType() == Material.WATER || block.getType() == Material.STATIONARY_WATER || block.getType() == Material.LAVA || block.getType() == Material.STATIONARY_LAVA || block.getType() == Material.TNT || block.getType() == Material.FIRE || block.getType() == Material.MOB_SPAWNER || block.getType() == Material.ICE || block.getType() == Material.PORTAL || block.getType() == Material.DRAGON_EGG)) {
			player.sendMessage("dThis block is 5Admin donly");
			player.sendMessage("dPlease type 6/admin dto learn how to become admin");
			event.setCancelled(true);
			return;
		}
		// Regions
		if (plugin.isInProtectedRegion(event.getBlock().getLocation(), player) == true) {
			player.sendMessage("cYou don't have permission to build here");
			event.setCancelled(true);
			return;
		}
		//
		if (plugin.isInSurvival(player) && (block.getType() == Material.DISPENSER || block.getType() == Material.CHEST || block.getType() == Material.WORKBENCH || block.getType() == Material.FURNACE || block.getType() == Material.BURNING_FURNACE || block.getType() == Material.BREWING_STAND || block.getType() == Material.ANVIL || block.getType() == Material.TRAPPED_CHEST || block.getType() == Material.DROPPER)) {
			plugin.protectContainer(event.getBlock().getLocation(), player);
			player.sendMessage(ChatColor.GRAY + plugin.blockList.get(event.getBlock().getType()).get(0) + " protected");
		}
		// Statistics
		plugin.statistics.setProperty(player.getWorld().getName() + " blocks placed", Long.valueOf(plugin.statistics.getProperty(player.getWorld().getName() + " blocks placed")) + 1);
	}
	
	/**
	 * Called when a sign is changed by a player
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onSignChange(SignChangeEvent e) {
		if (e.getLines().length == 0) return;
		for (int i = 0; i < 4; i++) e.setLine(i, plugin.toFormattedString(e.getLine(i)));
		if (e.getLine(0).toLowerCase().contains("[time]") || e.getLine(1).toLowerCase().contains("[time]") || e.getLine(2).toLowerCase().contains("[time]") || e.getLine(3).toLowerCase().contains("[time]") ||
				e.getLine(0).toLowerCase().contains("[weather]") || e.getLine(1).toLowerCase().contains("[weather]") || e.getLine(2).toLowerCase().contains("[weather]") || e.getLine(3).toLowerCase().contains("[weather]") ||
				e.getLine(0).toLowerCase().contains("[online]") || e.getLine(1).toLowerCase().contains("[online]") || e.getLine(2).toLowerCase().contains("[online]") || e.getLine(3).toLowerCase().contains("[online]")) {
			String[] text = new String[4];
			text[0] = plugin.replaceAllIgnoreCase(e.getLine(0), "[Time]", "[time]");
			text[1] = plugin.replaceAllIgnoreCase(e.getLine(1), "[Time]", "[time]");
			text[2] = plugin.replaceAllIgnoreCase(e.getLine(2), "[Time]", "[time]");
			text[3] = plugin.replaceAllIgnoreCase(e.getLine(3), "[Time]", "[time]");
			text[0] = plugin.replaceAllIgnoreCase(text[0], "[Weather]", "[weather]");
			text[1] = plugin.replaceAllIgnoreCase(text[1], "[Weather]", "[weather]");
			text[2] = plugin.replaceAllIgnoreCase(text[2], "[Weather]", "[weather]");
			text[3] = plugin.replaceAllIgnoreCase(text[3], "[Weather]", "[weather]");
			text[0] = plugin.replaceAllIgnoreCase(text[0], "[Online]", "[online]");
			text[1] = plugin.replaceAllIgnoreCase(text[1], "[Online]", "[online]");
			text[2] = plugin.replaceAllIgnoreCase(text[2], "[Online]", "[online]");
			text[3] = plugin.replaceAllIgnoreCase(text[3], "[Online]", "[online]");
			plugin.dynamicSignList.put(e.getBlock().getLocation(), text);
			try {
				Properties prop = new Properties();
				prop.setProperty("Location", e.getBlock().getLocation().getWorld().getName() + "," + e.getBlock().getLocation().getBlockX() + "," + e.getBlock().getLocation().getBlockY() + "," + e.getBlock().getLocation().getBlockZ());
				prop.setProperty("Text1", text[0]);
				prop.setProperty("Text2", text[1]);
				prop.setProperty("Text3", text[2]);
				prop.setProperty("Text4", text[3]);
				prop.save("plugins/EvilBook/Dynamic Signs/" + e.getBlock().getLocation().getWorld().getName() + e.getBlock().getLocation().getBlockX() + e.getBlock().getLocation().getBlockY() + e.getBlock().getLocation().getBlockZ() + ".db", null);
			} catch (Exception exception) {
				plugin.logSevere("Failed to save dynamic sign database '" + e.getBlock().getLocation().getWorld().getName() + e.getBlock().getLocation().getBlockX() + e.getBlock().getLocation().getBlockY() + e.getBlock().getLocation().getBlockZ() + ".db'");
				exception.printStackTrace();
			}
			String time = plugin.getTime(e.getBlock().getWorld());
			String weather = plugin.getWeather(e.getBlock());
			e.setLine(0, text[0].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
			e.setLine(1, text[1].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
			e.setLine(2, text[2].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
			e.setLine(3, text[3].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
		}
	}
	
	/**
	 * Called when a hanging entity is created
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onHangingPlaceEvent(HangingPlaceEvent event) {
		// Regions
		if (plugin.isInProtectedRegion(event.getBlock().getLocation(), event.getPlayer()) == true) {
			event.getPlayer().sendMessage("cYou don't have permission to build here");
			event.setCancelled(true);
		}
		//
	}
	
	/**
	 * Called when a vehicle moves
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onVehicleMove(VehicleMoveEvent event) {
		if (event.getVehicle().getPassenger() instanceof Player == false) return;
		Player player = (Player) event.getVehicle().getPassenger();
		// Regions
		for (Region region : plugin.regionList) {
			if (region.getLeaveMessage() != null && plugin.isInRegion(region, event.getFrom()) && plugin.isInRegion(region, event.getTo()) == false) {
				player.sendMessage(region.getLeaveMessage());
			} else if (plugin.isInRegion(region, event.getTo())) {
				if (region.getWelcomeMessage() != null && plugin.isInRegion(region, event.getFrom()) == false) player.sendMessage(region.getWelcomeMessage());
				if (region.getWarp() != null) {
					event.getVehicle().remove();
					player.teleport(plugin.warpList.get(region.getWarp()));
					break;
				}
			}
		}
	}
	
	/**
	 * Called when an entity forms a block
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onEntityBlockForm(EntityBlockFormEvent event) {
		if (!plugin.isInSurvival(event.getEntity()) && event.getEntity().getType() == EntityType.SNOWMAN) event.setCancelled(true);
	}
	
	/**
	 * Called when a hanging entity is removed
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onHangingBreak(HangingBreakEvent event) {
		if (plugin.isInAdventure(event.getEntity()) || (!plugin.isInSurvival(event.getEntity()) && event.getCause() == RemoveCause.EXPLOSION)) event.setCancelled(true);
	}
	
	/**
	 * Called when a hanging entity is removed by an entity
	 */
	@EventHandler(priority = EventPriority.HIGHEST)
	public void onHangingBreakByEntity(HangingBreakByEntityEvent event) {
		if (event.getRemover() instanceof Player == false) return;
		// Regions
		if (plugin.isInProtectedRegion(event.getEntity().getLocation(), ((Player) event.getRemover()).getPlayer())) {
			((Player) event.getRemover()).sendMessage("cYou don't have permission to build here");
			event.setCancelled(true);
		}
	}
	
	/**
	 * Called when an entity targets another living entity
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onEntityTargetLivingEntity(EntityTargetLivingEntityEvent event) {
		if (event.getTarget() != null && event.getTarget() instanceof Player && plugin.getProfile(((Player)event.getTarget()).getName()).isAway) event.setCancelled(true);
	}
	
	/**
	 * Called when an entity explodes
	 */
	@EventHandler(priority = EventPriority.HIGH)
	public void onEntityExplode(EntityExplodeEvent event) {
		if (plugin.isInSurvival(event.getEntity()) == false) event.setCancelled(true);
	}
	
	/**
	 * Called when an entity changes a block except players
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onEntityChangeBlock(EntityChangeBlockEvent event) {
		if (plugin.isInSurvival(event.getEntity()) == false && (event.getEntityType() == EntityType.ENDERMAN || event.getEntityType() == EntityType.SILVERFISH)) event.setCancelled(true);
	}
	
	/**
	 * Called when an entity is damaged
	 */
	@EventHandler(priority = EventPriority.NORMAL)
	public void onEntityDamage(EntityDamageEvent event) {
		if (event.getEntity() instanceof Player && plugin.getProfile(((Player)event.getEntity())).isAway) event.setCancelled(true);
	}
	
	/**
	 * Called when a creature is spawned
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onCreatureSpawn(CreatureSpawnEvent event) {
		if (!plugin.isInSurvival(event.getEntity()) && event.getEntityType() == EntityType.SHEEP) ((Sheep)event.getEntity()).setColor(DyeColor.values()[new Random().nextInt(DyeColor.values().length)]);
	}
	
	/**
	 * Called when a vehicle is created
	 */
	@EventHandler(priority = EventPriority.LOW)
	public void onVehicleCreate(VehicleCreateEvent event) {
		if (event.getVehicle().getNearbyEntities(64, 64, 64).size() >= 400) {
			event.getVehicle().remove();
			return;
		}
		if (event.getVehicle() instanceof Boat) {
			Boat boat = (Boat) event.getVehicle();
			boat.setWorkOnLand(true);
		}
	}
}
