package me.evilpeanut;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.logging.Level;
import java.util.logging.Logger;

import org.apache.commons.lang.StringUtils;
import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.OfflinePlayer;
import org.bukkit.SkullType;
import org.bukkit.TreeType;
import org.bukkit.World;
import org.bukkit.World.Environment;
import org.bukkit.WorldCreator;
import org.bukkit.WorldType;
import org.bukkit.block.Biome;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.entity.Tameable;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.BookMeta;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;
import org.bukkit.material.MaterialData;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.util.Vector;

/**
 * @author Reece Aaron Lecrivain
 */
public class EvilBook extends JavaPlugin {
	public Map<String, PlayerProfile> playerProfiles = new HashMap<>();
	public Map<Material, List<String>> blockList = new LinkedHashMap<>();
	public ConcurrentMap<Location, String[]> dynamicSignList = new ConcurrentHashMap<>();
	public List<MarketItemStack> marketInventory = new ArrayList<>();
	public Map<String, Location> warpList = new HashMap<>();
	public Map<String, Byte> commandBlacklist = new HashMap<>();
	public List<String> paidWorldList = new ArrayList<>();
	public List<Region> regionList = new ArrayList<>();
	public Properties statistics;
	public EvilEdit EvilEdit = new EvilEdit(this);

	/**
	 * Called when the plugin is enabled
	 */
	@Override
	public void onEnable() {
		//
		// Register The Event Listener
		//
		PluginManager pluginManager = getServer().getPluginManager();
		pluginManager.registerEvents(new EventListener(this), this);
		//
		// Check the plugin folders and files exist
		//
		File check = new File("plugins/EvilBook");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook'");
		check = new File("plugins/EvilBook/Players");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Players'");
		check = new File("plugins/EvilBook/Regions");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Regions'");
		check = new File("plugins/EvilBook/Dynamic Signs");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Dynamic Signs'");
		check = new File("plugins/EvilBook/SpaceLand Systems");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/SpaceLand Systems'");
		check = new File("plugins/EvilBook/Inventories");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Inventories'");
		check = new File("plugins/EvilBook/Inventories/Creative");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Inventories/Creative'");
		check = new File("plugins/EvilBook/Inventories/Survival");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Inventories/Survival'");
		check = new File("plugins/EvilBook/Private worlds");
		if (check.exists() == false && check.mkdir() == false) logSevere("Failed to create directory 'plugins/EvilBook/Private worlds'");
		check = new File("plugins/EvilBook/Warps.db");
		if (check.exists() == false) try {check.createNewFile();} catch (Exception exception) {logSevere("Failed to create file 'plugins/EvilBook/Warps.db'");}
		check = new File("plugins/EvilBook/ContainerProtection.db");
		if (check.exists() == false) try {check.createNewFile();} catch (Exception exception) {logSevere("Failed to create file 'plugins/EvilBook/ContainerProtection.db'");}
		//
		// Market place inventory
		//
		check = new File("plugins/EvilBook/MarketInventory.db");
		if (check.exists()) {
			try {
				marketInventory = (List<MarketItemStack>) loadObject("plugins/EvilBook/MarketInventory.db");
			} catch (Exception exception) {
				logSevere("Failed to load market inventory 'plugins/EvilBook/MarketInventory.db'");
			}
		}
		//
		// Load the command blacklist
		//
		check = new File("plugins/EvilBook/CommandBlackList.db");
		if (check.exists())
		{
			Properties prop = new Properties(check);
			for (String propName : prop.getPropertyNames()) commandBlacklist.put(propName, Byte.valueOf(prop.getProperty(propName)));
		} else {
			try {
				check.createNewFile();
				Properties prop = new Properties(check);
				prop.setProperty("/createprivateworld", Rank.ServerHost.getID().toString());
				prop.setProperty("/disallownewworld", Rank.ServerHost.getID().toString());
				prop.setProperty("/allownewworld", Rank.ServerHost.getID().toString());
				prop.setProperty("/restart", Rank.ServerHost.getID().toString());
				prop.setProperty("/setall", Rank.ServerHost.getID().toString());
				prop.setProperty("/stop", Rank.ServerHost.getID().toString());
				prop.setProperty("/op", Rank.ServerHost.getID().toString());
				prop.setProperty("/reload", Rank.ServerHost.getID().toString());
				prop.setProperty("/debug", Rank.ServerHost.getID().toString());
				prop.setProperty("/xp", Rank.ServerHost.getID().toString());
				prop.setProperty("/charge", Rank.ServerHost.getID().toString());
				prop.setProperty("/reward", Rank.ServerHost.getID().toString());
				prop.setProperty("/rewardall", Rank.ServerHost.getID().toString());
				prop.setProperty("/makeadmin", Rank.ServerHost.getID().toString());
				prop.setProperty("/kickall", Rank.ServerHost.getID().toString());
				prop.setProperty("/setspawn", Rank.ServerHost.getID().toString());
				prop.setProperty("/demote", Rank.ServerOwner.getID().toString());
				prop.setProperty("/deop", Rank.ServerOwner.getID().toString());
				prop.setProperty("/cleandatabase", Rank.ServerOwner.getID().toString());
				prop.setProperty("/rollback", Rank.ServerOwner.getID().toString());
				prop.setProperty("/toggleredstone", Rank.ServerOwner.getID().toString());
				prop.setProperty("/setrank", Rank.Custom.getID().toString());
				prop.setProperty("/pardon", Rank.RainbowOwner.getID().toString());
				prop.setProperty("/promote", Rank.RainbowOwner.getID().toString());
				prop.setProperty("/broadcast", Rank.Owner.getID().toString());
				prop.setProperty("/say", Rank.Owner.getID().toString());
				prop.setProperty("/vanish", Rank.CoOwner.getID().toString());
				prop.setProperty("/hide", Rank.CoOwner.getID().toString());
				prop.setProperty("/unvanish", Rank.CoOwner.getID().toString());
				prop.setProperty("/show", Rank.CoOwner.getID().toString());
				prop.setProperty("/regen", Rank.Elite.getID().toString());
				prop.setProperty("/copy", Rank.Councillor.getID().toString());
				prop.setProperty("/paste", Rank.Councillor.getID().toString());
				prop.setProperty("/sphere", Rank.SpecialAdmin.getID().toString());
				prop.setProperty("/cspawn", Rank.SpecialAdmin.getID().toString());
				prop.setProperty("/spawncreature", Rank.SpecialAdmin.getID().toString());
				prop.setProperty("/desel", Rank.Admin.getID().toString());
				prop.setProperty("/wand", Rank.Admin.getID().toString());
				prop.setProperty("/drain", Rank.Admin.getID().toString());
				prop.setProperty("/overlay", Rank.Admin.getID().toString());
				prop.setProperty("/walls", Rank.Admin.getID().toString());
				prop.setProperty("/outline", Rank.Admin.getID().toString());
				prop.setProperty("/hollow", Rank.Admin.getID().toString());	
				prop.setProperty("/undo", Rank.Admin.getID().toString());
				prop.setProperty("/fill", Rank.Admin.getID().toString());
				prop.setProperty("/replace", Rank.Admin.getID().toString());
				prop.setProperty("/memstat", Rank.Admin.getID().toString());
				prop.setProperty("/clean", Rank.Admin.getID().toString());
				prop.setProperty("/rreplace", Rank.Admin.getID().toString());
				prop.setProperty("/rfill", Rank.Admin.getID().toString());
				prop.setProperty("/rdel", Rank.Admin.getID().toString());
				prop.setProperty("/rdelete", Rank.Admin.getID().toString());
				prop.setProperty("/del", Rank.Admin.getID().toString());
				prop.setProperty("/delete", Rank.Admin.getID().toString());
				prop.setProperty("/storm", Rank.Admin.getID().toString());
				prop.setProperty("/rain", Rank.Admin.getID().toString());
				prop.setProperty("/sun", Rank.Admin.getID().toString());
				prop.setProperty("/time", Rank.Admin.getID().toString());
				prop.setProperty("/butcher", Rank.Admin.getID().toString());
				prop.setProperty("/tree", Rank.Admin.getID().toString());
				prop.setProperty("/dawn", Rank.Admin.getID().toString());
				prop.setProperty("/day", Rank.Admin.getID().toString());
				prop.setProperty("/dusk", Rank.Admin.getID().toString());
				prop.setProperty("/night", Rank.Admin.getID().toString());
				prop.setProperty("/rename", Rank.Admin.getID().toString());
				prop.setProperty("/tphere", Rank.Admin.getID().toString());
				prop.setProperty("/teleporthere", Rank.Admin.getID().toString());
				prop.setProperty("/region", Rank.Admin.getID().toString());
				prop.setProperty("/log", Rank.Admin.getID().toString());
				prop.setProperty("/buy", Rank.Admin.getID().toString());
				prop.setProperty("/kick", Rank.Moderator.getID().toString());
				prop.setProperty("/sky", Rank.Moderator.getID().toString());
				prop.setProperty("/skyland", Rank.Moderator.getID().toString());
				prop.setProperty("/spaceland", Rank.Architect.getID().toString());
				prop.setProperty("/space", Rank.Architect.getID().toString());
				prop.setProperty("/flatland", Rank.AdvancedBuilder.getID().toString());
				prop.save("Format:\nCommand = Minimum rank required\nRank values:\nBuilder = " + Rank.Builder.getID() + 
						"\nAdvancedBuilder = " + Rank.AdvancedBuilder.getID() + "\nArchitect = " + Rank.Architect.getID() + "\nModerator = " + Rank.Moderator.getID() + 
						"\nPolice = " + Rank.Police.getID() + "\nAdmin = " + Rank.Admin.getID() + "\nSpecialAdmin = " + Rank.SpecialAdmin.getID() + 
						"\nCounciller = " + Rank.Councillor.getID() + "\nElite = " + Rank.Elite.getID() + "\nCoOwner = " + Rank.CoOwner.getID() + 
						"\nOwner = " + Rank.Owner.getID() + "\nRainbowOwner = " + Rank.RainbowOwner.getID() + "\nCustom = " + Rank.Custom.getID() +
						"\nServerOwner = " + Rank.ServerOwner.getID() + "\nServerHost = " + Rank.ServerHost.getID() + "\nDate created:");
				for (String propName : prop.getPropertyNames()) commandBlacklist.put(propName, Byte.valueOf(prop.getProperty(propName)));
			} catch (Exception exception) {
				logSevere("Failed to create command blacklist");
				exception.printStackTrace();
			}
		}
		//
		// Paid World Generator
		//
		for (String world : new File("plugins/EvilBook/Private worlds/").list()) {
			WorldCreator newWorld = new WorldCreator("plugins/EvilBook/Private worlds/" + world);
			if (getPrivateWorldProperty(world, "WorldType").equals("FLAT")) {
				newWorld.type(WorldType.FLAT);
			} else if (getPrivateWorldProperty(world, "WorldType").equals("NETHER")) {
				newWorld.environment(Environment.NETHER);
			} else if (getPrivateWorldProperty(world, "WorldType").equals("LARGE_BIOMES")) {
				newWorld.type(WorldType.LARGE_BIOMES);
			} else if (getPrivateWorldProperty(world, "WorldType").equals("SKY")) {
				newWorld.generator(new SkylandGenerator());
			}
			getServer().createWorld(newWorld);
			paidWorldList.add(world);
		}
		//
		// New World Generator
		//
		WorldCreator newWorld = new WorldCreator("NewAmentrix");
		getServer().createWorld(newWorld);
		//
		// FlatLand Generator
		//
		WorldCreator flatLand = new WorldCreator("FlatLand");
		flatLand.type(WorldType.FLAT);
		getServer().createWorld(flatLand);
		//
		// SpaceLand Generator
		//
		WorldCreator spaceLand = new WorldCreator("SpaceLand");
		spaceLand.generator(new SpaceWorldGenerator(this));
		getServer().createWorld(spaceLand);
		//
		// Survival Generator
		//
		WorldCreator survivalLand = new WorldCreator("SurvivalLand");
		getServer().createWorld(survivalLand);
		//
		// Survival Nether Generator
		//
		WorldCreator survivalLandNether = new WorldCreator("SurvivalLandNether");
		survivalLandNether.environment(Environment.NETHER);
		getServer().createWorld(survivalLandNether);
		//
		// Skyland Generator
		//
		WorldCreator skyLand = new WorldCreator("SkyLand");
		skyLand.generator(new SkylandGenerator());
		getServer().createWorld(skyLand);
		//
		// Adventure Generator
		//
		getServer().createWorld(new WorldCreator("AdventureLand"));
		//
		// Convert player profiles and preform checks
		//
		for (String player : new File("plugins/EvilBook/Players").list()) {
			Properties playerProp = new Properties("plugins/EvilBook/Players/" + player);
			if (Rank.valueOf(playerProp.getProperty("Rank")) == Rank.ServerHost) logWarning(player + " has ServerHost");
		}
		//
		// Load Warps
		//
		Properties warpFile = new Properties("plugins/EvilBook/Warps.db");
		for (Object key : warpFile.getKeySet().toArray()) {
			if (!getServer().getWorlds().contains(getServer().getWorld(warpFile.getProperty((String) key).split(":")[0]))) {
				logInfo("Warp " + (String)key + " ignored: World " + warpFile.getProperty((String) key).split(":")[0] + " is not loaded");
			} else {
				warpList.put((String)key, new Location(getServer().getWorld(warpFile.getProperty((String) key).split(":")[0]), 
						Double.valueOf(warpFile.getProperty((String) key).split(":")[1]),
						Double.valueOf(warpFile.getProperty((String) key).split(":")[2]), 
						Double.valueOf(warpFile.getProperty((String) key).split(":")[3]),
						Float.valueOf(warpFile.getProperty((String) key).split(":")[4]),
						Float.valueOf(warpFile.getProperty((String) key).split(":")[5])));
			}
		}
		//
		// Load regions
		//
		for (String file : new File("plugins/EvilBook/Regions").list()) {
			Properties regionProp = new Properties("plugins/EvilBook/Regions/" + file);
			if (regionProp.getProperty("regionName") != null) {
				regionProp.removeProperty("regionName");
				regionProp.save();
				logInfo("Removed outdated regionName property from " + file.split(".properties")[0]);
			}
			if (regionProp.getProperty("warpName") != null && !warpList.containsKey(regionProp.getProperty("warpName"))) {
				regionProp.removeProperty("warpName");
				regionProp.save();
				logInfo("Removed invalid warp from " + file.split(".properties")[0]);
			}
			if (regionProp.getProperty("worldName") == null || getServer().getWorld(regionProp.getProperty("worldName")) == null) continue;
			Region region = new Region(this, file.split(".properties")[0],
					new Location(getServer().getWorld(regionProp.getProperty("worldName")), Integer.valueOf(regionProp.getProperty("locationA").split(",")[0]), Integer.valueOf(regionProp.getProperty("locationA").split(",")[1]), Integer.valueOf(regionProp.getProperty("locationA").split(",")[2])),
					new Location(getServer().getWorld(regionProp.getProperty("worldName")), Integer.valueOf(regionProp.getProperty("locationB").split(",")[0]), Integer.valueOf(regionProp.getProperty("locationB").split(",")[1]), Integer.valueOf(regionProp.getProperty("locationB").split(",")[2])),
					Boolean.valueOf(regionProp.getProperty("isProtected")),
					regionProp.getProperty("ownerName"),
					regionProp.getProperty("welcomeMessage"),
					regionProp.getProperty("leaveMessage"),
					regionProp.getProperty("allowedPlayers"),
					regionProp.getProperty("warpName")
					);
			regionList.add(region);
		}
		//
		// Load dynamic signs
		//
		for (String dynamicSign : new File("plugins/EvilBook/Dynamic Signs/").list()) {
			Properties propTimeSign = new Properties("plugins/EvilBook/Dynamic Signs/" + dynamicSign);
			String location = propTimeSign.getProperty("Location");
			if (!getServer().getWorlds().contains(getServer().getWorld(location.split(",")[0]))) {
				logInfo("Removed dynamic sign world " + location.split(",")[0] + " is not loaded");
				new File("plugins/EvilBook/Dynamic Signs/" + dynamicSign).delete();
				continue;
			}
			String[] text = {propTimeSign.getProperty("Text1"), propTimeSign.getProperty("Text2"), propTimeSign.getProperty("Text3"), propTimeSign.getProperty("Text4")};
			dynamicSignList.put(new Location(getServer().getWorld(location.split(",")[0]), Double.valueOf(location.split(",")[1]), Double.valueOf(location.split(",")[2]), Double.valueOf(location.split(",")[3])), text);
		}
		//
		// Load Block List
		//
		blockList.put(Material.AIR, Arrays.asList("Air", "Void"));
		blockList.put(Material.STONE, Arrays.asList("Stone", "SmoothStone"));
		blockList.put(Material.GRASS, Arrays.asList("Grass"));
		blockList.put(Material.DIRT, Arrays.asList("Dirt", "Mud", "Ground"));
		blockList.put(Material.COBBLESTONE, Arrays.asList("Cobble Stone", "CobbleStone", "Cobble"));
		blockList.put(Material.WOOD, Arrays.asList("Planks", "WoodPlanks", "WoodenPlanks"));
		blockList.put(Material.SAPLING, Arrays.asList("Sapling", "TreeSapling"));
		blockList.put(Material.BEDROCK, Arrays.asList("BedRock", "Adminium"));
		blockList.put(Material.WATER, Arrays.asList("Water"));
		blockList.put(Material.STATIONARY_WATER, Arrays.asList("Stationary Water", "StationaryWater", "StaticWater", "StillWater"));
		blockList.put(Material.LAVA, Arrays.asList("Lava"));
		blockList.put(Material.STATIONARY_LAVA, Arrays.asList("Stationary Lava", "StationaryLava", "StaticLava", "StillLava"));
		blockList.put(Material.SAND, Arrays.asList("Sand"));
		blockList.put(Material.GRAVEL, Arrays.asList("Gravel"));
		blockList.put(Material.GOLD_ORE, Arrays.asList("Gold Ore", "GoldOre", "Gold"));
		blockList.put(Material.IRON_ORE, Arrays.asList("Iron Ore", "IronOre", "Iron"));
		blockList.put(Material.COAL_ORE, Arrays.asList("Coal Ore", "CoalOre", "Coal"));
		blockList.put(Material.LOG, Arrays.asList("Wood", "Log"));
		blockList.put(Material.LEAVES, Arrays.asList("Leaves"));
		blockList.put(Material.SPONGE, Arrays.asList("Sponge"));
		blockList.put(Material.GLASS, Arrays.asList("Glass", "GlassBlock"));
		blockList.put(Material.LAPIS_ORE, Arrays.asList("Lapis Ore", "LapisOre", "LapisLazuliOre"));
		blockList.put(Material.LAPIS_BLOCK, Arrays.asList("Lapis Block", "LapisBlock", "LapisLazuliBlock"));
		blockList.put(Material.DISPENSER, Arrays.asList("Dispenser", "ItemDispenser"));
		blockList.put(Material.SANDSTONE, Arrays.asList("Sandstone"));
		blockList.put(Material.NOTE_BLOCK, Arrays.asList("Note Block", "NoteBlock"));
		blockList.put(Material.BED_BLOCK, Arrays.asList("Bed"));
		blockList.put(Material.POWERED_RAIL, Arrays.asList("Powered Rail", "PoweredRail", "PowerRail"));
		blockList.put(Material.DETECTOR_RAIL, Arrays.asList("Detector Rail", "DetectorRail", "PressureRail", "PressurePlateRail"));
		blockList.put(Material.PISTON_STICKY_BASE, Arrays.asList("Sticky Piston", "StickyPiston"));
		blockList.put(Material.WEB, Arrays.asList("Cobweb", "Web"));
		blockList.put(Material.LONG_GRASS, Arrays.asList("Tall Grass", "TallGrass"));
		blockList.put(Material.DEAD_BUSH, Arrays.asList("Dead Bush", "DeadBush", "DeadSapling"));
		blockList.put(Material.PISTON_BASE, Arrays.asList("Piston"));
		blockList.put(Material.PISTON_EXTENSION, Arrays.asList("Piston Extension"));
		blockList.put(Material.WOOL, Arrays.asList("Wool"));
		blockList.put(Material.PISTON_MOVING_PIECE, Arrays.asList("Block Moved By Piston"));
		blockList.put(Material.YELLOW_FLOWER, Arrays.asList("Dandelion")); //TODO: This will change when API is updated to 1.7.2
		blockList.put(Material.RED_ROSE, Arrays.asList("Poppy")); //TODO: This will change when API is updated to 1.7.2
		blockList.put(Material.BROWN_MUSHROOM, Arrays.asList("Brown Mushroom", "BrownMushroom", "Mushroom"));
		blockList.put(Material.RED_MUSHROOM, Arrays.asList("Red Mushroom", "RedMushroom"));
		blockList.put(Material.GOLD_BLOCK, Arrays.asList("Gold Block", "GoldBlock"));
		blockList.put(Material.IRON_BLOCK, Arrays.asList("Iron Block", "IronBlock"));
		blockList.put(Material.DOUBLE_STEP, Arrays.asList("Double Slab", "DoubleSlab"));
		blockList.put(Material.STEP, Arrays.asList("Slab"));
		blockList.put(Material.BRICK, Arrays.asList("Brick", "Bricks"));
		blockList.put(Material.TNT, Arrays.asList("TNT", "Dynamite"));
		blockList.put(Material.BOOKSHELF, Arrays.asList("Bookshelf"));
		blockList.put(Material.MOSSY_COBBLESTONE, Arrays.asList("Moss Cobble Stone", "MossStone", "MossyStone", "MossCobble", "MossyCobble", "MossCobbleStone", "MossyCobbleStone"));
		blockList.put(Material.OBSIDIAN, Arrays.asList("Obsidian"));
		blockList.put(Material.TORCH, Arrays.asList("Torch"));
		blockList.put(Material.FIRE, Arrays.asList("Fire"));
		blockList.put(Material.MOB_SPAWNER, Arrays.asList("Spawner", "MonsterSpawner", "MobSpawner"));
		blockList.put(Material.WOOD_STAIRS, Arrays.asList("Oak Wood Stairs", "OakWoodStairs", "WoodStairs", "WoodenStairs"));
		blockList.put(Material.CHEST, Arrays.asList("Chest"));
		blockList.put(Material.REDSTONE_WIRE, Arrays.asList("Redstone Wire", "RedstoneWire", "Wire"));
		blockList.put(Material.DIAMOND_ORE, Arrays.asList("Diamond Ore", "DiamondOre"));
		blockList.put(Material.DIAMOND_BLOCK, Arrays.asList("Diamond Block", "DiamondBlock"));
		blockList.put(Material.WORKBENCH, Arrays.asList("Crafting table", "CraftingTable", "CraftingBench", "Workbench"));
		blockList.put(Material.CROPS, Arrays.asList("Wheat Seed", "WheatSeed", "WheatSeeds"));
		blockList.put(Material.SOIL, Arrays.asList("Farmland", "Soil"));
		blockList.put(Material.FURNACE, Arrays.asList("Furnace"));
		blockList.put(Material.BURNING_FURNACE, Arrays.asList("Burning Furnace", "BurningFurnace"));
		blockList.put(Material.SIGN_POST, Arrays.asList("Sign", "SignPost"));
		blockList.put(Material.WOODEN_DOOR, Arrays.asList("Door", "WoodenDoor", "WoodDoor"));
		blockList.put(Material.LADDER, Arrays.asList("Ladder"));
		blockList.put(Material.RAILS, Arrays.asList("Rail", "Track"));
		blockList.put(Material.COBBLESTONE_STAIRS, Arrays.asList("Cobble Stone Stairs", "CobbleStoneStairs", "CobbleStairs"));
		blockList.put(Material.WALL_SIGN, Arrays.asList("Wall Sign", "WallSign", "WallSignPost"));
		blockList.put(Material.LEVER, Arrays.asList("Lever", "Switch"));
		blockList.put(Material.STONE_PLATE, Arrays.asList("Stone Pressure Plate", "StonePressurePlate", "PressurePlate"));
		blockList.put(Material.IRON_DOOR_BLOCK, Arrays.asList("Iron Door", "IronDoor"));
		blockList.put(Material.WOOD_PLATE, Arrays.asList("Wooden Pressure Plate", "WoodenPressurePlate", "WoodPressurePlate"));
		blockList.put(Material.REDSTONE_ORE, Arrays.asList("Redstone Ore", "RedstoneOre"));
		blockList.put(Material.GLOWING_REDSTONE_ORE, Arrays.asList("Glowing Redstone Ore", "GlowingRedstone", "GlowingRedstoneOre"));
		blockList.put(Material.REDSTONE_TORCH_OFF, Arrays.asList("Off Redstone Torch", "OffRedstoneTorch"));
		blockList.put(Material.REDSTONE_TORCH_ON, Arrays.asList("Redstone Torch", "RedstoneTorch"));
		blockList.put(Material.STONE_BUTTON, Arrays.asList("Stone Button", "StoneButton"));
		blockList.put(Material.SNOW, Arrays.asList("Snow", "Snow Patch", "SnowPatch", "FlatSnow"));
		blockList.put(Material.ICE, Arrays.asList("Ice", "IceBlock"));
		blockList.put(Material.SNOW_BLOCK, Arrays.asList("Snow Block", "SnowBlock"));
		blockList.put(Material.CACTUS, Arrays.asList("Cactus"));
		blockList.put(Material.CLAY, Arrays.asList("Clay", "ClayBlock"));
		blockList.put(Material.SUGAR_CANE_BLOCK, Arrays.asList("Sugar Cane", "SugarCane", "Sugar", "Reed", "Cane"));
		blockList.put(Material.JUKEBOX, Arrays.asList("Jukebox"));
		blockList.put(Material.FENCE, Arrays.asList("Fence"));
		blockList.put(Material.PUMPKIN, Arrays.asList("Pumpkin"));
		blockList.put(Material.NETHERRACK, Arrays.asList("Netherrack"));
		blockList.put(Material.SOUL_SAND, Arrays.asList("Soul Sand", "SoulSand", "SinkingSand"));
		blockList.put(Material.GLOWSTONE, Arrays.asList("Glowstone"));
		blockList.put(Material.PORTAL, Arrays.asList("Portal", "NetherPortal"));
		blockList.put(Material.JACK_O_LANTERN, Arrays.asList("Jack O' Lantern", "JackOLantern", "Lantern", "PumpkinLantern"));
		blockList.put(Material.CAKE_BLOCK, Arrays.asList("Cake", "CakeBlock"));
		blockList.put(Material.DIODE_BLOCK_OFF, Arrays.asList("Redstone Repeater", "RedstoneRepeater", "OffRedstoneRepeater"));
		blockList.put(Material.DIODE_BLOCK_ON, Arrays.asList("On Redstone Repeater"));
		blockList.put(Material.LOCKED_CHEST, Arrays.asList("Stained Glass", "StainedGlass")); //TODO: This will change when API is updated to 1.7.2
		blockList.put(Material.TRAP_DOOR, Arrays.asList("Trap Door", "TrapDoor"));
		blockList.put(Material.MONSTER_EGGS, Arrays.asList("Monster Egg", "MonsterEgg"));
		blockList.put(Material.SMOOTH_BRICK, Arrays.asList("Stone Bricks", "StoneBricks", "StoneBrick"));
		blockList.put(Material.HUGE_MUSHROOM_1, Arrays.asList("Huge Brown Mushroom", "HugeBrownMushroom", "HugeMushroom"));
		blockList.put(Material.HUGE_MUSHROOM_2, Arrays.asList("Huge Red Mushroom", "HugeRedMushroom"));
		blockList.put(Material.IRON_FENCE, Arrays.asList("Iron Bars", "IronBars", "Bars"));
		blockList.put(Material.THIN_GLASS, Arrays.asList("Glass Pane", "GlassPane", "ThinGlass"));
		blockList.put(Material.MELON_BLOCK, Arrays.asList("Melon"));
		blockList.put(Material.PUMPKIN_STEM, Arrays.asList("Pumpkin Stem", "PumpkinStem"));
		blockList.put(Material.MELON_STEM, Arrays.asList("Melon Stem", "MelonStem"));
		blockList.put(Material.VINE, Arrays.asList("Vines", "Vine"));
		blockList.put(Material.FENCE_GATE, Arrays.asList("Fence Gate", "FenceGate", "Gate"));
		blockList.put(Material.BRICK_STAIRS, Arrays.asList("Brick Stairs", "BrickStairs"));
		blockList.put(Material.SMOOTH_STAIRS, Arrays.asList("Stone Brick Stairs", "StoneBrickStairs"));
		blockList.put(Material.MYCEL, Arrays.asList("Mycelium"));
		blockList.put(Material.WATER_LILY, Arrays.asList("LilyPad"));
		blockList.put(Material.NETHER_BRICK, Arrays.asList("Nether Bricks", "NetherBricks", "NetherBrick"));
		blockList.put(Material.NETHER_FENCE, Arrays.asList("Nether Brick Fence", "NetherBrickFence"));
		blockList.put(Material.NETHER_BRICK_STAIRS, Arrays.asList("Nether Brick Stairs", "NetherBrickStairs"));
		blockList.put(Material.NETHER_WARTS, Arrays.asList("Nether Wart", "NetherWart"));
		blockList.put(Material.ENCHANTMENT_TABLE, Arrays.asList("Enchanting Table", "EnchantingTable", "EnchantmentTable"));
		blockList.put(Material.BREWING_STAND, Arrays.asList("Brewing stand", "BrewingStand"));
		blockList.put(Material.CAULDRON, Arrays.asList("Cauldron"));
		blockList.put(Material.ENDER_PORTAL, Arrays.asList("Ender Portal", "Ender Portal", "EndPortal"));
		blockList.put(Material.ENDER_PORTAL_FRAME, Arrays.asList("Ender Portal Frame", "EnderPortalFrame", "EndPortalFrame"));
		blockList.put(Material.ENDER_STONE, Arrays.asList("Ender Stone", "EnderStone", "EndStone"));
		blockList.put(Material.DRAGON_EGG, Arrays.asList("Dragon Egg", "DragonEgg"));
		blockList.put(Material.REDSTONE_LAMP_OFF, Arrays.asList("Redstone Lamp", "RedstoneLamp", "OffRedstoneLamp"));
		blockList.put(Material.REDSTONE_LAMP_ON, Arrays.asList("On Redstone Lamp"));
		blockList.put(Material.WOOD_DOUBLE_STEP, Arrays.asList("Wooden Double Slab", "WoodenDoubleSlab"));
		blockList.put(Material.WOOD_STEP, Arrays.asList("Wooden Slab", "WoodenSlab", "WoodenStep"));
		blockList.put(Material.COCOA, Arrays.asList("Cocoa Plant", "CocoaPlant"));
		blockList.put(Material.SANDSTONE_STAIRS, Arrays.asList("Sandstone Stairs", "SandstoneStairs"));
		blockList.put(Material.EMERALD_ORE, Arrays.asList("Emerald Ore", "EmeraldOre", "Emerald"));
		blockList.put(Material.ENDER_CHEST, Arrays.asList("Ender Chest", "EnderChest"));
		blockList.put(Material.TRIPWIRE_HOOK, Arrays.asList("Tripwire Hook", "TripwireHook"));
		blockList.put(Material.TRIPWIRE, Arrays.asList("Tripwire"));
		blockList.put(Material.EMERALD_BLOCK, Arrays.asList("Emerald Block", "EmeraldBlock"));
		blockList.put(Material.SPRUCE_WOOD_STAIRS, Arrays.asList("Spruce Wood Stairs", "SpruceWoodStairs"));
		blockList.put(Material.BIRCH_WOOD_STAIRS, Arrays.asList("Birch Wood Stairs", "BirchWoodStairs"));
		blockList.put(Material.JUNGLE_WOOD_STAIRS, Arrays.asList("Jungle Wood Stairs", "JungleWoodStairs"));
		blockList.put(Material.COMMAND, Arrays.asList("Command Block", "CommandBlock", "CommandBeacon"));
		blockList.put(Material.BEACON, Arrays.asList("Beacon"));
		blockList.put(Material.COBBLE_WALL, Arrays.asList("Cobble Stone Wall", "CobblestoneWall", "CobbleWall"));
		blockList.put(Material.FLOWER_POT, Arrays.asList("Flower Pot", "FlowerPot", "PlantPot", "Pot"));
		blockList.put(Material.CARROT, Arrays.asList("Carrots"));
		blockList.put(Material.POTATO, Arrays.asList("Potatoes", "Potatos"));
		blockList.put(Material.WOOD_BUTTON, Arrays.asList("Wood Button", "WoodButton", "WoodenButton"));
		blockList.put(Material.SKULL, Arrays.asList("Skull", "Head", "MobHead"));
		blockList.put(Material.ANVIL, Arrays.asList("Anvil"));
		blockList.put(Material.TRAPPED_CHEST, Arrays.asList("Trapped chest", "TrappedChest", "TrapChest", "ChestTrap", "RedstoneChest"));
		blockList.put(Material.GOLD_PLATE, Arrays.asList("Light Weighted Pressure Plate", "LightWeightedPressurePlate", "LightPressurePlate"));
		blockList.put(Material.IRON_PLATE, Arrays.asList("Heavy Weighted Pressure Plate", "HeavyWeightedPressurePlate", "HeavyPressurePlate"));
		blockList.put(Material.REDSTONE_COMPARATOR_OFF, Arrays.asList("Inactive Redstone Comparator", "InactiveRedstoneComparator", "RedstoneComparator", "Comparator"));
		blockList.put(Material.REDSTONE_COMPARATOR_ON, Arrays.asList("Active Redstone Comparator", "ActiveRedstoneComparator", "ActiveComparator"));
		blockList.put(Material.DAYLIGHT_DETECTOR, Arrays.asList("Daylight Sensor", "DaylightSensor", "LightSensor", "SolarPanel"));
		blockList.put(Material.REDSTONE_BLOCK, Arrays.asList("Block Of Redstone", "BlockOfRedstone", "RedstoneBlock"));
		blockList.put(Material.QUARTZ_ORE, Arrays.asList("Nether Quartz Ore", "NetherQuartzOre", "QuartzOre", "NetherOre"));
		blockList.put(Material.HOPPER, Arrays.asList("Hopper"));
		blockList.put(Material.QUARTZ_BLOCK, Arrays.asList("Block of Quartz", "BlockofQuartz", "QuartzBlock"));
		blockList.put(Material.QUARTZ_STAIRS, Arrays.asList("Quartz Stairs", "QuartzStairs"));
		blockList.put(Material.ACTIVATOR_RAIL, Arrays.asList("Activator Rail", "ActivatorRail"));
		blockList.put(Material.DROPPER, Arrays.asList("Dropper"));
		blockList.put(Material.STAINED_CLAY, Arrays.asList("Stained Clay", "StainedClay"));
		blockList.put(Material.HAY_BLOCK, Arrays.asList("Hay Block", "Hay", "HayBlock"));
		blockList.put(Material.CARPET, Arrays.asList("Carpet"));
		blockList.put(Material.HARD_CLAY, Arrays.asList("Hardened Clay", "HardClay", "HardenedClay"));
		blockList.put(Material.COAL_BLOCK, Arrays.asList("Block of Coal", "CoalBlock", "BlockofCoal"));
		//TODO: Add 1.7.2 ITEMS and blocks when API is updated
		//
		// Statistics
		//
		if (!new File("plugins/EvilBook/Statistics.db").exists()) {
			statistics = new Properties();
			statistics.setProperty("Total logins", (long) 0);
			statistics.setProperty("Messages sent", (long) 0);
			statistics.setProperty("Commands executed", (long) 0);
			for (World world : getServer().getWorlds()) {
				statistics.setProperty(world.getName() + " blocks broken", (long) 0);
				statistics.setProperty(world.getName() + " blocks placed", (long) 0);
				statistics.setProperty(world.getName() + " times visited", (long) 0);
			}
			statistics.save("plugins/EvilBook/Statistics.db", null);
		} else {
			statistics = new Properties("plugins/EvilBook/Statistics.db");
			for (World world : getServer().getWorlds()) {
				if (statistics.getProperty(world.getName() + " blocks broken") == null) statistics.setProperty(world.getName() + " blocks broken", (long) 0);
				if (statistics.getProperty(world.getName() + " blocks placed") == null) statistics.setProperty(world.getName() + " blocks placed", (long) 0);
				if (statistics.getProperty(world.getName() + " times visited") == null) statistics.setProperty(world.getName() + " times visited", (long) 0);
			}
		}
		//
		// Scheduler
		//
		Scheduler scheduler = new Scheduler(this);
		scheduler.TipsAutosave();
		scheduler.UpdateDynamicSigns();
	}

	/**
	 * Called when the plugin is disabled
	 */
	@Override
	public void onDisable() {
		// Statistics
		statistics.save();
	}

	/**
	 * Called when a command is executed
	 */
	@Override
	public boolean onCommand(CommandSender sender, Command command, String commandLabel, String[] args) {
		// TODO: Add some honeypot stuff
		// TODO: Add protection for vehicle spam
		// TODO: Add skylands survival world
		// TODO: Add message to player showing unlocks on rankup
		// TODO: Improve help system
		// TODO: Add mail system
		// TODO: Add customization for block blacklist
		// TODO: Add questing system, mobs that talk and give quests, sendBlockChange to show route of quest by a line of wool, mabey an adventure questing world?
		// TODO: Improve book given on join
		// TODO: Add more sign commands
		// TODO: Add projectile protection
		// TODO: Switch MySQL to H2
		// TODO: Make EvilEdit work in survival if the player has the needed blocks
		// TODO: Fix books not saving in survival properly
		// TODO: Rotate command to rotate an area of blocks / copied blocks for evil edit
		// TODO: Add the ability to right click a sign you own and edit it
		// TODO: Achievements to earn special rewards
		// TODO: EvilEdit to use in-command schedulers
		// TODO: Add /walk to change walk speed
		//
		// Statistics
		//
		statistics.setProperty("Commands executed", Long.valueOf(statistics.getProperty("Commands executed")) + 1);
		//
		// Statistics Command
		//
		if (command.getName().equalsIgnoreCase("statistics")) {
			if (args.length == 1) {
				OfflinePlayer statPlayer = getServer().getOfflinePlayer(args[0]);
				if (statPlayer.hasPlayedBefore()) {
					sender.sendMessage("§5Statistics for player " + statPlayer.getName());
					sender.sendMessage("§dFirst played on " + new SimpleDateFormat("dd-MM-yyyy").format(new Date(statPlayer.getFirstPlayed())));
					sender.sendMessage("§dLast played on " + new SimpleDateFormat("dd-MM-yyyy").format(new Date(statPlayer.getLastPlayed())));
				} else {
					sender.sendMessage("§7Statistics for this player weren't found");
				}
			} else {
				sender.sendMessage("§5Statistics since 09/11/13");
				List<String> stats = new ArrayList(statistics.getKeySet());
				Collections.sort(stats);
				for (String stat : stats) {
					sender.sendMessage("§d" + (stat.contains("plugins/EvilBook/Private worlds/") ? stat.split("plugins/EvilBook/Private\\ worlds/")[1] : stat) + " = " + statistics.getProperty(stat));
				}
			}
			return true;
		}
		//
		// Set All Command
		//
		if (command.getName().equalsIgnoreCase("setall")) {
			if (args.length == 2) {
				if (sender.getName().equals("EvilPeanut")) {
					for (Player p : getServer().getOnlinePlayers()) p.kickPlayer("§cUpdated your player profile");
					for (String player : new File("plugins/EvilBook/Players").list()) {
						Properties playerProp = new Properties("plugins/EvilBook/Players/" + player);
						playerProp.setProperty(args[0], args[1]);
						playerProp.save();
					}
				} else {
					sender.sendMessage("§cThis command is blocked for security reasons");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/setall [property] [value]");
			}
			return true;
		}
		//
		// View Money Balance Command
		//
		if (command.getName().equalsIgnoreCase("money") || command.getName().equalsIgnoreCase("balance") || command.getName().equalsIgnoreCase("bal")) {
			if (args.length == 0 && sender instanceof Player) {
				sender.sendMessage("§5Your account balance is §d$" + getProfile(sender).getMoney());
			} else if (args.length == 1) {
				if (isProfileExistant(args[0])) {
					if (getPlayer(args[0]) != null) {
						sender.sendMessage("§5" + getPlayer(args[0]).getDisplayName() + "'s account balance is §d$" + getProfile(args[0]).getMoney());
					} else {
						sender.sendMessage("§5" + getServer().getOfflinePlayer(args[0]).getName() + "'s account balance is §d$" + getOfflineProperty(args[0], "Money"));
					}
				} else {
					sender.sendMessage("§7You can't view a player's account balance who doesn't exist");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				if (command.getName().equalsIgnoreCase("money")) sender.sendMessage("§d/money <player>");
				if (command.getName().equalsIgnoreCase("balance")) sender.sendMessage("§d/balance <player>");
				if (command.getName().equalsIgnoreCase("bal")) sender.sendMessage("§d/bal <player>");
			}
			return true;
		}
		//
		// Charge Player Money Command
		//
		if (command.getName().equalsIgnoreCase("charge")) {
			if (args.length == 2) {
				if (isInteger(args[1]) && Integer.valueOf(args[1]) > 0) {
					if (isProfileExistant(args[0])) {
						if (getPlayer(args[0]) != null) {
							getPlayer(args[0]).sendMessage("§cYou have been charged $" + args[1]);
							getProfile(args[0]).chargeMoney(Integer.valueOf(args[1]));
						} else {
							setOfflineProperty(args[0], "Money", Integer.toString(Integer.valueOf(getOfflineProperty(args[0], "Money")) - Integer.valueOf(args[1])));
						}
						sender.sendMessage("§7Money charged from " + getServer().getOfflinePlayer(args[0]).getName());
					} else {
						sender.sendMessage("§7You can't charge a player's account balance who doesn't exist");
					}
				} else {
					sender.sendMessage("§7Please enter a valid amount of money to charge");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/charge [player] [amount]");
			}
			return true;
		}
		//
		// Reward Player Money Command
		//
		if (command.getName().equalsIgnoreCase("reward")) {
			if (args.length == 2) {
				if (isInteger(args[1]) && Integer.valueOf(args[1]) > 0) {
					if (isProfileExistant(args[0])) {
						if (getPlayer(args[0]) != null) {
							getPlayer(args[0]).sendMessage("§aYou have been rewarded $" + args[1]);
							getProfile(args[0]).addMoney(Integer.valueOf(args[1]));
						} else {
							setOfflineProperty(args[0], "Money", Integer.toString(Integer.valueOf(getOfflineProperty(args[0], "Money")) + Integer.valueOf(args[1])));
						}
						sender.sendMessage("§7Money rewarded to " + getServer().getOfflinePlayer(args[0]).getName());
					} else {
						sender.sendMessage("§7You can't fund a player's account balance who doesn't exist");
					}
				} else {
					sender.sendMessage("§7Please enter a valid amount of money to reward");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/reward [player] [amount]");
			}
			return true;
		}
		//
		// Reward Online Players Money Command
		//
		if (command.getName().equalsIgnoreCase("rewardall")) {
			if (args.length == 1) {
				if (isInteger(args[0]) && Integer.valueOf(args[0]) > 0) {
					for (Player player : getServer().getOnlinePlayers()) {
						getProfile(player).addMoney(Integer.valueOf(args[0]));
						player.sendMessage("§aYou have been rewarded $" + args[0]);
					}
					sender.sendMessage("§7$" + args[0] + " rewarded to all online players");
				} else {
					sender.sendMessage("§7Please enter a valid amount of money to reward");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/rewardall [amount]");
			}
			return true;
		}
		//
		// Make Admin Command
		//
		if (command.getName().equalsIgnoreCase("makeadmin")) {
			if (args.length == 1) {
				if (isProfileExistant(args[0])) {
					if (getPlayer(args[0]) != null) {
						getProfile(args[0]).rank = Rank.Admin;
						getProfile(args[0]).updatePlayerListName(getPlayer(args[0]));
						broadcastPlayerMessage(getPlayer(args[0]).getName(), "§c" + getPlayer(args[0]).getDisplayName() + " §dhas been promoted to Admin rank");
					} else {
						setOfflineProperty(args[0], "Rank", "Admin");
						broadcastPlayerMessage(getServer().getOfflinePlayer(args[0]).getName(), "§c" + getServer().getOfflinePlayer(args[0]).getName() + " §dhas been promoted to Admin rank");
					}
					getServer().getOfflinePlayer(args[0]).setOp(true);
				} else {
					sender.sendMessage("§7You can't give admin rank to a player who doesn't exist");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/makeadmin [player]");
			}
			return true;
		}
		//
		// Stop Command
		//
		if (command.getName().equalsIgnoreCase("stop")) {
			String message = StringUtils.join(args, " ");
			for (Player p : getServer().getOnlinePlayers()) {
				getProfile(p).saveProfile();
				p.kickPlayer(message);
			}
			getServer().shutdown();
			return true;
		}
		//
		// List Command
		//
		if (command.getName().equalsIgnoreCase("list")) {
			sender.sendMessage(getServer().getOnlinePlayers().length == 0 ? "§dThere are no online players" : "§5" + getServer().getOnlinePlayers().length + (getServer().getOnlinePlayers().length > 1 ? " §dOnline players" : " §dOnline player"));
			for (Player p : getServer().getOnlinePlayers()) sender.sendMessage("  " + (getProfile(p.getName()).nameAlias == null ? p.getDisplayName() : p.getDisplayName() + " §7(" + p.getName() + ")"));
			return true;
		}
		//
		// Memstat Command
		//
		if (command.getName().equalsIgnoreCase("memstat")) {
			sender.sendMessage("§dTotal memory §5" + Runtime.getRuntime().maxMemory() / 1048576 + "MB");
			int freePercentage = (int) Math.round((double)(Runtime.getRuntime().freeMemory()) / (double)(Runtime.getRuntime().maxMemory()) * 100);
			sender.sendMessage("§dUsed memory " + ((100 - freePercentage) > 90 ? "§c" : "§a") + ((Runtime.getRuntime().maxMemory() / 1048576) - (Runtime.getRuntime().freeMemory() / 1048576)) + "MB §e(" + (100 - freePercentage) + "%)");
			sender.sendMessage("§dFree memory " + (freePercentage > 10 ? "§a" : "§c") + Runtime.getRuntime().freeMemory() / 1048576 + "MB §e(" + freePercentage + "%)");
			return true;
		}
		//
		// Demote Command
		//
		if (command.getName().equalsIgnoreCase("demote")) {
			if (args.length == 1) {
				if (isProfileExistant(args[0])) {
					if (getPlayer(args[0]) != null) {
						getProfile(args[0]).rank = Rank.getPreviousRank(getProfile(args[0]).rank);
						if (getProfile(args[0]).rank.getID() == Rank.Admin.getID() - 1) getServer().getOfflinePlayer(args[0]).setOp(false);
						getProfile(args[0]).updatePlayerListName(getPlayer(args[0]));
						getPlayer(args[0]).sendMessage("§7You have been demoted to " + getProfile(args[0]).rank + " rank");
						sender.sendMessage("§7" + getPlayer(args[0]).getDisplayName() + " has been demoted to " + getProfile(args[0]).rank + " rank");
					} else {
						if (Rank.getPreviousRank(Rank.valueOf(getOfflineProperty(args[0], "Rank"))).getID() == Rank.Admin.getID() - 1) getServer().getOfflinePlayer(args[0]).setOp(false);
						setOfflineProperty(args[0], "Rank", Rank.getPreviousRank(Rank.valueOf(getOfflineProperty(args[0], "Rank"))).toString());
						sender.sendMessage("§7" + getServer().getOfflinePlayer(args[0]).getName() + " has been demoted to " + Rank.valueOf(getOfflineProperty(args[0], "Rank")).getName() + " rank");
					}
				} else {
					sender.sendMessage("§7You can't demote a player who doesn't exist");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/demote [player]");
			}
			return true;
		}
		//
		// Promote Command
		//
		if (command.getName().equalsIgnoreCase("promote")) {
			if (args.length == 1) {
				if (isProfileExistant(args[0])) {
					if (getPlayer(args[0]) != null) {
						if (sender instanceof Player && Rank.getNextRank(getProfile(args[0]).rank).getID() > Rank.Moderator.getID() && getProfile(sender).rank.getID() == Rank.Custom.getID()) {
							sender.sendMessage("§7You can't promote a player to above moderator");
						} else if (sender instanceof Player && Rank.getNextRank(getProfile(args[0]).rank).getID() > Rank.Architect.getID() && getProfile(sender).rank.getID() < Rank.Custom.getID()) {
							sender.sendMessage("§7You can't promote a player to above architect");
						} else if (sender instanceof Player && Rank.getNextRank(getProfile(args[0]).rank).getID() == Rank.ServerHost.getID() && getProfile(sender).rank.getID() != Rank.ServerHost.getID()) {
							sender.sendMessage("§7You can't promote a player to serverhost");
						} else {
							getProfile(args[0]).rank = Rank.getNextRank(getProfile(args[0]).rank);
							if (getProfile(args[0]).rank.getID() == Rank.Admin.getID()) getServer().getOfflinePlayer(args[0]).setOp(true);
							getProfile(args[0]).updatePlayerListName(getPlayer(args[0]));
							broadcastPlayerMessage(getPlayer(args[0]).getName(), "§c" + getPlayer(args[0]).getDisplayName() + " §dhas been promoted to " + getProfile(args[0]).rank.getName() + " rank");
						}
					} else {
						if (sender instanceof Player && getProfile(sender).rank.getID() < Rank.ServerOwner.getID()) {
							sender.sendMessage("§7You can't promote offline players");
							return true;
						}
						if (Rank.getNextRank(Rank.valueOf(getOfflineProperty(args[0], "Rank"))).getID() == Rank.Admin.getID()) getServer().getOfflinePlayer(args[0]).setOp(true);
						setOfflineProperty(args[0], "Rank", Rank.getNextRank(Rank.valueOf(getOfflineProperty(args[0], "Rank"))).toString());
						broadcastPlayerMessage(getServer().getOfflinePlayer(args[0]).getName(), "§c" + getServer().getOfflinePlayer(args[0]).getName() + " §dhas been promoted to " + Rank.valueOf(getOfflineProperty(args[0], "Rank")).getName() + " rank");
					}
				} else {
					sender.sendMessage("§7You can't promote a player who doesn't exist");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/promote [player]");
			}
			return true;
		}
		//
		// Message Command
		//
		if (command.getName().equalsIgnoreCase("msg")) {
			if (args.length > 1) {
				if (getPlayer(args[0]) != null) {
					String message = "";
					for (String msg : args) if (!(msg == args[0])) message += " " + msg;
					sender.sendMessage("§7To " + getPlayer(args[0]).getDisplayName() + "§7:§f" + message);
					if (sender instanceof Player) {
						getPlayer(args[0]).sendMessage("§7From " + ((Player) sender).getDisplayName() + ":§f" + message);
					} else {
						getPlayer(args[0]).sendMessage("§7From Server:§f" + message);
					}
				} else {
					sender.sendMessage("§7You can't message an offline player");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/msg [player] [message]");
			}
			return true;
		}
		//
		// Broadcast Command
		//
		if (command.getName().equalsIgnoreCase("broadcast") || command.getName().equalsIgnoreCase("say")) {
			if (args.length > 0) {
				broadcastPlayerMessage(sender.getName(), "§d[§5" + (sender.getName().equals("CONSOLE") ? "Server" : sender.getName()) + "§d] " + toFormattedString(StringUtils.join(args, " ")));
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/broadcast [message]");
				sender.sendMessage("§d/say [message]");
			}
			return true;
		}
		//
		// Rules Command
		//
		if (command.getName().equalsIgnoreCase("rules")) {
			sender.sendMessage("§aAmentrix Server Rules");
			sender.sendMessage("§a[§b1§a] §6§lDont §6Greif");
			sender.sendMessage("§a[§b2§a] §6§lDont §6Advertise");
			sender.sendMessage("§a[§b3§a] §6§lDont §6Spam");
			sender.sendMessage("§7Breaking the rules §lwill §7result in a ban");
			sender.sendMessage("§7The server runs §lMcBans §7be warned");
			return true;
		}
		//
		// Ranks Command
		//
		if (command.getName().equalsIgnoreCase("ranks")) {
			if (args.length == 0 || args[0].equals("1")) {
				sender.sendMessage("§dRanks §5- §dPage 1 of 2 §5- §7/ranks <page>");
				sender.sendMessage("  §0[§EBuilder§0] §7Join the server");
				sender.sendMessage("  §0[§5Adv.Builder§0] §7Impress an admin with a creation");
				sender.sendMessage("  §0[§DArchitect§0] §7Further impress an admin with creations");
				sender.sendMessage("  §0[§9Moderator§0] §7Show commitment and help the admins");
				sender.sendMessage("  §0[§3Police§0] §7Further help the admins");
				sender.sendMessage("  §0[§4Admin§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§4SpecAdmin§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §7To purchase a rank please see /admin");
			} else if (args[0].equals("2")) {
				sender.sendMessage("§dRanks §5- §dPage 2 of 2 §5- §7/ranks <page>");
				sender.sendMessage("  §0[§ACounciller§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§CElite§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§6Co-Owner§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§BOwner§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§AO§Bw§Cn§De§Er§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§6CustomRank§0] §7Purchased from the Amentrix website");
				sender.sendMessage("  §0[§BServerOwner§0] §7Purchasable when available");
				sender.sendMessage("  §0[§BServerHost§0] §7EvilPeanut");
				sender.sendMessage("  §7To purchase a rank please see /admin");
			}
			return true;
		}
		//
		// Clean Command
		//
		if (command.getName().equalsIgnoreCase("clean")) {
			int entitiesRemoved = 0;
			for (World w : getServer().getWorlds()) {
				entitiesRemoved += w.getEntities().size();
				for (Entity entity : w.getEntities()) {
					if (entity.getType() == EntityType.PLAYER || entity.getType() == EntityType.PAINTING || entity.getType() == EntityType.FALLING_BLOCK
							|| entity.getType() == EntityType.DROPPED_ITEM || entity.getType() == EntityType.ENDER_SIGNAL || (entity.getType() == EntityType.EXPERIENCE_ORB && isInSurvival(entity))
							|| entity.getType() == EntityType.FISHING_HOOK || entity.getType() == EntityType.ITEM_FRAME || entity.getType() == EntityType.SNOWBALL
							|| entity.getType() == EntityType.PRIMED_TNT || entity.getType() == EntityType.WEATHER || (entity.getType() == EntityType.WOLF && ((Tameable)entity).isTamed())
							|| entity.getType() == EntityType.ENDER_PEARL || entity.getType() == EntityType.ENDER_CRYSTAL || entity.getType() == EntityType.EGG
							|| entity.getType() == EntityType.THROWN_EXP_BOTTLE || entity.getType() == EntityType.SPLASH_POTION) {
						entitiesRemoved--;
					} else {
						entity.remove();
					}
				}
			}
			sender.sendMessage("§dServer clean removed §5" + entitiesRemoved + "§d entities");
			return true;
		}
		//
		// View Colors Command
		//
		if (command.getName().equalsIgnoreCase("colors") || command.getName().equalsIgnoreCase("colours")) {
			if (args.length == 0 || args[0].equals("1")) {
				sender.sendMessage("§dColors §5- §dPage 1 of 2 §5- §7/colors <page>");
				sender.sendMessage("  §0#0 Black");
				sender.sendMessage("  §1#1 Dark Blue");
				sender.sendMessage("  §2#2 Dark Green");
				sender.sendMessage("  §3#3 Dark Aqua");
				sender.sendMessage("  §4#4 Dark Red");
				sender.sendMessage("  §5#5 Dark Purple");
				sender.sendMessage("  §6#6 Gold");
				sender.sendMessage("  §7#7 Gray");
				sender.sendMessage("  §8#8 Dark Grey");
			} else if (args[0].equals("2")) {
				sender.sendMessage("§dColors §5- §dPage 2 of 2 §5- §7/colors <page>");
				sender.sendMessage("  §9#9 Blue");
				sender.sendMessage("  §a#a Green");
				sender.sendMessage("  §b#b Aqua");
				sender.sendMessage("  §c#c Red");
				sender.sendMessage("  §d#d Light Purple");
				sender.sendMessage("  §e#e Yellow");
				sender.sendMessage("  §f#f White");
			}
			return true;
		}
		//
		// Kick Command
		//
		if (command.getName().equalsIgnoreCase("kick")) {
			if (args.length < 2) {
				sender.sendMessage("§7Please provide a player and a reason for the kick");
				sender.sendMessage("§7/kick [player] [reason]");
			} else {
				if (getPlayer(args[0]) != null) {
					String message = "";
					for (String msg : args) if (msg != args[0]) message += msg + " ";
					getPlayer(args[0]).kickPlayer((sender instanceof Player ? ((Player) sender).getDisplayName() : "§4Server") + "§c: " + message);
					alertOwner(sender.getName() + " kicked " + args[0] + " with the message '" + message + "§7'");
				} else {
					sender.sendMessage("§7You can't kick an offline player");
				}
			}
			return true;
		}
		//
		// Kick All Command
		//
		if (command.getName().equalsIgnoreCase("kickall")) {
			if (args.length >= 1) {
				String message = "§c" + StringUtils.join(args, " ");
				for (Player p : getServer().getOnlinePlayers()) p.kickPlayer(message);
			} else {
				for (Player p : getServer().getOnlinePlayers()) p.kickPlayer("§cYou have been kicked from the server");
			}
			return true;
		}
		//-------------------------------------------------------------------------------------------------------------------------------
		// COMMANDS BELOW THIS POINT ARE NOT AVAILABLE VIA CONSOLE
		//-------------------------------------------------------------------------------------------------------------------------------
		//
		// Check to see if the sender is a player
		//
		if (sender instanceof Player == false) {
			logInfo("This command is not supported by the console");
			return true;
		}
		Player player = (Player)sender;
		//
		// World Command
		//
		if (command.getName().equalsIgnoreCase("world")) {
			if (args.length < 1) {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/world [worldName]");
				sender.sendMessage("§d/world invite [worldName] [player]");
				sender.sendMessage("§d/world list");
			} else {
				if (args[0].equalsIgnoreCase("list")) {
					sender.sendMessage("§5Private worlds");
					sender.sendMessage("§d" + paidWorldList);
				} else if (args[0].equalsIgnoreCase("invite") && args.length == 3) {
					if (isProfileExistant(args[2])) {
						if (getPlayer(args[2]) != null) {
							getProfile(args[2]).allowedPrivateWorlds.add(args[1].toLowerCase());
							getPlayer(args[2]).sendMessage("§7You have been granted access to the private world " + args[1]);
							sender.sendMessage(getPlayer(args[2]).getDisplayName() + " has been granted access to the private world " + args[1]);
						} else {
							List<String> allowedPrivateWorlds = Arrays.asList(getOfflineProperty(args[2], "AllowedPrivateWorlds").toLowerCase().split(","));
							allowedPrivateWorlds.add(args[1].toLowerCase());
							setOfflineProperty(args[2], "AllowedPrivateWorlds", StringUtils.join(allowedPrivateWorlds, ","));
							sender.sendMessage(getServer().getOfflinePlayer(args[2]).getName() + " has been granted access to the private world " + args[1]);
						}
					} else {
						sender.sendMessage("§7A player with this name does not exist");
					}
				} else {
					for (String world : paidWorldList) {
						if (world.equalsIgnoreCase(args[0])) {
							if (getPrivateWorldProperty(args[0], "AllowedPlayers").contains(sender.getName()) || getProfile(player).allowedPrivateWorlds.contains(args[0].toLowerCase()) || getProfile(player).rank == Rank.ServerHost) {
								player.teleport(getProfile(player).getWorldLastPosition(getServer().getWorld("plugins/EvilBook/Private worlds/" + args[0]).getName()));
							} else {
								player.sendMessage("§7You don't have access this private world");
							}
							return true;
						}
					}
					sender.sendMessage("§7A world with this name does not exist");
				}
			}
			return true;
		}
		//
		// Create Private World Command
		//
		if (command.getName().equalsIgnoreCase("createprivateworld")) {
			if (args.length != 3) {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/createprivateworld [worldName] normal [ownerName]");
				sender.sendMessage("§d/createprivateworld [worldName] flat [ownerName]");
				sender.sendMessage("§d/createprivateworld [worldName] nether [ownerName]");
				sender.sendMessage("§d/createprivateworld [worldName] largebiome [ownerName]");
				sender.sendMessage("§d/createprivateworld [worldName] sky [ownerName]");
			} else {
				paidWorldList.add(args[0]);
				WorldCreator newWorld = new WorldCreator("plugins/EvilBook/Private worlds/" + args[0]);
				try {
					new File("plugins/EvilBook/Private worlds/" + args[0] + "/Config.properties").createNewFile();
				} catch (Exception e) {
					e.printStackTrace();
				}
				if (args[1].equalsIgnoreCase("flat")) {
					newWorld.type(WorldType.FLAT);
					setPrivateWorldProperty(args[0], "WorldType", "FLAT");
				} else if (args[1].equalsIgnoreCase("nether")) {
					newWorld.environment(Environment.NETHER);
					setPrivateWorldProperty(args[0], "WorldType", "NETHER");
				} else if (args[1].equalsIgnoreCase("largebiome")) {
					newWorld.type(WorldType.LARGE_BIOMES);
					setPrivateWorldProperty(args[0], "WorldType", "LARGE_BIOMES");
				} else if (args[1].equalsIgnoreCase("sky")) {
					newWorld.generator(new SkylandGenerator());
					setPrivateWorldProperty(args[0], "WorldType", "SKY");
				} else {
					setPrivateWorldProperty(args[0], "WorldType", "NORMAL");
				}
				getServer().createWorld(newWorld);
				setPrivateWorldProperty(args[0], "AllowedPlayers", args[2]);
				// TODO: Kinda inefficient
				for (World world : getServer().getWorlds()) {
					if (statistics.getProperty(world.getName() + " blocks broken") == null) statistics.setProperty(world.getName() + " blocks broken", (long) 0);
					if (statistics.getProperty(world.getName() + " blocks placed") == null) statistics.setProperty(world.getName() + " blocks placed", (long) 0);
					if (statistics.getProperty(world.getName() + " times visited") == null) statistics.setProperty(world.getName() + " times visited", (long) 0);
				}
			}
			return true;
		}
		//
		// Allow New World Command
		//
		if (command.getName().equalsIgnoreCase("allownewworld")) {
			if (args.length != 1) {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/allownewworld [player]");
			} else {
				getProfile(player).isAllowedNewWorld = true;
			}
			return true;
		}
		//
		// Allow New World Command
		//
		if (command.getName().equalsIgnoreCase("disallownewworld")) {
			if (args.length != 1) {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/disallownewworld [player]");
			} else {
				getProfile(player).isAllowedNewWorld = false;
			}
			return true;
		}
		//
		// Achievements Command
		//
		if (command.getName().equalsIgnoreCase("achievements")) {
			if (getProfile(player).achievements.size() == 0) {
				sender.sendMessage("§7You don't have any achievements");
			} else {
				//TODO: Implement the following achievements
				//Save $2000 - See onPlayerMoneyChange()
				//Save $5000 - See onPlayerMoneyChange()
				//Save $10000 - See onPlayerMoneyChange()
				//Meet evilpeanut
				//Hit evilpeanut
				//Ride another player
				//Use a dynamic sign command
				//Buy an item off the market in survival
				//Use the helmet command
				//Use the donate command
				//Mine diamond in survival
				//Mine quartzore in survival
				//Mine gold in survival
				//Mine iron in survival
				//Mine coal in survival
				//Mine redstone in survival
				//Mine lapis in survival
				//Mine emerald in survival
				//Kill a ghast in survival
				//Kill another player in survival
				//Kill a wither in survival
				//Kill a zombie pig man in survival
				//Place a chest in survival
				//Place a furnace in survival
			}
			return true;
		}
		//
		// Donate Command
		//
		if (command.getName().equalsIgnoreCase("donate") || command.getName().equalsIgnoreCase("admin")) {
			sender.sendMessage("§5How to purchase a rank or donate to the server");
			sender.sendMessage("§d  1 §5- §dGoto our website at §6http://amentrix.no-ip.org");
			sender.sendMessage("§d  2 §5- §dClick the §6Purchase A Rank §dbanner on the site");
			sender.sendMessage("§d  3 §5- §dSelect the rank you wish to purchase");
			sender.sendMessage("§d  4 §5- §dComplete the transaction and enjoy the rewards");
			sender.sendMessage("§7Purchased ranks allow the use of blocked items and content");
			sender.sendMessage("§7Each higher rank unlocks more content");
			return true;
		}
		//
		// Help Command
		//
		if (command.getName().equalsIgnoreCase("help")) {
			sender.sendMessage("§5For a list of all the commands and tutorials goto our website");
			sender.sendMessage("§dhttp://amentrix.no-ip.org");
			sender.sendMessage("§7You can request admin assistance using the §6/req §7command");
			return true;
		}
		//
		// Kill Player Command
		//
		if (command.getName().equalsIgnoreCase("kill")) {
			if (args.length == 0) {
				player.setHealth(0);
				player.sendMessage("§7You killed yourself");
			} else {
				if (getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
					if (getPlayer(args[0]) != null) {
						getPlayer(args[0]).setHealth(0);
						getPlayer(args[0]).sendMessage("§7You were killed by " + player.getDisplayName());
					} else {
						sender.sendMessage("§7You can't kill an offline player");
					}
				} else {
					sender.sendMessage("§7Server host rank is required to kill another player");
				}
			}
			return true;
		}
		//
		// Slap Command
		//
		if (command.getName().equalsIgnoreCase("slap")) {
			if (args.length == 1) {
				if (getPlayer(args[0]) != null) {
					if (isInSurvival(getPlayer(args[0])) == false) {
						getPlayer(args[0]).setVelocity(new Vector(new Random().nextDouble() * 2.0D - 1.0D, new Random().nextDouble() * 1.0D, new Random().nextDouble() * 2.0D - 1.0D));
						getPlayer(args[0]).sendMessage("§7You have been slapped by " + player.getDisplayName());
						sender.sendMessage("§7You slapped " + getPlayer(args[0]).getDisplayName());
					} else {
						sender.sendMessage("§7You can't slap players in survival");
					}
				} else {
					sender.sendMessage("§7You can't slap an offline player");
				}
			} else if (args.length == 0) {
				player.setVelocity(new Vector(new Random().nextDouble() * 2.0D - 1.0D, new Random().nextDouble() * 1.0D, new Random().nextDouble() * 2.0D - 1.0D));
				sender.sendMessage("§7You slapped yourself");
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/slap <player>");
			}
			return true;
		}
		//
		// Shock Command
		//
		if (command.getName().equalsIgnoreCase("shock")) {
			if (args.length == 1) {
				if (getPlayer(args[0]) != null) {
					if (isInSurvival(getPlayer(args[0])) == false) {
						getPlayer(args[0]).getWorld().strikeLightning(getPlayer(args[0]).getLocation());
						getPlayer(args[0]).sendMessage("§7You have been shocked by " + player.getDisplayName());
						sender.sendMessage("§7You shocked " + getPlayer(args[0]).getDisplayName());
					} else {
						sender.sendMessage("§7You can't shock players in survival");
					}
				} else {
					sender.sendMessage("§7You can't shock an offline player");
				}
			} else if (args.length == 0) {
				player.getWorld().strikeLightning(player.getLocation());
				sender.sendMessage("§7You shocked yourself");
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/shock <player>");
			}
			return true;
		}
		//
		// Rocket Command
		//
		if (command.getName().equalsIgnoreCase("rocket")) {
			if (args.length == 1) {
				if (getPlayer(args[0]) != null) {
					if (isInSurvival(getPlayer(args[0])) == false) {
						getPlayer(args[0]).setVelocity(new Vector(0, 20, 0));
						getPlayer(args[0]).sendMessage("§7You have been rocketed by " + player.getDisplayName());
						sender.sendMessage("§7You rocketed " + getPlayer(args[0]).getDisplayName());
					} else {
						sender.sendMessage("§7You can't rocket players in survival");
					}
				} else {
					sender.sendMessage("§7You can't rocket an offline player");
				}
			} else if (args.length == 0) {
				player.setVelocity(new Vector(0, 20, 0));
				sender.sendMessage("§7You rocketed yourself");
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/rocket <player>");
			}
			return true;
		}
		//
		// Ascend Command
		//
		if (command.getName().equalsIgnoreCase("ascend")) {
			int y = player.getLocation().getBlockY();
			boolean hasReachedSolid = false;
			while (hasReachedSolid == false || player.getWorld().getBlockAt(player.getLocation().getBlockX(), y, player.getLocation().getBlockZ()).getType() != Material.AIR) {
				if (y == player.getWorld().getMaxHeight() + 2) {
					player.sendMessage(ChatColor.GRAY + "There are no valid blocks to ascend to");
					return true;
				}
				if (player.getWorld().getBlockAt(player.getLocation().getBlockX(), y, player.getLocation().getBlockZ()).getType() != Material.AIR) hasReachedSolid = true;
				y++;
			}
			player.sendMessage(ChatColor.GRAY + "Ascended " + (y - player.getLocation().getBlockY()) + " blocks");
			Location freeLocation = player.getLocation();
			freeLocation.setY(y);
			player.teleport(freeLocation);
			return true;
		}
		//
		// Descend Command
		//
		if (command.getName().equalsIgnoreCase("descend")) {
			int y = player.getLocation().getBlockY();
			boolean hasReachedSolid = false;
			while (hasReachedSolid == false || player.getWorld().getBlockAt(player.getLocation().getBlockX(), y, player.getLocation().getBlockZ()).getType() != Material.AIR || player.getWorld().getBlockAt(player.getLocation().getBlockX(), y - 1, player.getLocation().getBlockZ()).getType() == Material.AIR) {
				if (y == 0) {
					player.sendMessage(ChatColor.GRAY + "There are no valid blocks to descend to");
					return true;
				}
				if (player.getWorld().getBlockAt(player.getLocation().getBlockX(), y, player.getLocation().getBlockZ()).getType() != Material.AIR) hasReachedSolid = true;
				y--;
			}
			player.sendMessage(ChatColor.GRAY + "Descended " + (player.getLocation().getBlockY() - y) + " blocks");
			Location freeLocation = player.getLocation();
			freeLocation.setY(y);
			player.teleport(freeLocation);
			return true;
		}
		//
		// Marketplace Command
		//
		if (command.getName().equalsIgnoreCase("market")) {
			if (args.length >= 1) {
				if (args[0].equalsIgnoreCase("sell")) {		
					if (isInSurvival(player)) {
						if (args.length == 2) {
							//TODO: Allow items to be sold on the market place
							if (player.getItemInHand().getType().isBlock() == false) {
								sender.sendMessage("§7Only blocks can be sold on the market place at the moment");
							} else if (player.getItemInHand().getType() == Material.DIRT || player.getItemInHand().getType() == Material.AIR) {
								// TODO: Block other items from being sold on the market place
								sender.sendMessage("§7This item can't be sold on the market place");
							} else if (!isInteger(args[1]) || Integer.valueOf(args[1]) < 1) {
								sender.sendMessage("§7Please enter a valid price to sell the item at");
							} else {
								Map<Integer, Integer> enchantmentList = new HashMap<>();
								// TODO: Re-add support for material data
								for (int i = 0; i < player.getItemInHand().getEnchantments().size(); i++) enchantmentList.put(((Enchantment)player.getItemInHand().getEnchantments().keySet().toArray()[i]).getId(), (Integer)player.getItemInHand().getEnchantments().values().toArray()[i]);
								marketInventory.add(new MarketItemStack(sender.getName(), Integer.valueOf(args[1]), player.getItemInHand().getAmount(), player.getItemInHand().getType(), new MaterialData(player.getItemInHand().getType()), enchantmentList));
								sender.sendMessage("§a" + player.getItemInHand().getAmount() + " items have been put up for sale on the market for $" + args[1] + " each");
								player.getInventory().removeItem(player.getItemInHand());
								//TODO: Make it so a player can sell x amount of the item
								//} else if (args.length == 3) {
								//if (player.getInventory().containsAtLeast(player.getItemInHand(), Integer.valueOf(args[2]))) {
								//Map<Integer, Integer> enchantmentList = new HashMap<Integer, Integer>();
								//for (int i = 0; i < player.getItemInHand().getEnchantments().size(); i++) enchantmentList.put(((Enchantment)player.getItemInHand().getEnchantments().keySet().toArray()[i]).getId(), (Integer)player.getItemInHand().getEnchantments().values().toArray()[i]);
								//marketInventory.add(new MarketItemStack(sender.getName(), Integer.valueOf(args[1]), Integer.valueOf(args[2]), player.getItemInHand().getTypeId(), player.getItemInHand().getData().getData(), enchantmentList));
								//sender.sendMessage("§a" + Integer.valueOf(args[2]) + " items have been put up for sale on the market for $" + args[1] + " each");
								//player.getInventory().removeItem(items,);
								//} else {
								//}
								try {
									saveObject(marketInventory, "plugins/EvilBook/MarketInventory.db");
								} catch (Exception exception) {
									logSevere("Failed to save market inventory");
									exception.printStackTrace();
								}
							}
						} else {
							sender.sendMessage("§5Incorrect command usage");
							sender.sendMessage("§d/market sell [pricePerItem]");
							//sender.sendMessage("§d/market sell [pricePerItem] [amount]");
						}
					} else {
						sender.sendMessage("§7You can only sell items in a survival world");
					}
				} else if (args[0].equalsIgnoreCase("buy")) {
					if (isInSurvival(player)) {
						if (args.length == 2) {
							if (!isInteger(args[1]) || Integer.valueOf(args[1]) >= marketInventory.size()) {
								sender.sendMessage("§7Please enter a valid item code to purchase");
							}
							if (getProfile(sender).getMoney() >= marketInventory.get(Integer.valueOf(args[1])).price) {
								getProfile(sender).chargeMoney(marketInventory.get(Integer.valueOf(args[1])).price);
								Player seller = getPlayer(marketInventory.get(Integer.valueOf(args[1])).seller);
								if (seller != null) {
									getProfile(seller).addMoney(marketInventory.get(Integer.valueOf(args[1])).price);
									seller.sendMessage(player.getDisplayName() + "§a purchased your market item of " + blockList.get(marketInventory.get(Integer.valueOf(args[1])).type).get(0) + " for $" + marketInventory.get(Integer.valueOf(args[1])).price);
								} else {
									String money = getOfflineProperty(marketInventory.get(Integer.valueOf(args[1])).seller, "Money");
									money = Integer.toString(Integer.valueOf(money) + marketInventory.get(Integer.valueOf(args[1])).price);
									setOfflineProperty(marketInventory.get(Integer.valueOf(args[1])).seller, "Money", money);
								}
								sender.sendMessage("§aYou have paid " + getServer().getOfflinePlayer(marketInventory.get(Integer.valueOf(args[1])).seller).getName() + " $" + marketInventory.get(Integer.valueOf(args[1])).price);
								player.getInventory().addItem(marketInventory.get(Integer.valueOf(args[1])).toItemStack(1));
								if (marketInventory.get(Integer.valueOf(args[1])).amount == 1) {
									marketInventory.remove(marketInventory.get(Integer.valueOf(args[1])));
								} else {
									marketInventory.get(Integer.valueOf(args[1])).amount--;
								}
								try {
									saveObject(marketInventory, "plugins/EvilBook/MarketInventory.db");
								} catch (Exception exception) {
									logSevere("Failed to save market inventory");
									exception.printStackTrace();
								}
							} else {
								sender.sendMessage("§5You don't have enough money for this item");
								sender.sendMessage("§dYou need to earn $" + (marketInventory.get(Integer.valueOf(args[1])).price - getProfile(sender).getMoney()));
							}
						} else {
							sender.sendMessage("§5Incorrect command usage");
							sender.sendMessage("§d/market buy [itemCode]");
							//sender.sendMessage("§d/market buy [itemCode] [amount]");
						}
					} else {
						sender.sendMessage("§7You can only purchase items in a survival world");
					}
				} else if (args[0].equalsIgnoreCase("shop")) {
					List<String> marketShopPages = new ArrayList<>();
					marketShopPages.add("§5Amentrix Marketplace\n\n§dThere are " + marketInventory.size() + " items for sale\n\n§7To purchase an item /market buy [itemCode]\n\n§7Please goto the next page to see the items for sale");
					for (int page = 0; page < Math.ceil((double)marketInventory.size() / 3); page++) {
						String pageText = "";
						for (int item = page * 3; item < (page * 3) + 3; item ++) {
							if (item >= marketInventory.size()) continue;
							pageText += "§d$" + marketInventory.get(item).price + " per item \n§5" + marketInventory.get(item).amount + " x " + blockList.get(marketInventory.get(item).type).get(0) + "\n§7Item code: " + item + "\n\n";
						}
						marketShopPages.add(pageText);
					}
					player.getInventory().addItem(getBook("Market Catalogue", "Amentrix", marketShopPages));
				} else if (args[0].equalsIgnoreCase("remove")) {
					if (getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
						marketInventory.remove(marketInventory.get(Integer.valueOf(args[1])));
						sender.sendMessage("§7Removed all items with code " + args[1] + " off the market place");
					}
				} else {
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/market sell [pricePerItem]");
					//sender.sendMessage("§d/market sell [pricePerItem] [amount]");
					sender.sendMessage("§d/market buy [itemCode]");
					sender.sendMessage("§d/market shop");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/market sell [pricePerItem]");
				//sender.sendMessage("§d/market sell [pricePerItem] [amount]");
				sender.sendMessage("§d/market buy [itemCode]");
				sender.sendMessage("§d/market shop");
			}
			return true;
		}
		//
		// Change-log Command
		//
		if (command.getName().equalsIgnoreCase("changelog")) {
			InputStream is = getClass().getResourceAsStream("Changelog.txt");
			Scanner read = new Scanner(is);
			String changeLogBookText = "";
			while (read.hasNextLine()) {
				changeLogBookText += read.nextLine() + "\n";
			}
			read.close();
			player.getInventory().addItem(getBook("EvilBook Change-log", "Amentrix", Arrays.asList(changeLogBookText.split("/p"))));
			return true;
		}
		//
		// Set Rank Command
		//
		if (command.getName().equalsIgnoreCase("setrank")) {
			if (args.length == 1) {
				if (args[0].toLowerCase().contains("serverhost") || args[0].toLowerCase().contains("&k")) {
					sender.sendMessage("§7This rank's name is blocked");
					return true;
				}
				Properties playerProp = new Properties("plugins/EvilBook/Players/" + sender.getName() + ".properties");
				String prefix = args[0].startsWith("&") ? args[0] : "&6" + args[0];
				playerProp.setProperty("CustomRankPrefix", prefix);
				playerProp.save("plugins/EvilBook/Players/" + sender.getName() + ".properties");
				getProfile(sender).customRankColor = prefix.substring(1, 2);
				getProfile(sender).customRankPrefix = "§0[" + prefix.replaceAll("&", "§") + "§0]";
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/setrank [rank]");
			}
			return true;
		}
		//
		// Teleport To New World Command
		//
		if (command.getName().equalsIgnoreCase("newworld")) {
			if (getProfile(player).isAllowedNewWorld) {
				player.teleport(getProfile(player).getWorldLastPosition("NewAmentrix"));
			} else {
				sender.sendMessage("§cYou don't have permission to access the new world");
			}
			return true;
		}
		//
		// Teleport To SpaceLand Command
		//
		if (command.getName().equalsIgnoreCase("spaceland") || command.getName().equalsIgnoreCase("space")) {
			player.teleport(getProfile(sender).getWorldLastPosition("SpaceLand"));
			return true;
		}
		//
		// Teleport To FlatLand Command
		//
		if (command.getName().equalsIgnoreCase("flatland")) {
			player.teleport(getProfile(sender).getWorldLastPosition("FlatLand"));
			return true;
		}
		//
		// Teleport To SkyLand Command
		//
		if (command.getName().equalsIgnoreCase("skyland") || command.getName().equalsIgnoreCase("sky")) {
			player.teleport(getProfile(sender).getWorldLastPosition("SkyLand"));
			return true;
		}
		//
		// Teleport To Adventure Command
		//
		if (command.getName().equalsIgnoreCase("adventure")) {
			player.teleport(getProfile(sender).getWorldLastPosition("AdventureLand"));
			return true;
		}
		//
		// Teleport To Creative Command
		//
		if (command.getName().equalsIgnoreCase("creative")) {
			player.teleport(getProfile(sender).getWorldLastPosition("Amentrix"));
			return true;
		}
		//
		// Teleport To Survival Command
		//
		if (command.getName().equalsIgnoreCase("survival")) {
			player.teleport(getProfile(sender).getWorldLastPosition("SurvivalLand"));
			return true;
		}
		//
		// Set Jump Height Command
		//
		if (command.getName().equalsIgnoreCase("jump")) {
			if (args.length == 1) {
				if (isDouble(args[0]) && Double.valueOf(args[0]) <= 41) {
					getProfile(sender).jumpAmplifier = Double.valueOf(args[0]) / 4;
				} else {
					sender.sendMessage("§7Please enter a valid jump height");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/jump [height]");
			}
			return true;
		}
		//
		// Set Fly Speed Command
		//
		if (command.getName().equalsIgnoreCase("fly")) {
			if (args.length == 1) {
				float flyAmplifier = Float.valueOf(args[0]) / 100;
				if (isInteger(args[0]) && flyAmplifier <= 1) {
					getProfile(sender).flyAmplifier = flyAmplifier < 0.1 ? 0.1f : Float.valueOf(args[0]) / 100;
					player.setFlySpeed(getProfile(sender).flyAmplifier);
				} else {
					sender.sendMessage("§7Please enter a valid fly speed");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/fly [speed]");
			}
			return true;
		}
		//
		// Set Run Speed Command
		//
		if (command.getName().equalsIgnoreCase("run")) {
			if (args.length == 1) {
				if (isInteger(args[0]) && Integer.valueOf(args[0]) <= 127) {
					getProfile(sender).runAmplifier = Integer.valueOf(args[0]);
				} else {
					sender.sendMessage("§7Please enter a valid run speed");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/run [speed]");
			}
			return true;
		}
		//
		// Disguise Command
		//
		if (command.getName().equalsIgnoreCase("disguise")) {
			if (getProfile(sender).rank.getID() < Rank.ServerOwner.getID()) {
				sender.sendMessage("§7Mob disguise can't be used in survival");
			} else {
				if (args.length == 1) {
					EntityType entityType = getEntity(args[0]);
					if (entityType != null) {
						if ((entityType != EntityType.ENDER_DRAGON && entityType != EntityType.WITHER && entityType != EntityType.ENDER_CRYSTAL) || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
							for (Player other : getServer().getOnlinePlayers()) other.hidePlayer(player);
							getProfile(player).disguise = player.getWorld().spawnEntity(player.getLocation(), entityType);
							sender.sendMessage("§7You are now disguised as a " + args[0].toLowerCase());
							alertOwner(sender.getName() + " disguised themselves as a " + args[0].toLowerCase());
						}
					}
				} else {
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/disguise [mobName]");
					sender.sendMessage("§d/disguise [mobID]");
				}
			}
			return true;
		}
		//
		// Name Command
		//
		if (command.getName().equalsIgnoreCase("name")) {
			if (args.length >= 1) {
				if (player.getItemInHand().getType() != Material.AIR) {
					if (args[0].length() > 32) {
						sender.sendMessage("§7The item name is too long");
					} else {
						String name = "";
						for (String arg : args) name += arg + " ";
						if (player.getItemInHand().getType() == Material.SKULL_ITEM) {
							ItemStack skull;
							if (name.trim().equalsIgnoreCase("Creeper")) {
								skull = new ItemStack(Material.SKULL_ITEM, 1, (short)SkullType.CREEPER.ordinal());
							} else if (name.trim().equalsIgnoreCase("Skeleton")) {
								skull = new ItemStack(Material.SKULL_ITEM, 1, (short)SkullType.SKELETON.ordinal());
							} else if (name.trim().equalsIgnoreCase("Wither")) {
								skull = new ItemStack(Material.SKULL_ITEM, 1, (short)SkullType.WITHER.ordinal());
							} else if (name.trim().equalsIgnoreCase("Zombie")) {
								skull = new ItemStack(Material.SKULL_ITEM, 1, (short)SkullType.ZOMBIE.ordinal());
							} else {
								skull = new ItemStack(Material.SKULL_ITEM, 1, (short)SkullType.PLAYER.ordinal());
							}
							SkullMeta skullMeta = (SkullMeta) skull.getItemMeta();
							skullMeta.setOwner(name.trim());
							skullMeta.setDisplayName(name.trim() + "'s Head");
							skull.setItemMeta(skullMeta);
							player.setItemInHand(skull);
						} else {
							ItemMeta meta = player.getItemInHand().getItemMeta();
							meta.setDisplayName(name.trim());
							player.getItemInHand().setItemMeta(meta);
							sender.sendMessage("§7Item renamed to §d" + name.trim());
						}
					}
				} else {
					sender.sendMessage("§7You must be holding an item to rename it");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/name [name]");
			}
			return true;
		}
		//
		// Advertise Command
		//
		if (command.getName().equalsIgnoreCase("advert") || command.getName().equalsIgnoreCase("advertise")) {
			if (args.length > 0) {
				if (getProfile(sender).getMoney() >= 40) {
					String broadcast = "";
					for (String msg : args) broadcast += " " + msg;
					broadcastPlayerMessage(sender.getName(), "§d[§5Advert§d]" + broadcast);
					alertOwner(sender.getName() + " executed the advertise command");
					getProfile(sender).chargeMoney(40);
					sender.sendMessage("§7Created advert §c-$40");
				} else {
					sender.sendMessage("§5You don't have enough money for this item");
					sender.sendMessage("§dYou need to earn $" + (40 - getProfile(sender).getMoney()));
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/advert [message]");
				sender.sendMessage("§d/advertise [message]");
			}
			return true;
		}
		//
		// Rollback Command
		//
		if (command.getName().equalsIgnoreCase("rollback")) {
			sender.sendMessage("§cWe are now using log-block temporarily");
			sender.sendMessage("§7To rollback do /lb rollback player [name] since [time]");
			sender.sendMessage("§7eg. /lb rollback player test since 10d");
			/*
			if (args.length == 1) {
				if (args[0].equalsIgnoreCase("EvilPeanut")) {
					sender.sendMessage("§7This user is protected from rollback");
				} else {
					// TODO: Re-implement
					//rollbackEdits(player, args[0]);
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/rollback [playerName]");
			}
			 */
			return true;
		}
		//
		// Log Command
		//
		if (command.getName().equalsIgnoreCase("log")) {
			sender.sendMessage("§cWe are now using log-block temporarily");
			sender.sendMessage("§7To spawn the tool do /lb tool");
			sender.sendMessage("§7and then use /lb tool <on|off>");
			//TODO: Re-implement
			/*
			if (getProfile(sender).isLogging) {
				getProfile(sender).isLogging = false;
				sender.sendMessage("§7Logging mode disabled");
			} else {
				getProfile(sender).isLogging = true;
				sender.sendMessage("§7Logging mode enabled");
			}
			 */
			return true;
		}
		//
		// Helmet command
		//
		if (command.getName().equalsIgnoreCase("helmet")) {
			if (player.getInventory().getItemInHand().getType() == Material.AIR) {
				sender.sendMessage("§7You can't wear an air helmet");
			} else {
				if (isInSurvival(player)) {
					ItemStack itemHelmet = player.getInventory().getItemInHand();
					if (player.getInventory().getHelmet() != null) {
						player.getInventory().addItem(player.getInventory().getHelmet());
					}
					player.getInventory().setHelmet(player.getInventory().getItemInHand());
					player.getInventory().getHelmet().setAmount(1);
					if (player.getInventory().getItemInHand().getAmount() != 1) {
						player.getInventory().getItemInHand().setAmount(player.getInventory().getItemInHand().getAmount() - 1);
					} else {
						player.getInventory().removeItem(player.getInventory().getItemInHand());
					}
					if (itemHelmet.getType().isBlock() == false) {
						sender.sendMessage("§7You are now wearing a custom helmet");
					} else {
						sender.sendMessage("§7You are now wearing a " + blockList.get(itemHelmet.getType()).get(0) + " helmet");
					}
				} else {
					player.getInventory().setHelmet(player.getInventory().getItemInHand());
					if (player.getInventory().getItemInHand().getType().isBlock() == false) {
						sender.sendMessage("§7You are now wearing a custom helmet");
					} else {
						sender.sendMessage("§7You are now wearing a " + blockList.get(player.getInventory().getItemInHand().getType()).get(0) + " helmet");
					}
				}
			}
			return true;
		}
		//
		// Butter command
		//
		if (command.getName().equalsIgnoreCase("butter")) {
			if (isInSurvival(player)) {
				sender.sendMessage("§7Butter is illegal in survival");
				return true;
			}
			ItemStack butter = new ItemStack(Material.GOLD_INGOT);
			ItemMeta yourItemStackMeta = butter.getItemMeta();
			yourItemStackMeta.setDisplayName("Butter");
			yourItemStackMeta.setLore(Arrays.asList("This butter was made by JacobClark"));
			butter.setItemMeta(yourItemStackMeta);
			butter.setAmount(64);
			player.getInventory().addItem(butter);
			butter = new ItemStack(Material.GOLD_HELMET);
			yourItemStackMeta = butter.getItemMeta();
			yourItemStackMeta.setDisplayName("Butter Helmet");
			yourItemStackMeta.setLore(Arrays.asList("A helmet made by the butter gods"));
			butter.setItemMeta(yourItemStackMeta);
			player.getInventory().setHelmet(butter);
			butter = new ItemStack(Material.GOLD_CHESTPLATE);
			yourItemStackMeta = butter.getItemMeta();
			yourItemStackMeta.setDisplayName("Butter Chestplate");
			yourItemStackMeta.setLore(Arrays.asList("A chestplate made by the butter gods"));
			butter.setItemMeta(yourItemStackMeta);
			player.getInventory().setChestplate(butter);
			butter = new ItemStack(Material.GOLD_LEGGINGS);
			yourItemStackMeta = butter.getItemMeta();
			yourItemStackMeta.setDisplayName("Butter Leggings");
			yourItemStackMeta.setLore(Arrays.asList("Leggings made by the butter gods"));
			butter.setItemMeta(yourItemStackMeta);
			player.getInventory().setLeggings(butter);
			butter = new ItemStack(Material.GOLD_BOOTS);
			yourItemStackMeta = butter.getItemMeta();
			yourItemStackMeta.setDisplayName("Butter Boots");
			yourItemStackMeta.setLore(Arrays.asList("Boots made by the butter gods"));
			butter.setItemMeta(yourItemStackMeta);
			player.getInventory().setBoots(butter);
			sender.sendMessage("§7You have been blessed by the gods of butter");
			return true;
		}
		//
		// Region command
		//
		if (command.getName().equalsIgnoreCase("region")) {
			if (args.length >= 1) {
				if (args[0].equalsIgnoreCase("scan")) {
					for (Region region : regionList) {
						if (isInRegionXRange(region, player.getLocation()) && isInRegionYRange(region, player.getLocation()) && isInRegionZRange(region, player.getLocation())) {
							sender.sendMessage("§7You are in the " + region.getRegionName() + " region owned by " + region.getOwner());
							return true;
						}
					}
					sender.sendMessage("§7Your not in any regions");
					return true;
				} else if (args[0].equalsIgnoreCase("add") || args[0].equalsIgnoreCase("create")) {
					if (args.length == 2) {
						if (getProfile(sender).actionLocationA == null || getProfile(sender).actionLocationB == null) {
							sender.sendMessage("§7Please select two region boundaries using the golden shovel tool");
						} else {
							if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
								sender.sendMessage("§7A region with this name already exists");
								return true;
							}
							Region region = new Region(this, args[1],
									getProfile(sender).actionLocationA,
									getProfile(sender).actionLocationB,
									false,
									sender.getName(),
									null,
									null,
									null,
									null);
							region.saveRegion();
							regionList.add(region);
							sender.sendMessage("§7Region " + args[1] + " created");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region add [regionName]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("protect")) {
					if (args.length == 2) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								region.isProtected(true);	
								region.saveRegion();
							}
							sender.sendMessage("§7Region " + args[1] + " protected");
						} else {
							if (getProfile(sender).actionLocationA == null || getProfile(sender).actionLocationB == null) {
								sender.sendMessage("§7Please select two region boundaries using the golden shovel tool");
							} else {
								Region region = new Region(this, args[1],
										getProfile(sender).actionLocationA,
										getProfile(sender).actionLocationB,
										true,
										sender.getName(),
										null,
										null,
										null,
										null);
								region.saveRegion();
								regionList.add(region);
								sender.sendMessage("§7Region " + args[1] + " created and protected");
							}
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region protect [regionName]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("remove")) {
					if (args.length == 2) {
						for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
							if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
								sender.sendMessage("§7You don't have ownership of this region");
								return true;
							}
							new File("plugins/EvilBook/Regions/" + args[1] + ".properties").delete();
							regionList.remove(region);
							sender.sendMessage("§7Region " + args[1] + " removed");
							return true;
						}
						sender.sendMessage("§7No regions with this name exist");
						return true;
					}
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/region remove [regionName]");
					return true;
				} else if (args[0].equalsIgnoreCase("setwelcome")) {
					if (args.length > 2) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							String message = "";
							for (String msg : args) if (msg != args[0] && msg != args[1]) message += msg + " ";
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								region.setWelcomeMessage(toFormattedString(message.trim()));
								region.saveRegion();
							}
							sender.sendMessage("§7Region " + args[1] + " welcome message set");
						} else {
							sender.sendMessage("§7No regions with this name exist");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region setWelcome [regionName] [welcomeMessage]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("setleave")) {
					if (args.length > 2) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							String message = "";
							for (String msg : args) if (msg != args[0] && msg != args[1]) message += msg + " ";
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								region.setLeaveMessage(toFormattedString(message.trim()));	
								region.saveRegion();
							}
							sender.sendMessage("§7Region " + args[1] + " leave message set");
						} else {
							sender.sendMessage("§7No regions with this name exist");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region setLeave [regionName] [leaveMessage]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("allow")) {
					if (args.length == 3) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								if (isProfileExistant(args[2])) {
									OfflinePlayer regionPlayer = getServer().getOfflinePlayer(args[2]);
									region.addAllowedPlayer(regionPlayer.getName());
									region.saveRegion();
									sender.sendMessage("§7" + args[2] + "'s allowed permissions for region " + args[1]);
								} else {
									sender.sendMessage("§7This player doesn't exist");
								}
							}
						} else {
							sender.sendMessage("§7No regions with this name exist");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region allow [regionName] [playerName]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("deny")) {
					if (args.length == 3) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								if (isProfileExistant(args[2])) {
									OfflinePlayer regionPlayer = getServer().getOfflinePlayer(args[2]);
									region.removeAllowedPlayer(regionPlayer.getName());
									region.saveRegion();
									sender.sendMessage("§7" + args[2] + "'s permissions removed for region " + args[1]);
								} else {
									sender.sendMessage("§7This player doesn't exist");
								}
							}
						} else {
							sender.sendMessage("§7No regions with this name exist");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region deny [regionName] [playerName]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("teleport") || args[0].equalsIgnoreCase("tp")) {
					if (args.length == 2) {
						for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) player.teleport(region.getLocationA());
					} else {
						sender.sendMessage("§d/region tp [regionName]");
					}
					return true;
				} else if (args[0].equalsIgnoreCase("setWarp")) {
					if (args.length == 3) {
						if (new File("plugins/EvilBook/Regions/" + args[1] + ".properties").exists()) {
							for (Region region : regionList) if (region.getRegionName().equalsIgnoreCase(args[1])) {
								if (sender.getName() != region.getOwner() && getProfile(sender).rank.getID() < Rank.ServerHost.getID()) {
									sender.sendMessage("§7You don't have ownership of this region");
									return true;
								}
								region.setWarp(args[2].toLowerCase());	
								region.saveRegion();
							}
							sender.sendMessage("§7Region " + args[1] + " warp set");
						} else {
							sender.sendMessage("§7No regions with this name exist");
						}
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/region setWarp [regionName] [warpName]");
					}
					return true;
				}
			}
			sender.sendMessage("§5Incorrect command usage");
			sender.sendMessage("§d/region scan");
			sender.sendMessage("§d/region create [regionName]");
			sender.sendMessage("§d/region protect [regionName]");
			sender.sendMessage("§d/region remove [regionName]");
			sender.sendMessage("§d/region setWelcome [regionName] [welcomeMessage]");
			sender.sendMessage("§d/region setLeave [regionName] [leaveMessage]");
			sender.sendMessage("§d/region tp [regionName]");
			sender.sendMessage("§d/region setWarp [regionName] [warpName]");
			sender.sendMessage("§d/region allow [regionName] [playerName]");
			sender.sendMessage("§d/region deny [regionName] [playerName]");
			return true;
		}
		//
		// Admin assistance request command
		//
		if (command.getName().equalsIgnoreCase("req")) {
			if (args.length >= 1) {
				String message = "§c";
				for (String msg : args) message += msg + " ";
				Boolean adminOnline = false;
				for (Player p : getServer().getOnlinePlayers()) {
					if (getProfile(p).rank.isAdmin()) {
						p.sendMessage(sender.getName() + " requires admin assistance: " + message.trim());
						adminOnline = true;
					}
				}
				if (!adminOnline) {
					sender.sendMessage("§7No administrators are online to recieve your request");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/req [message]");
			}
			return true;
		}
		//
		// View The Shop Catalogue
		//
		if (command.getName().equalsIgnoreCase("shop") || command.getName().equalsIgnoreCase("catalogue")) {
			player.getInventory().addItem(getBook("Shop Catalogue", "Amentrix", Arrays.asList(
					"§cCatalogue §4- §cContents\n\n§dPage 2 to 5\n§5Name colors\n\n§dPage 6 to 8\n§5Name titles",
					"§cName colors §7$500\n\n§0Black\n§8/buy blackname\n\n§1Dark Blue\n§8/buy darkbluename\n\n§2Dark Green\n§8/buy darkgreenname\n\n§3Dark Aqua\n§8/buy darkaquaname",
					"§cName colors §7$500\n\n§4Dark Red\n§8/buy darkredname\n\n§5Dark Purple\n§8/buy darkpurplename\n\n§6Gold\n§8/buy goldname\n\n§7Grey\n§8/buy greyname",
					"§cName colors §7$500\n\n§8Dark Grey\n§8/buy darkgreyname\n\n§9Blue\n§8/buy bluename\n\n§aGreen\n§8/buy greenname\n\n§bAqua\n§8/buy aquaname",
					"§cName colors §7$500\n\n§cRed\n§8/buy redname\n\n§dPink\n§8/buy pinkname\n\n§eYellow\n§8/buy yellowname\n\n§aR§ba§ci§dn§eb§ao§bw\n§8/buy rainbowname",
					"§cName titles §7$500\n\n§dMr\n§8/buy mrtitle\n\n§dMrs\n§8/buy mrstitle\n\n§dMiss\n§8/buy misstitle\n\n§dLord\n§8/buy lordtitle",
					"§cName titles §7$500\n\n§dDr\n§8/buy drtitle\n\n§dProf\n§8/buy proftitle\n\n§dProf\n§8/buy proftitle\n\n§dMiner\n§8/buy minertitle",
					"§cName titles §7$500\n\n§dCrafter\n§8/buy craftertitle\n\n§dEpic\n§8/buy epictitle\n\n§dElf\n§8/buy elftitle\n\n§dCustom title §7$2000\n§8/buy customtitle [title]")));
			sender.sendMessage("§7A shop catalogue has been put in your inventory");
			return true;
		}
		//
		// Pay Command
		//
		if (command.getName().equalsIgnoreCase("pay") || command.getName().equalsIgnoreCase("givemoney")) {
			if (args.length == 2) {
				if (isProfileExistant(args[0])) {
					if (isInteger(args[1]) && Integer.valueOf(args[1]) > 0) {
						if (getProfile(sender).getMoney() >= Integer.valueOf(args[1])) {
							if (getPlayer(args[0]) != null) {
								getProfile(sender).chargeMoney(Integer.valueOf(args[1]));
								getProfile(args[0]).addMoney(Integer.valueOf(args[1]));
								getPlayer(args[0]).sendMessage("§7You have recieved §a$" + args[1] + " §7from " + player.getDisplayName());
								sender.sendMessage("§7You have paid " + getPlayer(args[0]).getDisplayName() + " §c$" + args[1]);
							} else {
								String money = getOfflineProperty(args[0], "Money");
								money = Integer.toString(Integer.valueOf(money) + Integer.valueOf(args[1]));
								setOfflineProperty(args[0], "Money", money);
								getProfile(sender).chargeMoney(Integer.valueOf(args[1]));
								sender.sendMessage("§7You have paid " + getServer().getOfflinePlayer(args[0]).getName() + " §c$" + args[1]);
							}
						} else {
							sender.sendMessage("§7You don't have enough money to do this");
						}
					} else {
						sender.sendMessage("§7Please enter a valid amount of money to pay");
					}
				} else {
					sender.sendMessage("§7You can't pay a player who doesn't exist");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/pay [player] [amount]");
			}
			return true;
		}
		//
		// Gamemode Command
		//
		if (command.getName().equalsIgnoreCase("gamemode")) {
			if (args.length == 1) {
				if (args[0].equalsIgnoreCase("survival") || args[0].equals("0")) {
					player.setGameMode(GameMode.SURVIVAL);
					sender.sendMessage("§7Your gamemode has been changed to survival");
				} else if (args[0].equalsIgnoreCase("creative") || args[0].equals("1")) {
					if (isInSurvival(player) == false || getProfile(sender).rank == Rank.ServerHost) {
						player.setGameMode(GameMode.CREATIVE);
						sender.sendMessage("§7Your gamemode has been changed to creative");
					} else {
						sender.sendMessage("§7Creative gamemode can't be used in survival");
					}
				} else if (args[0].equalsIgnoreCase("adventure") || args[0].equals("2")) {
					player.setGameMode(GameMode.ADVENTURE);
					sender.sendMessage("§7Your gamemode has been changed to adventure");
				} else {
					sender.sendMessage("§7This gamemode doesn't exist");
				}
			} else if (args.length == 2 && getProfile(sender).rank == Rank.ServerHost) {
				if (getPlayer(args[1]) != null) {
					if (args[0].equalsIgnoreCase("survival") || args[0].equals("0")) {
						getPlayer(args[1]).setGameMode(GameMode.SURVIVAL);
						getPlayer(args[1]).sendMessage(player.getDisplayName() + "§7 has changed your gamemode to survival");
						sender.sendMessage(getPlayer(args[1]).getDisplayName() + "§7's gamemode has been change to survival");
						alertOwner(sender.getName() + " changed " + getPlayer(args[1]).getName() + "'s gamemode to survival");
					} else if (args[0].equalsIgnoreCase("creative") || args[0].equals("1")) {
						if (isInSurvival(getPlayer(args[1])) == false) {
							getPlayer(args[1]).setGameMode(GameMode.CREATIVE);
							getPlayer(args[1]).sendMessage(player.getDisplayName() + "§7 has changed your gamemode to creative");
							sender.sendMessage(getPlayer(args[1]).getDisplayName() + "§7's gamemode has been change to creative");
							alertOwner(sender.getName() + " changed " + getPlayer(args[1]).getName() + "'s gamemode to creative");
						} else {
							sender.sendMessage("§7Creative gamemode can't be used on a player in survival");
						}
					} else if (args[0].equalsIgnoreCase("adventure") || args[0].equals("2")) {
						getPlayer(args[1]).setGameMode(GameMode.ADVENTURE);
						getPlayer(args[1]).sendMessage(player.getDisplayName() + "§7 has changed your gamemode to adventure");
						sender.sendMessage(getPlayer(args[1]).getDisplayName() + "§7's gamemode has been change to adventure");
						alertOwner(sender.getName() + " changed " + getPlayer(args[1]).getName() + "'s gamemode to adventure");
					} else {
						sender.sendMessage("§7This gamemode doesn't exist");
					}
				} else {
					sender.sendMessage("§7You change the gamemode of an offline player");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/gamemode [mode]");
			}
			return true;
		}
		//
		// Generate Filled Sphere Command
		//
		if (command.getName().equalsIgnoreCase("sphere")) {	
			EvilEdit.createSphere(player, args, false);
			return true;
		}
		//
		// Generate Hollow Sphere Command
		//
		if (command.getName().equalsIgnoreCase("hsphere")) {	
			EvilEdit.createSphere(player, args, true);
			return true;
		}
		//
		// Replace Command
		//
		if (command.getName().equalsIgnoreCase("replace")) {
			EvilEdit.replaceArea(player, args);
			return true;
		}
		//
		// Randomly Replace Command
		//
		if (command.getName().equalsIgnoreCase("rreplace")) {
			EvilEdit.randomReplaceArea(player, args);
			return true;
		}
		//
		// Fill Command
		//
		if (command.getName().equalsIgnoreCase("fill")) {
			EvilEdit.fillArea(player, args);
			return true;
		}
		//
		// Random Fill Command
		//
		if (command.getName().equalsIgnoreCase("rfill")) {
			EvilEdit.randomFillArea(player, args);
			return true;
		}
		//
		// Random Delete Command
		//
		if (command.getName().equalsIgnoreCase("rdel") || command.getName().equalsIgnoreCase("rdelete")) {
			EvilEdit.randomDeleteArea(player, args);
			return true;
		}
		//
		// Delete Command
		//
		if (command.getName().equalsIgnoreCase("del") || command.getName().equalsIgnoreCase("delete")) {
			EvilEdit.deleteArea(player, args);
			return true;
		}
		//
		// Copy Command
		//
		if (command.getName().equalsIgnoreCase("copy")) {
			EvilEdit.copy(player, args);
			return true;
		}
		//
		// Paste Command
		//
		if (command.getName().equalsIgnoreCase("paste")) {
			EvilEdit.paste(player, args);
			return true;
		}
		//
		// Overlay Command
		//
		if (command.getName().equalsIgnoreCase("overlay")) {
			EvilEdit.overlayArea(player, args);
			return true;
		}
		//
		// Walls Command
		//
		if (command.getName().equalsIgnoreCase("walls")) {
			EvilEdit.wallArea(player, args);
			return true;
		}
		//
		// Outline Command
		//
		if (command.getName().equalsIgnoreCase("outline")) {
			EvilEdit.outlineArea(player, args);
			return true;
		}
		//
		// Hollow Command
		//
		if (command.getName().equalsIgnoreCase("hollow")) {
			EvilEdit.hollowArea(player, args);
			return true;
		}
		//
		// Regen Command
		//
		if (command.getName().equalsIgnoreCase("regen")) {
			EvilEdit.regenerateChunk(player);
			return true;
		}
		//
		// Drain Command
		//
		if (command.getName().equalsIgnoreCase("drain")) {
			EvilEdit.drainArea(player, args);
			return true;
		}
		//
		// Undo Command
		//
		if (command.getName().equalsIgnoreCase("undo")) {
			if (getProfile(sender).EvilEditUndo.size() == 0) {
				sender.sendMessage("§7You have no EvilEdit actions to undo");
			} else {
				EvilEdit.editBlockList.addAll(getProfile(sender).EvilEditUndo);
				getProfile(sender).EvilEditUndo = new ArrayList<>();
			}
			return true;
		}
		//
		// Wand Command
		//
		if (command.getName().equalsIgnoreCase("wand")) {
			if (isInSurvival(player)) {
				sender.sendMessage("§7You can't spawn an evil edit wand in survival");
			} else {
				player.getInventory().addItem(new ItemStack(Material.GOLD_SPADE));
				sender.sendMessage("§7You haved spawned an evil edit wand");
			}
			return true;
		}
		//
		// Desel Command
		//
		if (command.getName().equalsIgnoreCase("desel")) {
			getProfile(player).actionLocationA = null;
			getProfile(player).actionLocationB = null;
			sender.sendMessage("§7You have deselected your evil edit locations");
			return true;
		}
		//
		// Debug Command
		//
		if (command.getName().equalsIgnoreCase("debug")) {
			//Entity e = player.getWorld().spawnEntity(player.getLocation(), EntityType.ENDER_DRAGON);
			//e.setPassenger(player);
			Entity[] entity = new Entity[51];
			entity[0] = player.getWorld().spawnEntity(player.getLocation(), EntityType.SHEEP);
			for (int i = 0; i < 50; i++) {
				entity[i + 1] = player.getWorld().spawnEntity(player.getLocation(), EntityType.SHEEP);
				entity[i].setPassenger(entity[i + 1]);
			}
			//long startTime = System.nanoTime();
			// Code
			//long testA = System.nanoTime() - startTime;
			//long startTime2 = System.nanoTime();
			// Code
			//long testB = System.nanoTime() - startTime2;
			//sender.sendMessage("TestA = " + (testA / 100000));
			//sender.sendMessage("TestB = " + (testB / 100000));
			//EntityHuman v;
			//player.getWorld().spawnEntity(player.getLocation(), EntityType.fromId(49));
			/*
			WorldServer world = ((CraftWorld)player.getWorld()).getHandle();
			EntityPlayer playerEntity = new EntityPlayer(((CraftServer) getServer()).getServer(), world, args[0], new PlayerInteractManager(world));
			playerEntity.spawnIn(world);
			playerEntity.setPosition(player.getLocation().getX(), player.getLocation().getY(), player.getLocation().getZ());
			world.addEntity(playerEntity);
			 */
			return true;
		}
		//
		// Rename Command
		//
		if (command.getName().equalsIgnoreCase("rename")) {
			if (args.length >= 1) {
				if (args[0].equalsIgnoreCase("clear")) {
					getProfile(sender).setNameAlias(null, player);
					sender.sendMessage("§7Your name alias has been removed");
					alertOwner(sender.getName() + " removed their name alias");
				} else {
					String name = "";
					for (String arg : args) name += arg + " ";
					if (name.trim().length() <= 14) {
						for (String playerName : new File("plugins/EvilBook/Players").list()) {
							if (name.trim().equalsIgnoreCase(playerName.substring(0, playerName.lastIndexOf('.'))) && playerName.substring(0, playerName.lastIndexOf('.')).equalsIgnoreCase(sender.getName()) == false) {
								sender.sendMessage("§7The name '§d" + name.trim() + "§7' is in use by another player");
								return true;
							}
						}
						getProfile(sender).setNameAlias(name.trim(), player);
						sender.sendMessage("§7You have renamed yourself to §d" + name.trim());
						alertOwner(sender.getName() + " renamed themselves to " + name.trim());
					} else {
						sender.sendMessage("§7The maximum rename length is 14 characters");
					}
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/rename [name]");
			}
			return true;
		}
		//
		// Mute Command
		//
		if (command.getName().equalsIgnoreCase("mute")) {
			if (args.length == 1) {
				getProfile(sender).mutedPlayers.add(args[0].toLowerCase());
				sender.sendMessage("§7You have muted " + args[0]);
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/mute [player]");
			}
			return true;
		}
		//
		// Un-mute Command
		//
		if (command.getName().equalsIgnoreCase("unmute")) {
			if (args.length == 1) {
				if (getProfile(sender).mutedPlayers == null) {
					sender.sendMessage("§7You haven't muted any players");
				} else {
					getProfile(sender).mutedPlayers.remove(args[0].toLowerCase());
					sender.sendMessage("§7You have unmuted " + args[0]);
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/unmute [player]");
			}
			return true;
		}
		//
		// Vanish Command
		//
		if (command.getName().equalsIgnoreCase("vanish") || command.getName().equalsIgnoreCase("hide")) {
			if (isInSurvival(player) && getProfile(sender).rank != Rank.ServerHost) {
				sender.sendMessage("§7Vanish can't be used in survival");
				return true;
			}
			for (Player other : getServer().getOnlinePlayers()) other.hidePlayer(player);
			getProfile(player).isInvisible = true;
			sender.sendMessage("§7You are now invisible");
			alertOwner(sender.getName() + " made themselves invisible");
			return true;
		}
		//
		// Unvanish Command
		//
		if (command.getName().equalsIgnoreCase("unvanish") || command.getName().equalsIgnoreCase("show")) {
			for (Player other : getServer().getOnlinePlayers()) other.showPlayer(player);
			getProfile(player).isInvisible = false;
			sender.sendMessage("§7You are now visible");
			return true;
		}
		//
		// Set Home Command
		//
		if (command.getName().equalsIgnoreCase("sethome")) {
			getProfile(sender).homeLocation = player.getLocation();
			sender.sendMessage("§7Your home location has been set");
			return true;
		}
		//
		// Teleport To Home Command
		//
		if (command.getName().equalsIgnoreCase("home")) {
			if (getProfile(sender).homeLocation != null) {
				player.teleport(getProfile(sender).homeLocation);
				sender.sendMessage("§7Welcome home");
			} else {
				sender.sendMessage("§7Please set a home first using /sethome");
			}
			return true;
		}
		//
		// Spawn Creature Command
		//
		if (command.getName().equalsIgnoreCase("spawncreature") || command.getName().equalsIgnoreCase("cspawn")) {
			if (isInSurvival(player) == false || getProfile(sender).rank == Rank.ServerHost) {
				if (args.length >= 1) {
					EntityType entityType = getEntity(args[0]);
					if (entityType != null) {
						if ((entityType != EntityType.ENDER_DRAGON && entityType != EntityType.WITHER && entityType != EntityType.ENDER_CRYSTAL) || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
							if (args.length == 1) {
								if (player.getNearbyEntities(64, 64, 64).size() + 1 >= 400 && getProfile(sender).rank.getID() < Rank.ServerOwner.getID()) {
									sender.sendMessage("§7Nearby entity limit reached");
								} else {
									player.getWorld().spawnEntity(player.getLocation(), entityType);
									sender.sendMessage("§7Spawned a " + args[0].toLowerCase());
									alertOwner(sender.getName() + " spawned a " + args[0].toLowerCase());
								}
							} else if (args.length == 2) {
								if (isInteger(args[1])) {
									if (player.getNearbyEntities(64, 64, 64).size() + Integer.valueOf(args[1]) >= 400 && getProfile(sender).rank.getID() < Rank.ServerOwner.getID()) {
										sender.sendMessage("§7Nearby entity limit reached");
									} else {
										int amount = Integer.valueOf(args[1]);
										for (int i = 0; i < amount; i++) player.getWorld().spawnEntity(player.getLocation(), entityType);
										sender.sendMessage("§7Spawned " + args[1] + " " + args[0].toLowerCase() + "'s");
										alertOwner(sender.getName() + " spawned " + args[1] + " " + args[0].toLowerCase() + "'s");
									}
								} else {
									sender.sendMessage("§7Please enter a valid number of creatures to spawn");
								}
							}
						} else {
							sender.sendMessage("§7This creature is banned");
						}
					} else {
						sender.sendMessage("§7This creature doesn't exist");
					}
				} else {
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/cspawn [mob] <amount>");
					sender.sendMessage("§d/spawncreature [mob] <amount>");
				}
			} else {
				sender.sendMessage("§7Creatures can't be spawned in survival");
			}
			return true;
		}
		//
		// Warp Command
		//
		if (command.getName().equalsIgnoreCase("warp")) {
			if (args.length == 1) {
				if (args[0].equalsIgnoreCase("list")) {
					if (getProfile(sender).warps.size() != 0) {
						sender.sendMessage("§5My warps");
						sender.sendMessage("§d" + getProfile(sender).warps);
					} else {
						sender.sendMessage("§7You don't own any warps");
					}
				} else {
					if (warpList.containsKey(args[0].toLowerCase())) {
						player.teleport(warpList.get(args[0].toLowerCase()));
					} else {
						sender.sendMessage("§7A warp with that name doesn't exist");
					}
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/warp [warpName]");
			}
			return true;
		}
		//
		// Delete Warp Command
		//
		if (command.getName().equalsIgnoreCase("delwarp") || command.getName().equalsIgnoreCase("deletewarp")) {
			if (args.length == 1) {
				if (getProfile(sender).warps.size() != 0) {
					if (getProfile(sender).rank.getID() >= Rank.ServerOwner.getID() || getProfile(sender).warps.contains(args[0].toLowerCase())) {
						getProfile(sender).warps.remove(args[0].toLowerCase());
						warpList.remove(args[0].toLowerCase());
						Properties warpFile = new Properties("plugins/EvilBook/Warps.db");
						warpFile.removeProperty(args[0].toLowerCase());
						warpFile.save();
						for (Region region : regionList) {
							if (region.getWarp().equals(args[0].toLowerCase())) {
								region.setWarp(null);
							}
						}
						sender.sendMessage("§7Deleted warp §d" + args[0]);
					} else {
						sender.sendMessage("§7You don't own this warp");
					}
				} else {
					sender.sendMessage("§7You don't own any warps");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/delwarp [warpName]");
			}
			return true;
		}
		//
		// Set Warp Command
		//
		if (command.getName().equalsIgnoreCase("setwarp") || command.getName().equalsIgnoreCase("createwarp")) {
			if (args.length == 1) {
				if (getProfile(sender).rank.isAdmin() || getProfile(sender).getMoney() >= 20) {
					if (args[0].length() <= 16) {
						Location loc = player.getLocation();
						if (loc.getY() < 1) {
							sender.sendMessage("§7You can't create a warp below bedrock");
						} else {
							if (args[0].contains(",")) {
								sender.sendMessage("§7The ',' character is blocked in warp names");
							} else {
								Properties warpFile = new Properties("plugins/EvilBook/Warps.db");
								if (warpFile.getProperty(args[0].toLowerCase()) == null) {
									warpFile.setProperty(args[0].toLowerCase(), loc.getWorld().getName() + ":" + loc.getX() + ":" + loc.getY() + ":" + loc.getZ() + ":" + loc.getYaw() + ":" + loc.getPitch());
									warpFile.save();
									warpList.put(args[0].toLowerCase(), loc);
									if (getProfile(sender).rank.isAdmin()) {
										sender.sendMessage("§7Created warp §d" + args[0]);
									} else {
										getProfile(sender).chargeMoney(20);
										sender.sendMessage("§7Created warp §d" + args[0] + " §c-$20");
									}
									getProfile(sender).warps.add(args[0].toLowerCase());
								} else {
									sender.sendMessage("§7A warp named §d" + args[0] + " §7already exists");
								}
							}
						}
					} else {
						sender.sendMessage("§7The maximum warp name length is 16 characters");
					}
				} else {
					sender.sendMessage("§5You don't have enough money for this item");
					sender.sendMessage("§dYou need to earn $" + (20 - getProfile(sender).getMoney()));
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/setwarp [warpName]");
			}
			return true;
		}
		//
		// Enchant Command
		//
		if (command.getName().equalsIgnoreCase("enchant")) {
			if (isInSurvival(player) == false || getProfile(sender).rank == Rank.ServerHost) {
				if (args.length == 2) {
					if (isInteger(args[1])) {
						try {
							player.getItemInHand().addEnchantment(getEnchantment(args[0].toUpperCase()), Integer.valueOf(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.ARROW_DAMAGE) sender.sendMessage("§7Item enchanted with the power of damage " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.ARROW_FIRE) sender.sendMessage("§7Item enchanted with flame");
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.ARROW_INFINITE) sender.sendMessage("§7Item enchanted with infinite arrows");
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.ARROW_KNOCKBACK) sender.sendMessage("§7Item enchanted with knockback " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.DAMAGE_ALL) sender.sendMessage("§7Item enchanted with sharpness " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.DAMAGE_ARTHROPODS) sender.sendMessage("§7Item enchanted with bane of arthropods " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.DAMAGE_UNDEAD) sender.sendMessage("§7Item enchanted with smite " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.DIG_SPEED) sender.sendMessage("§7Item enchanted with efficiency " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.DURABILITY) sender.sendMessage("§7Item enchanted with unbreaking " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.FIRE_ASPECT) sender.sendMessage("§7Item enchanted with fire aspect " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.KNOCKBACK) sender.sendMessage("§7Item enchanted with knockback " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.LOOT_BONUS_BLOCKS) sender.sendMessage("§7Item enchanted with fortune " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.LOOT_BONUS_MOBS) sender.sendMessage("§7Item enchanted with looting " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.OXYGEN) sender.sendMessage("§7Item enchanted with respiration " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.PROTECTION_ENVIRONMENTAL) sender.sendMessage("§7Item enchanted with protection " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.PROTECTION_EXPLOSIONS) sender.sendMessage("§7Item enchanted with explosive protection " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.PROTECTION_FALL) sender.sendMessage("§7Item enchanted with fall protection " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.PROTECTION_FIRE) sender.sendMessage("§7Item enchanted with fire protection " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.PROTECTION_PROJECTILE) sender.sendMessage("§7Item enchanted with projectile protection " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.SILK_TOUCH) sender.sendMessage("§7Item enchanted with silk touch");
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.THORNS) sender.sendMessage("§7Item enchanted with thorns " + toRomanNumerals(args[1]));
							if (getEnchantment(args[0].toUpperCase()) == Enchantment.WATER_WORKER) sender.sendMessage("§7Item enchanted with aqua affinity");
						} catch (Exception exception) {
							if (getEnchantment(args[0].toUpperCase()) == null) {
								sender.sendMessage("§7This enchantment doesn't exist");
							} else if (Integer.valueOf(args[1]) > getEnchantment(args[0].toUpperCase()).getMaxLevel()) {
								sender.sendMessage("§7The maximum level for this enchantment is " + getEnchantment(args[0].toUpperCase()).getMaxLevel());
							} else {
								sender.sendMessage("§7This item can't have this enchantment");
							}
						}
					} else {
						sender.sendMessage("§7Please enter a valid enchantment level");
					}
				} else {
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/enchant [enchantmentID] [enchantmentLevel]");
				}
			} else {
				sender.sendMessage("§7Items can't be enchanted in survival via command");
			}
			return true;
		}
		//
		// Back Command
		//
		if (command.getName().equalsIgnoreCase("back")) {
			if (getProfile(sender).deathLocation != null) {
				player.teleport(getProfile(sender).deathLocation);
				sender.sendMessage("§7Teleported to your death position");
			} else {
				sender.sendMessage("§7You haven't died recently");
			}
			return true;
		}
		//
		// Storm Command
		//
		if (command.getName().equalsIgnoreCase("storm")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setThundering(true);
				player.getWorld().setStorm(true);
				sender.sendMessage("§7World weather changed to stormy");
			} else {
				sender.sendMessage("§7Weather can't be changed in survival");
			}
			return true;
		}
		//
		// Rain Command
		//
		if (command.getName().equalsIgnoreCase("rain")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setStorm(true);
				sender.sendMessage("§7World weather changed to rainy");
			} else {
				sender.sendMessage("§7Weather can't be changed in survival");
			}
			return true;
		}
		//
		// Sun Command
		//
		if (command.getName().equalsIgnoreCase("sun")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setThundering(false);
				player.getWorld().setStorm(false);
				sender.sendMessage("§7World weather changed to sunny");
			} else {
				sender.sendMessage("§7Weather can't be changed in survival");
			}
			return true;
		}
		//
		// AFK Command
		//
		if (command.getName().equalsIgnoreCase("afk")) {
			getProfile(player).isAway = true;
			broadcastPlayerMessage(sender.getName(), "§5" + player.getDisplayName() + " §dhas gone AFK");
			getProfile(player).updatePlayerListName(player);
			return true;
		}
		//
		// Time Command
		//
		if (command.getName().equalsIgnoreCase("time")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				if (args.length == 1) {
					if (isInteger(args[0])) {
						player.getWorld().setTime(Long.valueOf(args[0]));
					} else if (args[0].equalsIgnoreCase("dawn")) {
						player.getWorld().setTime(0L);
					} else if (args[0].equalsIgnoreCase("day")) {
						player.getWorld().setTime(6000L);
					} else if (args[0].equalsIgnoreCase("dusk")) {
						player.getWorld().setTime(12000L);
					} else if (args[0].equalsIgnoreCase("night")) {
						player.getWorld().setTime(18000L);
					} else {
						sender.sendMessage("§7This is not a valid time");
						return true;
					}
					sender.sendMessage("§7World time changed");
				} else {
					sender.sendMessage("§5Incorrect command usage");
					sender.sendMessage("§d/time [time]");
					sender.sendMessage("§d/time dawn");
					sender.sendMessage("§d/time day");
					sender.sendMessage("§d/time dusk");
					sender.sendMessage("§d/time night");
				}
			} else {
				sender.sendMessage("§7Time can't be changed in survival");
			}
			return true;
		}
		//
		// Set Spawn Command
		//
		if (command.getName().equalsIgnoreCase("setspawn")) {
			player.getWorld().setSpawnLocation(player.getLocation().getBlockX(), player.getLocation().getBlockY(), player.getLocation().getBlockZ());
			sender.sendMessage("§7The world spawn has been moved");
			return true;
		}
		//
		// Spawn Command
		//
		if (command.getName().equalsIgnoreCase("spawn")) {
			player.teleport(player.getWorld().getSpawnLocation());
			return true;
		}
		//
		// Me Command
		//
		if (command.getName().equalsIgnoreCase("me")) {
			String me = "";
			for (String msg : args) me += " " + msg;
			broadcastPlayerMessage(sender.getName(), "* " + player.getDisplayName() + me);
			return true;
		}
		//
		// Butcher Command
		//
		if (command.getName().equalsIgnoreCase("butcher")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				int entities = player.getWorld().getLivingEntities().size();
				for (LivingEntity entity : player.getWorld().getLivingEntities()) if (entity.getType() == EntityType.PLAYER || (entity.getType() == EntityType.WOLF && ((Tameable)entity).isTamed())) entities--; else entity.remove();
				sender.sendMessage("§5" + entities + "§d animals butchered");
				alertOwner(sender.getName() + " executed the butcher command");
			} else {
				sender.sendMessage("§7Animals can't be butchered in survival");
			}
			return true;
		}
		//
		// Tree Spawn Command
		//
		if (command.getName().equalsIgnoreCase("tree")) {
			if (isInSurvival(player) == false || getProfile(sender).rank == Rank.ServerHost) {
				if (args.length == 0) {
					player.getWorld().generateTree(player.getLocation(), TreeType.TREE);
					alertOwner(sender.getName() + " spawned a tree");
				} else {
					if (args[0].equalsIgnoreCase("Tree") || args[0].equalsIgnoreCase("Redwood") || args[0].equalsIgnoreCase("Birch") || args[0].equalsIgnoreCase("Jungle")) {
						player.getWorld().generateTree(player.getLocation(), TreeType.valueOf(args[0].toUpperCase()));
						alertOwner(sender.getName() + " spawned a tree");
					} else {
						sender.sendMessage("§7Please Specify A Type of Tree From The Following");
						sender.sendMessage("§7Default /tree");
						sender.sendMessage("§7RedWood /tree redwood");
						sender.sendMessage("§7Birch   /tree birch");
						sender.sendMessage("§7Jungle  /tree jungle");
					}
				}
			} else {
				sender.sendMessage("§7Trees can't be spawned in survival");
			}
			return true;
		}
		//
		// Hug Command
		//
		if (command.getName().equalsIgnoreCase("hug")) {
			if (args.length >= 1) {
				broadcastPlayerMessage(sender.getName(), player.getDisplayName() + " hugs " + args[0]);
			} else {
				broadcastPlayerMessage(sender.getName(), player.getDisplayName() + " hugs themselves");
			}
			return true;
		}
		//
		// Kiss Command
		//
		if (command.getName().equalsIgnoreCase("kiss")) {
			if (args.length >= 1) {
				broadcastPlayerMessage(sender.getName(), player.getDisplayName() + " kisses " + args[0]);
			} else {
				broadcastPlayerMessage(sender.getName(), player.getDisplayName() + " kisses themselves");
			}
			return true;
		}
		//
		// Clear Inventory Command
		//
		if (command.getName().equalsIgnoreCase("clear")) {
			player.getInventory().clear();
			sender.sendMessage("§7Your inventory has been cleared");
			return true;
		}
		//
		// Dawn Time Command
		//
		if (command.getName().equalsIgnoreCase("dawn")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setTime(0L);
				sender.sendMessage("§7The world time has been changed to dawn");
			} else {
				sender.sendMessage("§7Time can't be changed in survival");
			}
			return true;
		}
		//
		// Day Time Command
		//
		if (command.getName().equalsIgnoreCase("day")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setTime(6000L);
				sender.sendMessage("§7The world time has been changed to day");
			} else {
				sender.sendMessage("§7Time can't be changed in survival");
			}
			return true;
		}
		//
		// Dusk Time Command
		//
		if (command.getName().equalsIgnoreCase("dusk")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setTime(12000L);
				sender.sendMessage("§7The world time has been changed to dusk");
			} else {
				sender.sendMessage("§7Time can't be changed in survival");
			}
			return true;
		}
		//
		// Night Time Command
		//
		if (command.getName().equalsIgnoreCase("night")) {
			if (isInSurvival(player) == false || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
				player.getWorld().setTime(18000L);
				sender.sendMessage("§7The world time has been changed to night");
			} else {
				sender.sendMessage("§7Time can't be changed in survival");
			}
			return true;
		}
		//
		// Accept Teleport Request Command
		//
		if (command.getName().equalsIgnoreCase("accept")) {
			if (getProfile(sender).teleportantName != null) {
				if (getPlayer(getProfile(sender).teleportantName) != null) {
					getPlayer(getProfile(sender).teleportantName).teleport(player);
					getPlayer(getProfile(sender).teleportantName).sendMessage("§7Teleport request accepted");
					getProfile(sender).teleportantName = null;
				} else {
					sender.sendMessage("§7The player who sent the request isn't online");
				}
			}
			return true;
		}
		//
		// Teleport To Player Command
		//
		if (command.getName().equalsIgnoreCase("tp") || command.getName().equalsIgnoreCase("teleport")) {
			if (args.length == 1) {
				if (getPlayer(args[0]) != null) {
					if (!isInSurvival(getPlayer(args[0])) || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
						if (getProfile(getPlayer(args[0])).rank.isAdmin() && getProfile(sender).rank.getID() < Rank.Custom.getID()) {
							getProfile(getPlayer(args[0])).teleportantName = sender.getName();
							getPlayer(args[0]).sendMessage("§d" + player.getDisplayName() + " §dwishes to teleport to you");
							getPlayer(args[0]).sendMessage("§aTo accept the request type /accept");
							sender.sendMessage("§7A teleport request has been sent to " + getPlayer(args[0]).getDisplayName());
						} else {
							player.teleport(getPlayer(args[0]));
						}
					} else {
						sender.sendMessage("§7You can't teleport to a player in survival");
					}
				} else {
					sender.sendMessage("§7You can't teleport to an offline player");
				}
			} else if (args.length == 2 && getProfile(sender).rank.getID() >= Rank.CoOwner.getID()) {
				if (getPlayer(args[0]) != null && getPlayer(args[1]) != null) {
					if ((!isInSurvival(getPlayer(args[0])) && !isInSurvival(getPlayer(args[1]))) || getProfile(sender).rank == Rank.ServerHost) {
						getPlayer(args[0]).teleport(getPlayer(args[1]));
					} else {
						sender.sendMessage("§7You can't teleport a player in survival");
					}
				} else {
					sender.sendMessage("§7You can't teleport an offline player");
				}
			} else if (args.length == 3) {
				if (!isInSurvival(player) || getProfile(sender).rank == Rank.ServerHost) {
					if (isDouble(args[0]) && isDouble(args[1]) && isDouble(args[2])) {
						Location destination = player.getLocation();
						destination.setX(Double.valueOf(args[0]));
						destination.setY(Double.valueOf(args[1]));
						destination.setZ(Double.valueOf(args[2]));
						player.teleport(destination);
						sender.sendMessage("§aTeleported to co-ordinates");
						sender.sendMessage("§dX: " + args[0]);
						sender.sendMessage("§dY: " + args[1]);
						sender.sendMessage("§dZ: " + args[2]);
					} else {
						sender.sendMessage("§5Incorrect command usage");
						sender.sendMessage("§d/tp [x] [y] [z]");
						sender.sendMessage("§7The X, Y and Z values must be numbers");
					}
				} else {
					sender.sendMessage("§7You can't teleport to co-ordinates in survival");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/tp [player]");
				sender.sendMessage("§d/tp [x] [y] [z]");
				sender.sendMessage("§6Co-Owner §d/tp [player] <toPlayer>");
			}
			return true;
		}
		//
		// Teleport Player Here Command
		//
		if (command.getName().equalsIgnoreCase("tphere") || command.getName().equalsIgnoreCase("teleporthere")) {
			if (args.length == 1) {
				if (getPlayer(args[0]) != null) {
					if (!isInSurvival(player) || getProfile(sender).rank.getID() >= Rank.ServerOwner.getID()) {
						getPlayer(args[0]).teleport(player);
					} else {
						sender.sendMessage("§7You can't teleport a player who is in survival");
					}
				} else {
					sender.sendMessage("§7You can't teleport an offline player");
				}
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/tphere [player]");
			}
			return true;
		}
		//
		// Buy Shop Item Command
		//
		if (command.getName().equalsIgnoreCase("buy")) {
			if (args.length == 1) {
				if (args[0].endsWith("name")) {
					if (getProfile(sender).getMoney() >= 500) {
						getProfile(sender).chargeMoney(500);
					} else {
						sender.sendMessage("§5You don't have enough money for this item");
						sender.sendMessage("§dYou need to earn $" + (500 - getProfile(sender).getMoney()));
						return true;
					}
					if (args[0].equalsIgnoreCase("blackname")) getProfile(sender).setNameColor("0", player);
					if (args[0].equalsIgnoreCase("darkbluename")) getProfile(sender).setNameColor("1", player);
					if (args[0].equalsIgnoreCase("darkgreenname")) getProfile(sender).setNameColor("2", player);
					if (args[0].equalsIgnoreCase("darkaquaname")) getProfile(sender).setNameColor("3", player);
					if (args[0].equalsIgnoreCase("darkredname")) getProfile(sender).setNameColor("4", player);
					if (args[0].equalsIgnoreCase("darkpurplename")) getProfile(sender).setNameColor("5", player);
					if (args[0].equalsIgnoreCase("goldname")) getProfile(sender).setNameColor("6", player);
					if (args[0].equalsIgnoreCase("greyname")) getProfile(sender).setNameColor("7", player);
					if (args[0].equalsIgnoreCase("darkgreyname")) getProfile(sender).setNameColor("8", player);
					if (args[0].equalsIgnoreCase("bluename")) getProfile(sender).setNameColor("9", player);
					if (args[0].equalsIgnoreCase("greenname")) getProfile(sender).setNameColor("a", player);
					if (args[0].equalsIgnoreCase("aquaname")) getProfile(sender).setNameColor("b", player);
					if (args[0].equalsIgnoreCase("redname")) getProfile(sender).setNameColor("c", player);
					if (args[0].equalsIgnoreCase("pinkname")) getProfile(sender).setNameColor("d", player);
					if (args[0].equalsIgnoreCase("yellowname")) getProfile(sender).setNameColor("e", player);
					if (args[0].equalsIgnoreCase("rainbowname")) getProfile(sender).setNameColor("?", player);
					sender.sendMessage("§7Purchase complete");
					return true;
				} else if (args[0].endsWith("title")) {
					if (getProfile(sender).getMoney() >= 500) {
						getProfile(sender).chargeMoney(500);
					} else {
						sender.sendMessage("§5You don't have enough money for this item");
						sender.sendMessage("§dYou need to earn $" + (500 - getProfile(sender).getMoney()));
						return true;
					}
					if (args[0].equalsIgnoreCase("elftitle")) getProfile(sender).setNameTitle("Elf", player);
					if (args[0].equalsIgnoreCase("mrtitle")) getProfile(sender).setNameTitle("Mr", player);
					if (args[0].equalsIgnoreCase("mrstitle")) getProfile(sender).setNameTitle("Mrs", player);
					if (args[0].equalsIgnoreCase("misstitle")) getProfile(sender).setNameTitle("Miss", player);
					if (args[0].equalsIgnoreCase("lordtitle")) getProfile(sender).setNameTitle("Lord", player);
					if (args[0].equalsIgnoreCase("drtitle")) getProfile(sender).setNameTitle("Dr", player);
					if (args[0].equalsIgnoreCase("proftitle")) getProfile(sender).setNameTitle("Prof", player);
					if (args[0].equalsIgnoreCase("minertitle")) getProfile(sender).setNameTitle("Miner", player);
					if (args[0].equalsIgnoreCase("craftertitle")) getProfile(sender).setNameTitle("Crafter", player);
					if (args[0].equalsIgnoreCase("epictitle")) getProfile(sender).setNameTitle("Epic", player);
					sender.sendMessage("§7Purchase complete");
					return true;
				}
				sender.sendMessage("§7That item doesn't exist");
				return true;
			}
			if (args.length == 2 && args[0].equalsIgnoreCase("customtitle")) {
				if (getProfile(sender).getMoney() >= 2000) {
					getProfile(sender).chargeMoney(2000);
				} else {
					sender.sendMessage("§5You don't have enough money for this item");
					sender.sendMessage("§dYou need to earn $" + (2000 - getProfile(sender).getMoney()));
					return true;
				}
				getProfile(sender).setNameTitle(args[1], player);
				sender.sendMessage("§7Purchase complete");
			} else {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/buy [item]");
			}
			return true;
		}
		//
		// Give Block Command
		//
		if (command.getName().equalsIgnoreCase("item") || command.getName().equalsIgnoreCase("give")) {
			if (isInSurvival(player.getWorld().getName()) && getProfile(sender).rank != Rank.ServerHost) {
				sender.sendMessage("§7Spawning of items is blocked in survival");
				return true;
			}
			if (args.length == 0 || args.length >= 4) {
				sender.sendMessage("§5Incorrect command usage");
				sender.sendMessage("§d/item [ID] <amount> <data>");
				sender.sendMessage("§d/give [ID] <amount> <data>");
				sender.sendMessage("§d/item [name] <amount> <data>");
				sender.sendMessage("§d/give [name] <amount> <data>");
				return true;
			}
			try {
				int itemID = Integer.valueOf(args[0]);
				ItemStack spawnItem = new ItemStack(itemID);
				if (args.length == 2) {
					try {
						spawnItem.setAmount(Integer.valueOf(args[1]));
					} catch (Exception exception) {
						sender.sendMessage("§7Please enter a valid number of items to spawn");
						return true;
					}
				} else if (args.length == 3) {
					try {
						spawnItem.setAmount(Integer.valueOf(args[1]));
					} catch (Exception exception) {
						sender.sendMessage("§7Please enter a valid number of items to spawn");
						return true;
					}
					try {
						spawnItem.setData(new MaterialData(itemID, Byte.valueOf(args[2])));
					} catch (Exception exception) {
						sender.sendMessage("§7Please enter a valid data number");
						return true;
					}
				}
				player.getInventory().addItem(spawnItem);
			} catch (Exception exception) {
				//TODO: Check this works
				for(Entry<Material, List<String>> entry : blockList.entrySet()) {
					for (String subItem : entry.getValue()) {
						if (args[0].equalsIgnoreCase(subItem)) {
							ItemStack spawnItem = new ItemStack(entry.getKey());
							if (args.length == 2) {
								try {
									spawnItem.setAmount(Integer.valueOf(args[1]));
								} catch (Exception exception2) {
									sender.sendMessage("§7Please enter a valid number of items to spawn");
									return true;
								}
							} else if (args.length == 3) {
								try {
									spawnItem.setAmount(Integer.valueOf(args[1]));
								} catch (Exception exception2) {
									sender.sendMessage("§7Please enter a valid number of items to spawn");
									return true;
								}
								try {
									spawnItem.setData(new MaterialData(entry.getKey(), Byte.valueOf(args[2])));
								} catch (Exception exception2) {
									sender.sendMessage("§7Please enter a valid data number");
									return true;
								}
							}
							player.getInventory().addItem(spawnItem);
							return true;
						}
					}
				}
				sender.sendMessage("§7Please enter a valid block name");
			}
			return true;
		}
		return false;
	}

	/**
	 * Log information to the minecraft server console
	 * @param information The information to log
	 */
	public void logInfo(String information) {
		Logger.getLogger("Minecraft").log(Level.INFO, information);
	}

	/**
	 * Log severe information to the minecraft server console
	 * @param information The severe information to log
	 */
	public void logSevere(String information) {
		Logger.getLogger("Minecraft").log(Level.SEVERE, information);
	}

	/**
	 * Log warning information to the minecraft server console
	 * @param information The warning information to log
	 */
	public void logWarning(String information) {
		Logger.getLogger("Minecraft").log(Level.WARNING, information);
	}

	/**
	 * Check if an entity is in the adventure world
	 * @param entity The entity execute the check with
	 * @return If the entity is in an adventure world or not
	 */
	public Boolean isInAdventure(Entity entity) {
		return entity.getWorld().getName() == "AdventureLand" ? true : false;
	}

	/**
	 * Check if a world is a adventure world
	 * @param entity The world name execute the check with
	 * @return If the entity is in an adventure world or not
	 */
	public Boolean isInAdventure(String worldName) {
		return worldName.equals("AdventureLand") ? true : false;
	}

	/**
	 * Check if an entity is in the survival world
	 * @param entity The entity execute the check with
	 * @return If the entity is in an survival world or not
	 */
	public Boolean isInSurvival(Entity entity) {
		return entity.getWorld().getName() == "SurvivalLand" || entity.getWorld().getName() == "SurvivalLandNether" ? true : false;
	}

	/**
	 * Check if a world is a survival world
	 * @param worldName The world name to execute the check with
	 * @return If the world is a survival world or not
	 */
	public Boolean isInSurvival(String worldName) {
		return worldName.equals("SurvivalLand") || worldName.equals("SurvivalLandNether") ? true : false;
	}

	/**
	 * Check if a string can be casted to an integer
	 * @param string The string to execute the cast check with
	 * @return If the string can be casted to an integer
	 */
	public Boolean isInteger(String string) {
		try {Integer.valueOf(string); return true;} catch (Exception exception) {return false;}
	}

	/**
	 * Check if a string can be casted to a double
	 * @param string The string to execute the cast check with
	 * @return If the string can be casted to a double
	 */
	public Boolean isDouble(String string) {
		try {Double.valueOf(string); return true;} catch (Exception exception) {return false;}
	}

	/**
	 * Check if a string can be casted to a byte
	 * @param string The string to execute the cast check with
	 * @return If the string can be casted to a byte
	 */
	public Boolean isByte(String string) {
		try {Byte.valueOf(string); return true;} catch (Exception exception) {return false;}
	}

	/**
	 * Returns a player profile for the command sender
	 * @param sender The sender to fetch the profile of
	 * @return The player profile of the sender
	 */
	public PlayerProfile getProfile(CommandSender sender) {
		return playerProfiles.get(sender.getName().toLowerCase());
	}

	/**
	 * Returns a player profile for the player
	 * @param player The player name to fetch the profile of
	 * @return The player profile of the player
	 */
	public PlayerProfile getProfile(String player) {
		if (playerProfiles.containsKey(getPlayer(player).getName().toLowerCase())) return playerProfiles.get(getPlayer(player).getName().toLowerCase());
		return null;
	}

	/**
	 * Sends a message alert to the server owner
	 * @param alert The message
	 */
	public void alertOwner(String alert) {
		Player player = getServer().getPlayer("EvilPeanut");
		if (player != null) player.sendMessage("§7Alert: §O" + alert);
	}

	/**
	 * Returns a player from the player name
	 * @param name The name of the player
	 * @return The player
	 */
	public Player getPlayer(String name) {
		try {
			if (getServer().getPlayer(name) != null) return getServer().getPlayer(name);
			for (Player player : getServer().getOnlinePlayers()) {
				if (player.getName().toLowerCase().startsWith(name.toLowerCase())) return player;
			}
			for (int i = 0; i != playerProfiles.size(); i++) {
				if (((PlayerProfile)playerProfiles.values().toArray()[i]).nameAlias.toLowerCase().startsWith(name.toLowerCase())) return getServer().getPlayer(playerProfiles.keySet().toArray()[i].toString());
			}
			return null;
		} catch (Exception exception) {
			exception.printStackTrace();
			return null;
		}
	}

	/**
	 * Returns if a location is in a region
	 * @param region The region to execute the check with
	 * @param loc The location to execute the check with
	 * @return If the location is inside the region
	 */
	public Boolean isInRegion(Region region, Location loc) {
		if (region.getLocationA().getWorld().getName().equals(loc.getWorld().getName()) == false) return false;
		if (isInRegionXRange(region, loc) && isInRegionYRange(region, loc) && isInRegionZRange(region, loc)) return true;
		return false;
	}

	/**
	 * Returns if the region is protected or not for the player
	 * @param player The player to execute the check with
	 * @param loc The location to execute the check with
	 * @return If the location is in a protected region which the player doesn't have rights to
	 */
	public Boolean isInProtectedRegion(Location loc, Player player) {
		if (getProfile(player).rank.isAdmin()) return false;
		for (Region region : regionList) {
			if (region.isProtected() == false) continue;
			if (region.getOwner().equals(player.getName()) || region.getAllowedPlayers().contains(player.getName())) continue;
			if (region.getLocationA().getWorld().getName().equals(loc.getWorld().getName()) == false) continue;
			if (isInRegionXRange(region, loc)) {
				if (isInRegionYRange(region, loc)) {
					if (isInRegionZRange(region, loc)) {
						return true;
					}
				}
			}
		}
		return false;
	}

	/**
	 * Returns if the player is in the region's X range or not
	 * @param region The region to execute the check with
	 * @param location The location to execute the check with
	 * @return If the location is in the region's X range
	 */
	static Boolean isInRegionXRange(Region region, Location location) {
		if (region.getLocationA().getBlockX() <= region.getLocationB().getBlockX()) {
			if (location.getBlockX() >= region.getLocationA().getBlockX() && location.getBlockX() <= region.getLocationB().getBlockX()) return true;
		} else if (region.getLocationA().getBlockX() >= region.getLocationB().getBlockX()) {
			if (location.getBlockX() <= region.getLocationA().getBlockX() && location.getBlockX() >= region.getLocationB().getBlockX()) return true;
		}
		return false;
	}

	/**
	 * Returns if the player is in the region's Y range or not
	 * @param region The region to execute the check with
	 * @param location The location to execute the check with
	 * @return If the location is in the region's Y range
	 */
	static Boolean isInRegionYRange(Region region, Location playerLocation) {
		if (region.getLocationA().getBlockY() <= region.getLocationB().getBlockY()) {
			if (playerLocation.getBlockY() >= region.getLocationA().getBlockY() && playerLocation.getBlockY() <= region.getLocationB().getBlockY()) return true;
		} else if (region.getLocationA().getBlockY() >= region.getLocationB().getBlockY()) {
			if (playerLocation.getBlockY() <= region.getLocationA().getBlockY() && playerLocation.getBlockY() >= region.getLocationB().getBlockY()) return true;
		}
		return false;
	}

	/**
	 * Returns if the player is in the region's Z range or not
	 * @param region The region to execute the check with
	 * @param location The location to execute the check with
	 * @return If the location is in the region's Z range
	 */
	static Boolean isInRegionZRange(Region region, Location playerLocation) {
		if (region.getLocationA().getBlockZ() <= region.getLocationB().getBlockZ()) {
			if (playerLocation.getBlockZ() >= region.getLocationA().getBlockZ() && playerLocation.getBlockZ() <= region.getLocationB().getBlockZ()) return true;
		} else if (region.getLocationA().getBlockZ() >= region.getLocationB().getBlockZ()) {
			if (playerLocation.getBlockZ() <= region.getLocationA().getBlockZ() && playerLocation.getBlockZ() >= region.getLocationB().getBlockZ()) return true;
		}
		return false;
	}

	/**
	 * Return the entity type from the entity type name
	 * @param name The name of the entity type
	 * @return The entity type
	 */
	public EntityType getEntity(String name) {
		if (EntityType.fromName(name) != null) return EntityType.fromName(name);
		try {if (EntityType.fromId(Integer.valueOf(name)) != null) return EntityType.fromId(Integer.valueOf(name));} catch (Exception exception) {}
		if (name.equalsIgnoreCase("mooshroom")) return EntityType.MUSHROOM_COW;
		if (name.equalsIgnoreCase("ocelot") || name.equalsIgnoreCase("cat")) return EntityType.OCELOT;
		if (name.equalsIgnoreCase("zombiepigman")) return EntityType.PIG_ZOMBIE;
		if (name.equalsIgnoreCase("dog")) return EntityType.WOLF;
		if (name.equalsIgnoreCase("magmacube")) return EntityType.MAGMA_CUBE;
		if (name.equalsIgnoreCase("witherskeleton")) return EntityType.WITHER_SKULL;
		if (name.equalsIgnoreCase("snowgolem")) return EntityType.SNOWMAN;
		if (name.equalsIgnoreCase("irongolem") || name.equalsIgnoreCase("ironman")) return EntityType.IRON_GOLEM;
		if (name.equalsIgnoreCase("wither")) return EntityType.WITHER;
		if (name.equalsIgnoreCase("firework")) return EntityType.FIREWORK;
		if (name.equalsIgnoreCase("lightning")) return EntityType.LIGHTNING;
		if (name.equalsIgnoreCase("tnt")) return EntityType.PRIMED_TNT;
		return null;
	}

	/**
	 * Return the enchantment from the enchantment name
	 * @param name The name of the enchantment
	 * @return The enchantment
	 */
	public Enchantment getEnchantment(String name) {
		if (Enchantment.getByName(name) != null) return Enchantment.getByName(name);
		try {if (Enchantment.getById(Integer.valueOf(name)) != null) return Enchantment.getById(Integer.valueOf(name));} catch (Exception exception) {}
		if (name.equalsIgnoreCase("power")) return Enchantment.ARROW_DAMAGE;
		if (name.equalsIgnoreCase("flame")) return Enchantment.ARROW_FIRE;
		if (name.equalsIgnoreCase("infinity")) return Enchantment.ARROW_INFINITE;
		if (name.equalsIgnoreCase("punch")) return Enchantment.ARROW_KNOCKBACK;
		if (name.equalsIgnoreCase("sharpness")) return Enchantment.DAMAGE_ALL;
		if (name.equalsIgnoreCase("baneofarthropods") || name.equalsIgnoreCase("bane")) return Enchantment.DAMAGE_ARTHROPODS;
		if (name.equalsIgnoreCase("smite")) return Enchantment.DAMAGE_UNDEAD;
		if (name.equalsIgnoreCase("efficiency")) return Enchantment.DIG_SPEED;
		if (name.equalsIgnoreCase("unbreaking")) return Enchantment.DURABILITY;
		if (name.equalsIgnoreCase("fireaspect")) return Enchantment.FIRE_ASPECT;
		if (name.equalsIgnoreCase("knockback")) return Enchantment.KNOCKBACK;
		if (name.equalsIgnoreCase("fortune")) return Enchantment.LOOT_BONUS_BLOCKS;
		if (name.equalsIgnoreCase("looting")) return Enchantment.LOOT_BONUS_MOBS;
		if (name.equalsIgnoreCase("respiration")) return Enchantment.OXYGEN;
		if (name.equalsIgnoreCase("protection")) return Enchantment.PROTECTION_ENVIRONMENTAL;
		if (name.equalsIgnoreCase("blastprotection")) return Enchantment.PROTECTION_EXPLOSIONS;
		if (name.equalsIgnoreCase("featherfalling")) return Enchantment.PROTECTION_FALL;
		if (name.equalsIgnoreCase("fireprotection")) return Enchantment.PROTECTION_FIRE;
		if (name.equalsIgnoreCase("projectileprotection")) return Enchantment.PROTECTION_PROJECTILE;
		if (name.equalsIgnoreCase("silktouch")) return Enchantment.SILK_TOUCH;
		if (name.equalsIgnoreCase("thorns")) return Enchantment.THORNS;
		if (name.equalsIgnoreCase("aquaaffinity")) return Enchantment.WATER_WORKER;
		return null;
	}

	/**
	 * Returns a colorized string
	 * @param string The string to colorize
	 * @return The colorized string
	 */
	public String colorizeString(String string) {
		String name = "";
		int color = 0;
		for (char c : string.toCharArray()) {
			if (color == 0) name += "§a" + c;
			if (color == 1) name += "§b" + c;
			if (color == 2) name += "§c" + c;
			if (color == 3) name += "§d" + c;
			if (color == 4) {
				name += "§e" + c;
				color = 0;
			} else {
				color++;
			}
		}
		return name;
	}

	/**
	 * Returns an itemstack of a book
	 * @param title The title of the book
	 * @param author The author of the book
	 * @param text The text in the book
	 * @return The book itemstack
	 */
	public ItemStack getBook(String title, String author, List<String> text) {
		ItemStack book = new ItemStack(Material.WRITTEN_BOOK);
		BookMeta meta = (BookMeta)book.getItemMeta();
		meta.setTitle(title);
		meta.setAuthor(author);
		meta.setPages(text);
		book.setItemMeta(meta);
		return book;
	}

	/**
	 * Returns the minecraft world time
	 * @param world The world to obtain the time of
	 * @return The time of the minecraft world
	 */
	public String getTime(World world) {
		return (int)(Math.floor(world.getTime() / 1000)) + ":" + ((int) ((world.getTime() % 1000) / 1000.0 * 60) < 10 ? "0" + (int) ((world.getTime() % 1000) / 1000.0 * 60) : (int) ((world.getTime() % 1000) / 1000.0 * 60));
	}

	/**
	 * Returns a string with characters replaced with other specified characters ignoring case on replacement
	 * @param text The text
	 * @param search The search word to replace
	 * @param replacement The world to replace with
	 * @return The string after all instances of the search word, ignoring case, are replaced
	 */
	public String replaceAllIgnoreCase(final String text, final String search, final String replacement){
		if(search.equals(replacement)) return text;
		final StringBuffer buffer = new StringBuffer(text);
		final String lowerSearch = search.toLowerCase();
		int i = 0;
		int prev = 0;
		while((i = buffer.toString().toLowerCase().indexOf(lowerSearch, prev)) > -1){
			buffer.replace(i, i+search.length(), replacement);
			prev = i + replacement.length();
		}
		return buffer.toString();
	}

	/**
	 * Returns a string number as roman numerals
	 * @param number The number to convert into roman numerals
	 * @return The string number as roman numerals
	 */
	public String toRomanNumerals(String number) {
		if (number.equals("1")) return "I";
		if (number.equals("2")) return "II";
		if (number.equals("3")) return "III";
		if (number.equals("4")) return "IV";
		if (number.equals("5")) return "V";
		return null;
	}

	/**
	 * Returns a formatted string
	 * @param text The text to format
	 * @return The formatted string
	 */
	public String toFormattedString(String text) {
		//
		// Color formatting
		//
		if (text.contains("&")) {
			text = replaceAllIgnoreCase(text, "&a", "§a");
			text = replaceAllIgnoreCase(text, "&b", "§b");
			text = replaceAllIgnoreCase(text, "&c", "§c");
			text = replaceAllIgnoreCase(text, "&d", "§d");
			text = replaceAllIgnoreCase(text, "&e", "§e");
			text = replaceAllIgnoreCase(text, "&f", "§f");
			text = replaceAllIgnoreCase(text, "&k", "§k");
			text = replaceAllIgnoreCase(text, "&l", "§l");
			text = replaceAllIgnoreCase(text, "&m", "§m");
			text = replaceAllIgnoreCase(text, "&n", "§n");
			text = replaceAllIgnoreCase(text, "&o", "§o");
			text = replaceAllIgnoreCase(text, "&r", "§r");
			text = text.replaceAll("&0", "§0");
			text = text.replaceAll("&1", "§1");
			text = text.replaceAll("&2", "§2");
			text = text.replaceAll("&3", "§3");
			text = text.replaceAll("&4", "§4");
			text = text.replaceAll("&5", "§5");
			text = text.replaceAll("&6", "§6");
			text = text.replaceAll("&7", "§7");
			text = text.replaceAll("&8", "§8");
			text = text.replaceAll("&9", "§9");
		}
		return text;
	}

	/**
	 * Returns the weather state in the blocks biome as a string
	 * @param block The block to get the weather data from
	 * @return The weather state as a string at the block
	 */
	public String getWeather(Block block) {
		if (block.getWorld().hasStorm() && block.getWorld().isThundering() && block.getBiome() != Biome.FROZEN_OCEAN && block.getBiome() != Biome.FROZEN_RIVER && block.getBiome() != Biome.ICE_MOUNTAINS && block.getBiome() != Biome.ICE_PLAINS && block.getBiome() != Biome.TAIGA && block.getBiome() != Biome.TAIGA_HILLS) return "Lightning";
		if (block.getWorld().hasStorm() && (block.getBiome() == Biome.FROZEN_OCEAN || block.getBiome() == Biome.FROZEN_RIVER || block.getBiome() == Biome.ICE_MOUNTAINS || block.getBiome() == Biome.ICE_PLAINS || block.getBiome() == Biome.TAIGA || block.getBiome() == Biome.TAIGA_HILLS)) return "Snow";
		if (block.getWorld().hasStorm()) return "Rain";
		return "Sunny";
	}

	//TODO: Implement H2 version of this
	/**
	 * Log a hanging entity break
	 * @param entity The hanging entity to log
	 * @param playerName The player's name who broke the block
	 */
	//public void logHangingEntityBreak(Entity entity, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶EntityTypeID¶EntityDirection
	//writeFileNewLine("plugins/EvilBook/Protection/" + entity.getWorld().getName() + "," + entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + ".txt", entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + "¶" + playerName + "¶" + entity.getWorld().getName() + "¶4¶" + entity.getType().getTypeId() + "¶" + entity.getLocation().getDirection());
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + "¶" + playerName + "¶" + entity.getWorld().getName() + "¶4¶" + entity.getType().getTypeId() + "¶" + entity.getLocation().getDirection());
	//}

	/**
	 * Log a hanging entity place
	 * @param entity The hanging entity to log
	 * @param playerName The player's name who placed the block
	 */
	//public void logHangingEntityPlace(Entity entity, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶EntityTypeID¶EntityDirection
	//writeFileNewLine("plugins/EvilBook/Protection/" + entity.getWorld().getName() + "," + entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + ".txt", entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + "¶" + playerName + "¶" + entity.getWorld().getName() + "¶5¶" + entity.getType().getTypeId() + "¶" + entity.getLocation().getDirection());
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", entity.getLocation().getBlockX() + "," + entity.getLocation().getBlockY() + "," + entity.getLocation().getBlockZ() + "¶" + playerName + "¶" + entity.getWorld().getName() + "¶5¶" + entity.getType().getTypeId() + "¶" + entity.getLocation().getDirection());	
	//}

	/**
	 * Log a block break
	 * @param block The block to log
	 * @param playerName The player's name who broke the block
	 */
	//public void logBlockBreak(Block block, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶BlockTypeID¶BlockData
	//writeFileNewLine("plugins/EvilBook/Protection/" + block.getWorld().getName() + "," + block.getX() + "," + block.getY() + "," + block.getZ() + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶0¶" + block.getTypeId() + "¶" + block.getData());
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶0¶" + block.getTypeId() + "¶" + block.getData());
	//}

	/**
	 * Log a block place
	 * @param block The block to log
	 * @param playerName The player's name who placed the block
	 */
	//public void logBlockPlace(Block block, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶BlockTypeID¶BlockData
	//writeFileNewLine("plugins/EvilBook/Protection/" + block.getWorld().getName() + "," + block.getX() + "," + block.getY() + "," + block.getZ() + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶1¶" + block.getTypeId() + "¶" + block.getData());
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶1¶" + block.getTypeId() + "¶0");
	//}

	/**
	 * Log a liquid placement
	 * @param block The block to log
	 * @param liquidID The type ID of the liquid
	 * @param playerName The player's name who placed the liquid
	 */
	//public void logLiquidPlace(Block block, int liquidID, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶LiquidID¶BlockData
	//writeFileNewLine("plugins/EvilBook/Protection/" + block.getWorld().getName() + "," + block.getX() + "," + block.getY() + "," + block.getZ() + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶2¶" + liquidID + "¶0");
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", block.getX() + "," + block.getY() + "," + block.getZ() + "¶" + playerName + "¶" + block.getWorld().getName() + "¶2¶" + liquidID + "¶0");
	//}

	/**
	 * Log a sign break
	 * @param sign The sign to log
	 * @param block The block to log
	 * @param playerName The player's name who broke the block
	 */
	//public void logSignBreak(Sign sign, Block block, String playerName) {
	// X,Y,Z¶PlayerName¶WorldName¶EditID¶BlockTypeID¶BlockData¶BlockDirection¶Line1¶Line2¶Line3¶Line4
	//String[] signLine = new String[4];
	//signLine[0] = sign.getLine(0);
	//signLine[1] = sign.getLine(1);
	//signLine[2] = sign.getLine(2);
	//signLine[3] = sign.getLine(3);
	//writeFileNewLine("plugins/EvilBook/Protection/" + playerName + ".txt", sign.getX() + "," + sign.getY() + "," + sign.getZ() + "¶" + playerName + "¶" + sign.getWorld().getName() + "¶3¶" + sign.getTypeId() + "¶0¶" + ((Directional) block.getType().getNewData(block.getData())).getFacing().toString() + "¶" + signLine[0] + "¶" + signLine[1] + "¶" + signLine[2] + "¶" + signLine[3]);
	//writeFileNewLine("plugins/EvilBook/Protection/" + sign.getWorld().getName() + "," + sign.getX() + "," + sign.getY() + "," + sign.getZ() + ".txt", sign.getX() + "," + sign.getY() + "," + sign.getZ() + "¶" + playerName + "¶" + sign.getWorld().getName() + "¶3¶" + sign.getTypeId() + "¶0¶" + ((Directional) block.getType().getNewData(block.getData())).getFacing().toString() + "¶" + signLine[0] + "¶" + signLine[1] + "¶" + signLine[2] + "¶" + signLine[3]);
	//}

	/**
	 * Return the location of a logged block
	 * @param line The logged line containing the block information
	 * @return The location of the logged block
	 */
	//public Location getLogBlockLocation(String line) {
	//return new Location(getServer().getWorld(line.split("¶")[2]), Double.valueOf(line.split(",")[0]), Double.valueOf(line.split(",")[1]), Double.valueOf(line.split(",")[2].split("¶")[0]));
	//}

	/**
	 * Return the editor's name of a logged block
	 * @param line The logged line containing the block information
	 * @return The editor's name of the logged block
	 */
	//public String getLogBlockEditor(String line) {
	//	return line.split("¶")[1];
	//}

	/**
	 * Return the edit ID of a logged block
	 * @param line The logged line containing the block information
	 * @return The edit ID of the logged block
	 */
	//public byte getLogBlockEditID(String line) {
	//return Byte.valueOf(line.split("¶")[3]);
	//}

	/**
	 * Return the type ID of a logged block
	 * @param line The logged line containing the block information
	 * @return The type ID of the logged block
	 */
	//public short getLogBlockTypeID(String line) {
	//	return Short.valueOf(line.split("¶")[4]);
	//}

	/**
	 * Return the data of a logged block
	 * @param line The logged line containing the block information
	 * @return The data of the logged block
	 */
	//public byte getLogBlockData(String line) {
	//return Byte.valueOf(line.split("¶")[5]);
	//}

	/**
	 * Return the direction of a logged block
	 * @param line The logged line containing the block information
	 * @return The direction of the logged block
	 */
	//public BlockFace getLogBlockDirection(String line) {
	//return BlockFace.valueOf(line.split("¶")[6]);
	//}

	/**
	 * Return the extra argument one of a logged block
	 * @param line The logged line containing the block information
	 * @return The extra argument one of the logged block
	 */
	//public String getLogBlockArg1(String line) {
	//try {
	//return line.split("¶")[7];
	//} catch (Exception exception) {
	//return "";
	//}
	//}

	/**
	 * Return the extra argument two of a logged block
	 * @param line The logged line containing the block information
	 * @return The extra argument two of the logged block
	 */
	//public String getLogBlockArg2(String line) {
	//try {
	//return line.split("¶")[8];
	//} catch (Exception exception) {
	//return "";
	//}
	//}

	/**
	 * Return the extra argument three of a logged block
	 * @param line The logged line containing the block information
	 * @return The extra argument three of the logged block
	 */
	//public String getLogBlockArg3(String line) {
	//try {
	//return line.split("¶")[9];
	//} catch (Exception exception) {
	//return "";
	//}
	//}

	/**
	 * Return the extra argument four of a logged block
	 * @param line The logged line containing the block information
	 * @return The extra argument four of the logged block
	 */
	//public String getLogBlockArg4(String line) {
	//try {
	//return line.split("¶")[10];
	//} catch (Exception exception) {
	//return "";
	//}
	//}

	/**
	 * Return an array of strings with the blocks edits
	 * @param block The block to gather the logging information on
	 * @return The logging information for the block
	 */
	//public List<String> getLogBlockInformation(Block block) {
	//List<String> info = new ArrayList<String>();
	//try {
	//BufferedReader br = new BufferedReader(new FileReader("plugins/EvilBook/Protection/" + block.getWorld().getName() + "," + block.getX() + "," + block.getY() + "," + block.getZ() + ".txt"));
	//String strLine = null;
	//while ((strLine = br.readLine()) != null) {
	//if (getLogBlockEditID(strLine) == 5) info.add("§e" + getLogBlockEditor(strLine) + " §fplaced entity " + hangingEntityList.get((byte)getLogBlockTypeID(strLine)).toLowerCase());
	//if (getLogBlockEditID(strLine) == 4) info.add("§e" + getLogBlockEditor(strLine) + " §fbroke entity " + hangingEntityList.get((byte)getLogBlockTypeID(strLine)).toLowerCase());
	//if (getLogBlockEditID(strLine) == 3) info.add("§e" + getLogBlockEditor(strLine) + " §fbroke sign");
	//if (getLogBlockEditID(strLine) == 2) info.add("§e" + getLogBlockEditor(strLine) + " §fplaced liquid " + blockList.get(getLogBlockTypeID(strLine)).get(0).toLowerCase());
	//if (getLogBlockEditID(strLine) == 1) info.add("§e" + getLogBlockEditor(strLine) + " §fplaced block " + blockList.get(getLogBlockTypeID(strLine)).get(0).toLowerCase());
	//if (getLogBlockEditID(strLine) == 0) info.add("§e" + getLogBlockEditor(strLine) + " §fbroke block " + blockList.get(getLogBlockTypeID(strLine)).get(0).toLowerCase());
	//}
	//br.close();
	//} catch (Exception exception) {}
	//return info;
	//}

	/**
	 * Rollback a player's edits
	 * @param player The player executing the rollback
	 * @param badPlayer The player to rollback
	 */
	//public void rollbackEdits(Player player, String badPlayer) {
	//player.sendMessage("§7Rolling back " + badPlayer);
	//try {
	//BufferedReader br = new BufferedReader(new FileReader("plugins/EvilBook/Protection/" + badPlayer + ".txt"));
	//String brLine;
	//while ((brLine = br.readLine()) != null) {
	//if (getLogBlockEditID(brLine) == 0) if (getLogBlockTypeID(brLine) != 0) getLogBlockLocation(brLine).getBlock().setTypeIdAndData(getLogBlockTypeID(brLine), getLogBlockData(brLine), false);
	//if (getLogBlockEditID(brLine) == 1 || getLogBlockEditID(brLine) == 2) getLogBlockLocation(brLine).getBlock().setTypeId(0);
	//if (getLogBlockEditID(brLine) == 3) {
	//	getLogBlockLocation(brLine).getBlock().setTypeIdAndData(getLogBlockTypeID(brLine), getLogBlockData(brLine), false);
	//	Sign sign = (Sign) getLogBlockLocation(brLine).getBlock().getState();
	//		org.bukkit.material.Sign matSign =  new org.bukkit.material.Sign();
	//		matSign.setFacingDirection(getLogBlockDirection(brLine));
	//		sign.setData(matSign);
	//		sign.setLine(0, getLogBlockArg1(brLine));
	//		sign.setLine(1, getLogBlockArg2(brLine));
	//		sign.setLine(2, getLogBlockArg3(brLine));
	//		sign.setLine(3, getLogBlockArg4(brLine));
	//		sign.update(true);
	//		}
	//	}
	//	br.close();
	//	player.sendMessage("§7Rolled back " + badPlayer);
	//	} catch (Exception exception) {
	//		player.sendMessage("§7Nothing to rollback");
	//	}
	//	}

	/**
	 * Append text to a file
	 * @param file The file
	 * @param text The text to append
	 */
	public void writeFileNewLine(String file, String text) {
		try {
			BufferedWriter writer = new BufferedWriter(new FileWriter(file, true));
			writer.write(text) ;
			writer.newLine();
			writer.close() ;
		} catch (Exception exception) {
			logSevere("Failed To Write To File " + file);
		}
	}

	/**
	 * Save an object to a file
	 * @param obj The object to save
	 * @param path The path of the file to save to
	 */
	public void saveObject(Object obj, String path) throws Exception {
		ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(path));
		oos.writeObject(obj);
		oos.flush();
		oos.close();
	}

	/**
	 * Load an object from a file
	 * @param path The path of the file to load from
	 * @return The object loaded from the file
	 */
	public Object loadObject(String path) throws Exception {
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(path));
		Object result = ois.readObject();
		ois.close();
		return result;
	}

	/**
	 * Update the online player web statistic
	 * @param onlinePlayers The number of online players
	 */
	public void updateWebPlayerStatistics(int onlinePlayers) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter("C:/Program Files (x86)/Apache Software Foundation/Apache2.2/htdocs/playerStats.htm"));
			out.write("<html><body style='background:transparent'><p style='color:#31AFF5;text-align:center;font-family:Calibri'>" + onlinePlayers + " Players online<p></body></html>");
			out.close();
		} catch (Exception exception) {
			exception.printStackTrace();
		}
	}

	/**
	 * Return if a player profile exists
	 * @param playerName The player name to execute the check with
	 * @return If the player's profile is existant
	 */
	public boolean isProfileExistant(String playerName) {
		return new File("plugins/EvilBook/Players/" + playerName + ".properties").exists();
	}

	/**
	 * Gets the players creative inventory and equips it
	 * @param player The player
	 */
	public void getCreativeInventory(Player player) {	
		/*
		try {
			SerializableInventory inv = new SerializableInventory(player.getInventory().getContents(), player.getInventory().getArmorContents());
			saveObject(inv, "inventory.inv");
		} catch (Exception exception) {
			e.printStackTrace();
		}
		 */
		player.getInventory().clear();
		player.getInventory().setArmorContents(new ItemStack[4]);
		try {
			SerializableInventory inv = (SerializableInventory) loadObject("plugins/EvilBook/Inventories/Creative/" + player.getName() + ".inv");
			player.getInventory().setContents(inv.getContents());
			player.getInventory().setArmorContents(inv.getArmorContents());
		} catch (Exception exception) {
			if (exception instanceof FileNotFoundException) return;
			logSevere("Failed to load player creative inventory: " + player.getName() + ".inv");
			exception.printStackTrace();
		}
	}

	/**
	 * Get the players survival inventory and equip it
	 * @param player The player
	 */
	public void getSurvivalInventory(Player player) {	
		player.getInventory().clear();
		player.getInventory().setArmorContents(new ItemStack[4]);
		try {
			SerializableInventory inv = (SerializableInventory) loadObject("plugins/EvilBook/Inventories/Survival/" + player.getName() + ".inv");
			player.getInventory().setContents(inv.getContents());
			player.getInventory().setArmorContents(inv.getArmorContents());
		} catch (Exception exception) {
			if (exception instanceof FileNotFoundException) return;
			logSevere("Failed to load player survival inventory: " + player.getName() + ".inv");
			exception.printStackTrace();
		}
	}

	/**
	 * Set the players creative inventory
	 * @param player The player
	 */
	public void setCreativeInventory(Player player) {
		try {
			saveObject(new SerializableInventory(player.getInventory().getContents(), player.getInventory().getArmorContents()), "plugins/EvilBook/Inventories/Creative/" + player.getName() + ".inv");
		} catch (Exception exception) {
			logSevere("Failed to save player creative inventory: " + player.getName() + ".inv");
			exception.printStackTrace();
		}
	}

	/**
	 * Set the players survival inventory
	 * @param player The player
	 */
	public void setSurvivalInventory(Player player) {
		try {
			saveObject(new SerializableInventory(player.getInventory().getContents(), player.getInventory().getArmorContents()), "plugins/EvilBook/Inventories/Survival/" + player.getName() + ".inv");
		} catch (Exception exception) {
			logSevere("Failed to save player survival inventory: " + player.getName() + ".inv");
			exception.printStackTrace();
		}
	}

	/**
	 * Get a property of an offline player's profile
	 * @param player The player name
	 * @param property The property name
	 * @return The property value
	 */
	public String getOfflineProperty(String player, String property) {
		Properties prop = new Properties("plugins/EvilBook/Players/" + player + ".properties");
		return prop.getProperty(property);
	}

	/**
	 * Set a property of an offline player's profile
	 * @param player The player name
	 * @param property The property name
	 * @param value The new value of the property
	 */
	public void setOfflineProperty(String player, String property, String value) {
		Properties prop = new Properties("plugins/EvilBook/Players/" + player + ".properties");
		prop.setProperty(property, value);
		prop.save();
	}

	/**
	 * Protect a container (Chest, furnace & brewing stand ect...) in the survival world
	 * @param location The position of the container in the world
	 * @param player The player owner of the container
	 */
	public void protectContainer(Location location, Player player) {
		Properties protectionProp = new Properties("plugins/EvilBook/ContainerProtection.db");
		protectionProp.setProperty(location.getBlockX() + ":" + location.getBlockY() + ":" + location.getBlockZ(), player.getName());
		protectionProp.save();
	}

	/**
	 * Unprotect a container (Chest, furnace & brewing stand ect...) in the survival world
	 * @param location The position of the container in the world
	 */
	public void unprotectContainer(Location location) {
		Properties protectionProp = new Properties("plugins/EvilBook/ContainerProtection.db");
		protectionProp.removeProperty(location.getBlockX() + ":" + location.getBlockY() + ":" + location.getBlockZ());
		protectionProp.save();
	}

	/**
	 * Return if the container (Chest, furnace & brewing stand ect...) is protected to the player
	 * @param location The position of the container in the world
	 * @param player The player to execute the check with
	 * @return If the container is protected to the player
	 */
	public Boolean isContainerProtected(Location location, Player player) {
		Properties protectionProp = new Properties("plugins/EvilBook/ContainerProtection.db");
		String protection = protectionProp.getProperty(location.getBlockX() + ":" + location.getBlockY() + ":" + location.getBlockZ());
		return protection == null || protection.equals(player.getName()) ? false : true;
	}

	/**
	 * Return the block material from an argument
	 * @param block The argument containing the block ID or name
	 * @return The block material or null if it can't be found
	 */
	public Material getBlockMaterial(String block) {
		int blockID = 0;
		for(Entry<Material, List<String>> entry : blockList.entrySet()) {
			if (isInteger(block) && Integer.valueOf(block) == blockID) return entry.getKey();
			for (String subItem : entry.getValue()) {
				if (block.equalsIgnoreCase(subItem)) {
					return entry.getKey();
				}
			}
			blockID++;
		}
		return null;
	}

	/**
	 * Return the value of a private world property
	 * @param worldName The name of the private world
	 * @param property The property to fetch the value of
	 * @return The value of the private world property
	 */
	public String getPrivateWorldProperty(String worldName, String property) {
		return new Properties("plugins/EvilBook/Private worlds/" + worldName + "/Config.properties").getProperty(property);
	}

	/**
	 * Set the value of a private world property
	 * @param worldName The name of the private world
	 * @param property The property to set the value of
	 * @param value The value of the property
	 */
	public void setPrivateWorldProperty(String worldName, String property, String value) {
		Properties prop = new Properties("plugins/EvilBook/Private worlds/" + worldName + "/Config.properties");
		prop.setProperty(property, value);
		prop.save();
	}

	/**
	 * Broadcasts a player message to other players
	 * Warning: This makes use of the mute functionality
	 * @param message The message to broadcast
	 */
	public void broadcastPlayerMessage(String playerName, String message) {
		for (Player p : getServer().getOnlinePlayers()) {
			if (getProfile(p).mutedPlayers.contains(playerName.toLowerCase()) == false) {
				p.sendMessage(message);
			}
		}
	}
}
