package me.evilpeanut;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.material.MaterialData;

//TODO: Allow admins to use EvilEdit in survival provided they have the required blocks
public class EvilEdit {
	public List<EvilEditBlock> editBlockList = new ArrayList<>();
	private EvilBook plugin;
	
	public EvilEdit(EvilBook evilBook) {
		plugin = evilBook;
	}
	
	public void regenerateChunk(Player player) {
		if (plugin.isInSurvival(player)) {
			player.sendMessage("7EvilEdit can't be used in survival");
		} else {
			plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
			for (int x = 0; x <= 16; x++)
			{
				for (int z = 0; z <= 16; z++)
				{
					for (int y = 0; y <= 256; y++)
					{
						int realX = ((player.getLocation().getBlockX() / 16) * 16) + x;
						int realZ = ((player.getLocation().getBlockZ() / 16) * 16) + z;
						//TODO: Re-add support for material data
						plugin.getProfile(player).EvilEditUndo.add(new EvilEditBlock(player.getWorld().getBlockAt(realX, y, realZ).getType(), new MaterialData(player.getWorld().getBlockAt(realX, y, realZ).getType()), new Location(player.getWorld(), realX, y, realZ)));
					}
				}
			}
			if (player.getWorld().regenerateChunk(player.getLocation().getBlockX() / 16, player.getLocation().getBlockZ() / 16)) {
				player.sendMessage("7Regenerated chunks");
			} else {
				player.sendMessage("7Failed to regenerate chunks");
			}
		}
	}
	
	public void drainArea(Player player, String[] args) {
		if (args.length != 0) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/drain");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to drain");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only drain up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							if (player.getWorld().getBlockAt(x, y, z).getType() != Material.WATER && player.getWorld().getBlockAt(x, y, z).getType() != Material.STATIONARY_WATER && player.getWorld().getBlockAt(x, y, z).getType() != Material.LAVA && player.getWorld().getBlockAt(x, y, z).getType() != Material.STATIONARY_LAVA) continue;
							setBlock(player, new Location(player.getWorld(), x, y, z), Material.AIR, new MaterialData(Material.AIR));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void hollowArea(Player player, String[] args) {
		if (args.length != 0) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/hollow");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to hollow");
		} else {
	        try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
		        	player.sendMessage("7You can only hollow up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
		        	player.sendMessage("7Rank-up to lift this limit");
					return;
		        }
		        plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
		        for (int x = bottomBlockX; x <= topBlockX; x++)
		        {
		            for (int z = bottomBlockZ; z <= topBlockZ; z++)
		            {
		                for (int y = bottomBlockY; y <= topBlockY; y++)
		                {
		                	if (x != bottomBlockX && x != topBlockX && z != bottomBlockZ && z != topBlockZ && y != bottomBlockY && y != topBlockY) {
		                		setBlock(player, new Location(player.getWorld(), x, y, z), Material.AIR, new MaterialData(Material.AIR));
		                	}
		                }
		            }
		        }
	        } catch (Exception exception) {
	        	exception.printStackTrace();
	        }
		}
	}
	
	public void outlineArea(Player player, String[] args) {
		if (args.length != 1 && args.length != 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/outline [blockID / blockName]");
			player.sendMessage("d/outline [blockID / blockName] <blockData>");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to outline");
		} else {
	        try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
		        	player.sendMessage("7You can only outline up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
		        	player.sendMessage("7Rank-up to lift this limit");
					return;
		        }
		        Material blockMaterial = plugin.getBlockMaterial(args[0]);
				if (blockMaterial == null) {
					player.sendMessage("7Please enter a valid block name");
					return;
				}
		        plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
		        for (int x = bottomBlockX; x <= topBlockX; x++)
		        {
		            for (int z = bottomBlockZ; z <= topBlockZ; z++)
		            {
		                for (int y = bottomBlockY; y <= topBlockY; y++)
		                {
		                	if (x == bottomBlockX || x == topBlockX || z == bottomBlockZ || z == topBlockZ || y == bottomBlockY || y == topBlockY) {
		                		// TODO: Re-add block material data support
				            	setBlock(player, new Location(player.getWorld(), x, y, z), blockMaterial, new MaterialData(blockMaterial));
		                	}
		                }
		            }
		        }
	        } catch (Exception exception) {
	        	exception.printStackTrace();
	        }
		}
	}
	
	public void wallArea(Player player, String[] args) {
		if (args.length != 1 && args.length != 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/walls [blockID / blockName]");
			player.sendMessage("d/walls [blockID / blockName] <blockData>");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to wall");
		} else {
	        try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
		        	player.sendMessage("7You can only wall up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
		        	player.sendMessage("7Rank-up to lift this limit");
					return;
		        }
		        Material blockMaterial = plugin.getBlockMaterial(args[0]);
				if (blockMaterial == null) {
					player.sendMessage("7Please enter a valid block name");
					return;
				}
		        plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
		        for (int x = bottomBlockX; x <= topBlockX; x++)
		        {
		            for (int z = bottomBlockZ; z <= topBlockZ; z++)
		            {
		                for (int y = bottomBlockY; y <= topBlockY; y++)
		                {
		                	if (x == bottomBlockX || x == topBlockX || z == bottomBlockZ || z == topBlockZ) {
		                		// TODO: Re-add block material data support
				            	setBlock(player, new Location(player.getWorld(), x, y, z), blockMaterial, new MaterialData(blockMaterial));
		                	}
		                }
		            }
		        }
	        } catch (Exception exception) {
	        	exception.printStackTrace();
	        }
		}
	}
	
	public void overlayArea(Player player, String[] args) {
		if (args.length != 1 && args.length != 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/overlay [blockID / blockName]");
			player.sendMessage("d/overlay [blockID / blockName] [blockData]");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to overlay");
		} else {
	        try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
		        int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
		        int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
		        if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
		        	player.sendMessage("7You can only overlay up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
		        	player.sendMessage("7Rank-up to lift this limit");
					return;
		        }
		        Material blockMaterial = plugin.getBlockMaterial(args[0]);
				if (blockMaterial == null) {
					player.sendMessage("7Please enter a valid block name");
					return;
				}
		        plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
		        for (int x = bottomBlockX; x <= topBlockX; x++)
		        {
		            for (int z = bottomBlockZ; z <= topBlockZ; z++)
		            {
		            	int highestY = player.getWorld().getHighestBlockYAt(x, z);
		            	// TODO: Re-add block material data support
		            	setBlock(player, new Location(player.getWorld(), x, highestY, z), blockMaterial, new MaterialData(blockMaterial));
		            }
		        }
	        } catch (Exception exception) {
	        	exception.printStackTrace();
	        }
		}
	}
	
	public void paste(Player player, String[] args) {
		if (plugin.isInSurvival(player)) {
			player.sendMessage("7EvilEdit can't be used in survival");
		} else if (args.length != 0) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/paste");
		} else if (plugin.getProfile(player).EvilEditCopy.size() == 0) {
			player.sendMessage("7Please copy an area of blocks before attempting paste");
		} else {
			try {
				int topBlockX = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockX();
				int bottomBlockX = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockX();
				int topBlockY = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockY();
				int bottomBlockY = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockY();
				int topBlockZ = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockZ();
				int bottomBlockZ = plugin.getProfile(player).EvilEditCopy.get(0).getLocation().getBlockZ();
				for (EvilEditBlock block : plugin.getProfile(player).EvilEditCopy) {
					if (block.getLocation().getBlockX() > topBlockX) topBlockX = block.getLocation().getBlockX();
					if (block.getLocation().getBlockX() < bottomBlockX) bottomBlockX = block.getLocation().getBlockX();
					if (block.getLocation().getBlockY() > topBlockY) topBlockY = block.getLocation().getBlockY();
					if (block.getLocation().getBlockY() < bottomBlockY) bottomBlockY = block.getLocation().getBlockY();
					if (block.getLocation().getBlockZ() > topBlockZ) topBlockZ = block.getLocation().getBlockZ();
					if (block.getLocation().getBlockZ() < bottomBlockZ) bottomBlockZ = block.getLocation().getBlockZ();
				}
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int i = 0; i != plugin.getProfile(player).EvilEditCopy.size(); i++) {
					Location loc = new Location(player.getLocation().getWorld(), player.getLocation().getBlockX() - plugin.getProfile(player).EvilEditCopy.get(i).getLocation().getBlockX(), player.getLocation().getBlockY() - plugin.getProfile(player).EvilEditCopy.get(i).getLocation().getBlockY(), player.getLocation().getBlockZ() - plugin.getProfile(player).EvilEditCopy.get(i).getLocation().getBlockZ());
					// TODO: Re-add block material data support, i think...
					setBlock(player, loc, plugin.getProfile(player).EvilEditCopy.get(i).getType(), plugin.getProfile(player).EvilEditCopy.get(i).getData());
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void copy(Player player, String[] args) {
		if (args.length != 0) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/copy");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to copy");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only copy up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				plugin.getProfile(player).EvilEditCopy = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{ 
							// TODO: Re-add block material data support
							plugin.getProfile(player).EvilEditCopy.add(new EvilEditBlock(player.getWorld().getBlockAt(x, y, z).getType(), new Location(player.getWorld(), bottomBlockX - x, bottomBlockY - y, bottomBlockZ - z)));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void randomDeleteArea(Player player, String[] args) {
		if (args.length > 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/rdel");
			player.sendMessage("d/rdel [blockID / blockName]");
			player.sendMessage("d/rdel [blockID / blockName] [blockData]");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to randomly delete");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only randomly delete up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material deleteBlockMaterial = null;
				if (args.length >= 1) {
					deleteBlockMaterial = plugin.getBlockMaterial(args[0]);
					if (deleteBlockMaterial == null) {
						player.sendMessage("7Please enter a valid block name or ID");
						return;
					}
				}
				Random randomizer = new Random();
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							if (randomizer.nextBoolean() && (args.length == 0 || new Location(player.getWorld(), x, y, z).getBlock().getType() == deleteBlockMaterial)) setBlock(player, new Location(player.getWorld(), x, y, z), Material.AIR, new MaterialData(Material.AIR));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void deleteArea(Player player, String[] args) {
		if (args.length > 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/del");
			player.sendMessage("d/del [blockID / blockName]");
			player.sendMessage("d/del [blockID / blockName] [blockData]");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to delete");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only delete up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material deleteBlockMaterial = null;
				if (args.length >= 1) {
					deleteBlockMaterial = plugin.getBlockMaterial(args[0]);
					if (deleteBlockMaterial == null) {
						player.sendMessage("7Please enter a valid block name or ID");
						return;
					}
				}
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							if (args.length == 0 || new Location(player.getWorld(), x, y, z).getBlock().getType() == deleteBlockMaterial) setBlock(player, new Location(player.getWorld(), x, y, z), Material.AIR, new MaterialData(Material.AIR));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void randomReplaceArea(Player player, String[] args) {
		if (args.length != 2 && args.length != 4) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/rreplace [blockID / blockName] [blockID / blockName]");
			player.sendMessage("d/rreplace [blockID / blockName] [blockData] [blockID / blockName] [blockData]");
		} else if (args.length == 4 && (!plugin.isByte(args[1]) || !plugin.isByte(args[3]))) {
			player.sendMessage("7Please enter valid block data values");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to randomly replace");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only randomly replace up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material oldBlockMaterial = plugin.getBlockMaterial(args[0]);
				Material newBlockMaterial = plugin.getBlockMaterial(args.length == 2 ? args[1] : args[2]);
				if (oldBlockMaterial == null || newBlockMaterial == null) {
					player.sendMessage("7Please enter valid block names or IDs");
					return;
				}
				Random randomizer = new Random();
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							if (randomizer.nextBoolean() && new Location(player.getWorld(), x, y, z).getBlock().getType() == oldBlockMaterial) setBlock(player, new Location(player.getWorld(), x, y, z), newBlockMaterial, new MaterialData(newBlockMaterial));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}
	
	public void replaceArea(Player player, String[] args) {
		if (args.length != 2 && args.length != 4) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/replace [blockID / blockName] [blockID / blockName]");
			player.sendMessage("d/replace [blockID / blockName] [blockData] [blockID / blockName] [blockData]");
		} else if (args.length == 4 && (!plugin.isByte(args[1]) || !plugin.isByte(args[3]))) {
			player.sendMessage("7Please enter valid block data values");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to replace");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only replace up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material oldBlockMaterial = plugin.getBlockMaterial(args[0]);
				Material newBlockMaterial = plugin.getBlockMaterial(args.length == 2 ? args[1] : args[2]);
				if (oldBlockMaterial == null || newBlockMaterial == null) {
					player.sendMessage("7Please enter valid block names or IDs");
					return;
				}
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							if (new Location(player.getWorld(), x, y, z).getBlock().getType() == oldBlockMaterial) setBlock(player, new Location(player.getWorld(), x, y, z), newBlockMaterial, new MaterialData(newBlockMaterial));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}

	public void randomFillArea(Player player, String[] args) {
		if (args.length != 1 && args.length != 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/rfill [blockID / blockName]");
			player.sendMessage("d/rfill [blockID / blockName] [blockData]");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to randomly fill");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only randomly fill up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material blockMaterial = plugin.getBlockMaterial(args[0]);
				if (blockMaterial == null) {
					player.sendMessage("7Please enter a valid block name or ID");
					return;
				}
				Random randomizer = new Random();
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							if (randomizer.nextBoolean()) setBlock(player, new Location(player.getWorld(), x, y, z), blockMaterial, new MaterialData(blockMaterial));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}

	public void fillArea(Player player, String[] args) {
		if (args.length != 1 && args.length != 2) {
			player.sendMessage("5Incorrect command usage");
			player.sendMessage("d/fill [blockID / blockName]");
			player.sendMessage("d/fill [blockID / blockName] [blockData]");
		} else if (args.length == 2 && !plugin.isByte(args[1])) {
			player.sendMessage("7Please enter a valid block data value");
		} else if (plugin.getProfile(player).actionLocationA == null || plugin.getProfile(player).actionLocationB == null) {
			player.sendMessage("7Please select two locations to fill");
		} else {
			try {
				int topBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() < plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int bottomBlockX = (plugin.getProfile(player).actionLocationA.getBlockX() > plugin.getProfile(player).actionLocationB.getBlockX() ? plugin.getProfile(player).actionLocationB.getBlockX() : plugin.getProfile(player).actionLocationA.getBlockX());
				int topBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() < plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int bottomBlockY = (plugin.getProfile(player).actionLocationA.getBlockY() > plugin.getProfile(player).actionLocationB.getBlockY() ? plugin.getProfile(player).actionLocationB.getBlockY() : plugin.getProfile(player).actionLocationA.getBlockY());
				int topBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() < plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				int bottomBlockZ = (plugin.getProfile(player).actionLocationA.getBlockZ() > plugin.getProfile(player).actionLocationB.getBlockZ() ? plugin.getProfile(player).actionLocationB.getBlockZ() : plugin.getProfile(player).actionLocationA.getBlockZ());
				if (getNumberOfBlocksInArea(topBlockX, bottomBlockX, topBlockY, bottomBlockY, topBlockZ, bottomBlockZ) > plugin.getProfile(player).rank.getEvilEditAreaLimit() && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
					player.sendMessage("7You can only fill up to an area of " + plugin.getProfile(player).rank.getEvilEditAreaLimit() + " blocks");
					player.sendMessage("7Rank-up to lift this limit");
					return;
				}
				Material blockMaterial = plugin.getBlockMaterial(args[0]);
				if (blockMaterial == null) {
					player.sendMessage("7Please enter a valid block name or ID");
					return;
				}
				plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
				for (int x = bottomBlockX; x <= topBlockX; x++)
				{
					for (int z = bottomBlockZ; z <= topBlockZ; z++)
					{
						for (int y = bottomBlockY; y <= topBlockY; y++)
						{
							// TODO: Re-add block material data support
							setBlock(player, new Location(player.getWorld(), x, y, z), blockMaterial, new MaterialData(blockMaterial));
						}
					}
				}
			} catch (Exception exception) {
				exception.printStackTrace();
			}
		}
	}

	public void createSphere(Player player, String[] args, Boolean hollow) {
		if (plugin.isInSurvival(player)) {
			player.sendMessage("7EvilEdit can't be used in survival");
		} else if (args.length != 2 && args.length != 3 && args.length != 5) {
			player.sendMessage("5Incorrect command usage");
			if (hollow) {
				player.sendMessage("d/hsphere [blockID / blockName] [radius]");
				player.sendMessage("d/hsphere [blockID / blockName] [blockData] [radius]");
				player.sendMessage("d/hsphere [blockID / blockName] [blockData] [radiusX] [radiusY] [radiusZ]");
			} else {
				player.sendMessage("d/sphere [blockID / blockName] [radius]");
				player.sendMessage("d/sphere [blockID / blockName] [blockData] [radius]");
				player.sendMessage("d/sphere [blockID / blockName] [blockData] [radiusX] [radiusY] [radiusZ]");
			}
		} else if (args.length == 2 && !plugin.isInteger(args[1])) {
			player.sendMessage("7Please enter a valid radius");
		} else if (args.length == 3 && (!plugin.isByte(args[1]) || !plugin.isInteger(args[2]))) {
			player.sendMessage("7Please enter a valid radius and block data value");
		} else if (args.length == 5 && (!plugin.isByte(args[1]) || !plugin.isInteger(args[2]) || !plugin.isInteger(args[3]) || !plugin.isInteger(args[4]))) {
			player.sendMessage("7Please enter a valid radius and block data value");
		} else {
			double radiusX = args.length == 2 ? Integer.valueOf(args[1]) + 0.5 : args.length == 3 ? Integer.valueOf(args[2]) + 0.5 : Integer.valueOf(args[2]) + 0.5;
			double radiusY = args.length == 2 ? Integer.valueOf(args[1]) + 0.5 : args.length == 3 ? Integer.valueOf(args[2]) + 0.5 : Integer.valueOf(args[3]) + 0.5;
			double radiusZ = args.length == 2 ? Integer.valueOf(args[1]) + 0.5 : args.length == 3 ? Integer.valueOf(args[2]) + 0.5 : Integer.valueOf(args[4]) + 0.5;
			if ((radiusX > 25 || radiusY > 25 || radiusZ > 25) && plugin.getProfile(player).rank.getID() < Rank.ServerOwner.getID()) {
				player.sendMessage("7The maximum radius limit is 25");
				return;
			}		 
			Material blockMaterial = plugin.getBlockMaterial(args[0]);
			if (blockMaterial == null) {
				player.sendMessage("7Please enter a valid block name or ID");
				return;
			}
			plugin.getProfile(player).EvilEditUndo = new ArrayList<>();
			//TODO: Re-add block data support
			MaterialData blockData = new MaterialData(blockMaterial);//args.length == 2 ? 0 : Byte.valueOf(args[2]);
			final double invRadiusX = 1 / radiusX;
			final double invRadiusY = 1 / radiusY;
			final double invRadiusZ = 1 / radiusZ;
			final int ceilRadiusX = (int) Math.ceil(radiusX);
			final int ceilRadiusY = (int) Math.ceil(radiusY);
			final int ceilRadiusZ = (int) Math.ceil(radiusZ);
			int blocks = 0;
			double nextXn = 0;
			forX: for (int x = 0; x <= ceilRadiusX; ++x) {
				final double xn = nextXn;
				nextXn = (x + 1) * invRadiusX;
				double nextYn = 0;
				forY: for (int y = 0; y <= ceilRadiusY; ++y) {
					final double yn = nextYn;
					nextYn = (y + 1) * invRadiusY;
					double nextZn = 0;
					forZ: for (int z = 0; z <= ceilRadiusZ; ++z) {
						final double zn = nextZn;
						nextZn = (z + 1) * invRadiusZ;
						double distanceSq = lengthSq(xn, yn, zn);
						if (distanceSq > 1) {
							if (z == 0) {
								if (y == 0) {
									break forX;
								}
								break forY;
							}
							break forZ;
						}
						if (hollow && lengthSq(nextXn, yn, zn) <= 1 && lengthSq(xn, nextYn, zn) <= 1 && lengthSq(xn, yn, nextZn) <= 1) continue;
						if (setBlock(player, player.getLocation().add(x, y, z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(-x, y, z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(x, -y, z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(x, y, -z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(-x, -y, z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(x, -y, -z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(-x, y, -z), blockMaterial, blockData)) blocks++;
						if (setBlock(player, player.getLocation().add(-x, -y, -z), blockMaterial, blockData)) blocks++;
					}
				}
			}
			player.sendMessage((hollow ? "7Created a hollow " : "7Created a ") + blocks + " block sphere made of " + plugin.blockList.get(blockMaterial).get(0));
		}
	}

	/**
	 * Square a length
	 * @param x The X length
	 * @param y The Y length
	 * @param z The Z length
	 * @return The squared length
	 */
	double lengthSq(double x, double y, double z) {
		return (x * x) + (y * y) + (z * z);
	}
	
	/**
	 * Return the number of blocks in an area
	 * @param topBlockX The top X block
	 * @param bottomBlockX The bottom X block
	 * @param topBlockY The top Y block
	 * @param bottomBlockY The bottom Y block
	 * @param topBlockZ The top Z block
	 * @param bottomBlockZ The bottom Z block
	 * @return Number of blocks in the area
	 */
	public int getNumberOfBlocksInArea(int topBlockX, int bottomBlockX, int topBlockY, int bottomBlockY, int topBlockZ, int bottomBlockZ) {
		return (((topBlockX - bottomBlockX) + 1) * ((topBlockY - bottomBlockY) + 1) * ((topBlockZ - bottomBlockZ) + 1));
	}

	/**
	 * Set a given block at a given location
	 * @param player The player setting the block
	 * @param location The location of the block
	 * @param blockMaterial The material of the block
	 * @param blockData The data of the block
	 * @return If the block was set
	 */
	public Boolean setBlock(Player player, Location location, Material blockMaterial, MaterialData blockData) {
		//TODO: Add support for material data
		if (location.getBlock().getType() != blockMaterial) { //|| player.getWorld().getBlockAt(location).getData() != blockData) {
			plugin.getProfile(player).EvilEditUndo.add(new EvilEditBlock(location.getBlock().getType(), new MaterialData(location.getBlock().getType()), location));
			editBlockList.add(new EvilEditBlock(blockMaterial, blockData, location));
			return true;
		}
		return false;
	}
	
	//TODO: Implement
	public Boolean isBlocked(Material material) {
		switch (material) {
		case BED_BLOCK:
			return true;
		case PISTON_EXTENSION:
			return true;
		case PISTON_MOVING_PIECE:
			return true;
		case WALL_SIGN:
			return true;
		case SIGN_POST:
			return true;
		case IRON_DOOR_BLOCK:
			return true;
		default:
			return false;
		}
	}
}
