package me.evilpeanut;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.material.MaterialData;

/**
 * @author Reece Aaron Lecrivain
 */
public class EvilEditBlock {
	private Material type;
	private MaterialData data;
	private Location location;

	/**
	 * @return The location of the block
	 */
	Location getLocation(){ return location; }

	/**
	 * @return The material data of the block
	 */
	MaterialData getData(){ return data; }
	
	/**
	 * @return type The material type of the block
	 */
	Material getType(){ return type; }

	/**
	 * Define a new evil edit block with a data value of 0
	 * @param type The material type of the block
	 * @param location The location of the block
	 */
	public EvilEditBlock(Material type, Location location) {
		this.type = type;
		this.data = new MaterialData(type);
		this.location = location;
	}
	
	/**
	 * Define a new evil edit block
	 * @param type The material type of the block
	 * @param data The material data of the block
	 * @param location The location of the block
	 */
	public EvilEditBlock(Material type, MaterialData data, Location location) {
		this.type = type;
		this.data = data;
		this.location = location;
	}
}
