package me.evilpeanut;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.material.MaterialData;

/**
 * @author Reece Aaron Lecrivain
 */
@SuppressWarnings("serial")
public class MarketItemStack implements Serializable {
	public String seller;
	public MaterialData data;
	public Material type;
	public int price, amount;
	public Map<Integer, Integer> enchantmentList = new HashMap<>();
	
	public MarketItemStack(String seller, int price, int amount, Material type, MaterialData data, Map<Integer, Integer> enchantmentList) {
		this.seller = seller;
		this.price = price;
		this.amount = amount;
		this.type = type;
		this.data = data;
		this.enchantmentList = enchantmentList;
	}
	
	public ItemStack toItemStack(int amount) {
		ItemStack newStack = new ItemStack(type, amount);
		// TODO: Re-add support for item data
		newStack.setData(new MaterialData(type));
		for (int i = 0; i < enchantmentList.size(); i++) newStack.addEnchantment(Enchantment.getById((int)enchantmentList.keySet().toArray()[i]), (Integer)enchantmentList.values().toArray()[i]);
		ItemMeta newMeta = newStack.getItemMeta();
		newStack.setItemMeta(newMeta);
		return newStack;
	}
}
