package me.evilpeanut;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.Set;

public class Properties {
	private java.util.Properties properties;
	private File propertiesFile;
	
	public Properties(String filePath) {
		properties = new java.util.Properties();
		propertiesFile = new File(filePath);
		try {
			FileInputStream inputStream = new FileInputStream(propertiesFile);
			properties.load(inputStream);
			inputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Properties(File file) {
		properties = new java.util.Properties();
		propertiesFile = file;
		try {
			FileInputStream inputStream = new FileInputStream(propertiesFile);
			properties.load(inputStream);
			inputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Properties() {
		properties = new java.util.Properties();
	}
	
	public Boolean exists() {
		return propertiesFile.exists();
	}
	
	public String getProperty(String key) {
		return properties.getProperty(key);
	}
	
	public Set<String> getPropertyNames() {
		return properties.stringPropertyNames();
	}
	
	public void setProperty(String key, Long value) {
		properties.setProperty(key, Long.toString(value));
	}
	
	public void setProperty(String key, String value) {
		properties.setProperty(key, value);
	}
	
	public void removeProperty(Object key) {
		properties.remove(key);
	}

	public Set<Object> getKeySet() {
		return properties.keySet();
	}
	
	public void save(String comment) {
		try {
			FileOutputStream outputStream = new FileOutputStream(propertiesFile);
			properties.store(outputStream, comment);
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void save(String filePath, String comment) {
		try {
			if (propertiesFile == null) propertiesFile = new File(filePath);
			FileOutputStream outputStream = new FileOutputStream(filePath);
			properties.store(outputStream, comment);
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void save() {
		save(null);
	}
}
