package me.evilpeanut;

import java.util.Map.Entry;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.block.Sign;
import org.bukkit.entity.Player;

/**
 * @author Reece Aaron Lecrivain
 */
public class Scheduler {
	private EvilBook plugin;

	/**
	 * Define a new scheduler
	 * @param evilBook The parent EvilBook plugin
	 */
	public Scheduler(EvilBook evilBook) {
		plugin = evilBook;
	}

	/**
	 * Autosave the player profiles and display a tip
	 */
	public void TipsAutosave() {
		plugin.getServer().getScheduler().runTaskTimer(plugin, new Runnable() {
			@Override
			public void run() {
				for (Player p : plugin.getServer().getOnlinePlayers()) {
					if (plugin.getProfile(p).isAway) continue;
					if (System.currentTimeMillis() - plugin.getProfile(p).lastActionTime > 120000) {
						plugin.getProfile(p).isAway = true;
						plugin.broadcastPlayerMessage(p.getName(), "5" + p.getDisplayName() + " dhas gone AFK");
						plugin.getProfile(p).updatePlayerListName(p);
						continue;
					}
					if (plugin.getProfile(p).rank.getID() >= Rank.Admin.getID()) {
						p.sendMessage("dYou can always l/donate dagain for a higher rank");
						plugin.playerProfiles.get(p.getName().toLowerCase()).addMoney(20);
						plugin.playerProfiles.get(p.getName().toLowerCase()).setProperty("Money", Integer.toString(plugin.playerProfiles.get(p.getName().toLowerCase()).getMoney()));
					} else {
						p.sendMessage("dDonate to become an admin l/donate");
						plugin.playerProfiles.get(p.getName().toLowerCase()).addMoney(10);
						plugin.playerProfiles.get(p.getName().toLowerCase()).setProperty("Money", Integer.toString(plugin.playerProfiles.get(p.getName().toLowerCase()).getMoney()));
					}
					plugin.getProfile(p).saveProfile();
				}
				// Statistics
				plugin.statistics.save();
			}
		}, 0L, 6000L);
	}
	
	/**
	 * Update the dynamic signs
	 */
	public void UpdateDynamicSigns() {
		plugin.getServer().getScheduler().runTaskTimer(plugin, new Runnable() {
			@Override
			public void run() {
				for(Entry<Location, String[]> entry : plugin.dynamicSignList.entrySet()) {
					try {
						Block block = entry.getKey().getWorld().getBlockAt(entry.getKey());
						Sign s = (Sign) block.getState();
						String time = plugin.getTime(entry.getKey().getWorld());
						String weather = plugin.getWeather(block);
						s.setLine(0, entry.getValue()[0].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
						s.setLine(1, entry.getValue()[1].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
						s.setLine(2, entry.getValue()[2].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
						s.setLine(3, entry.getValue()[3].replace("[time]", time).replace("[weather]", weather).replace("[online]", Integer.toString(plugin.getServer().getOnlinePlayers().length)));
						if (!s.getLine(0).equals(((Sign)block.getState()).getLine(0)) || !s.getLine(1).equals(((Sign)block.getState()).getLine(1)) || !s.getLine(2).equals(((Sign)block.getState()).getLine(2)) || !s.getLine(3).equals(((Sign)block.getState()).getLine(3))) {
							s.update();
						}
					} catch (Exception exception) {
						plugin.dynamicSignList.remove(entry.getKey());
					}
				}
				// Mob Disguise
				for (Player p : plugin.getServer().getOnlinePlayers()) {
					if (plugin.getProfile(p).disguise != null) {
						plugin.getProfile(p).disguise.teleport(p.getLocation());
					}
				}
				// Evil Edit
				if (plugin.EvilEdit.editBlockList.size() == 0) return;
				for (int i = 0; i < (plugin.EvilEdit.editBlockList.size() < 20 ? plugin.EvilEdit.editBlockList.size() : 20); i++) {
					EvilEditBlock block = plugin.EvilEdit.editBlockList.get(0);
					// TODO: Re-add logging
					// TODO: Support material data
					block.getLocation().getBlock().setType(block.getType());
					//block.getLocation().getWorld().getBlockAt(block.getLocation()).setType(block.getType());
					plugin.EvilEdit.editBlockList.remove(0);
				}
			}
		}, 0L, 1L);
	}
}