package me.evilpeanut;

import org.bukkit.Location;

/**
 * @author Reece Aaron Lecrivain
 */
public class Region {
	private Boolean isProtected;
	private String regionName, welcomeMessage, leaveMessage, warpName, ownerName, allowedPlayers;
	private Location locationA, locationB;
	
	/**
	 * @return The players who have rights to the region
	 */
	String getAllowedPlayers(){ return allowedPlayers; }
	
	/**
	 * @param allowedPlayers The players who have rights to the region
	 */
	void setAllowedPlayers(String allowedPlayers) { this.allowedPlayers = allowedPlayers; }
	
	/**
	 * @return The region owner's name
	 */
	String getOwner(){ return ownerName; }
	
	/**
	 * @param ownerName The region owner's name
	 */
	void setOwner(String ownerName) { this.ownerName = ownerName; }
	
	/**
	 * @return The warp redirection name
	 */
	String getWarp(){ return warpName; }
	
	/**
	 * @param warpName The warp redirection name
	 */
	void setWarp(String warpName) { this.warpName = warpName; }
	
	/**
	 * @return The leave message
	 */
	String getLeaveMessage(){ return leaveMessage; }
	
	/**
	 * @param leaveMessage The leave message
	 */
	void setLeaveMessage(String leaveMessage) { this.leaveMessage = leaveMessage; }
	
	/**
	 * @return The welcome message
	 */
	String getWelcomeMessage(){ return welcomeMessage; }
	
	/**
	 * @param welcomeMessage The welcome message
	 */
	void setWelcomeMessage(String welcomeMessage) { this.welcomeMessage = welcomeMessage; }
	
	/**
	 * @return The region nam
	 */
	String getRegionName(){ return regionName; }
	
	/**
	 * @param regionName The region name
	 */
	void setRegionName(String regionName) { this.regionName = regionName; }
	
	/**
	 * @return If protection is enabled
	 */
	Boolean isProtected(){ return isProtected; }
	
	/**
	 * @param isProtected If protection is enabled
	 */
	void isProtected(Boolean isProtected) { this.isProtected = isProtected; }
	
	/**
	 * @return The first location point
	 */
	Location getLocationA(){ return locationA; }
	
	/**
	 * @param locationA The first location point
	 */
	void setLocationA(Location locationA) { this.locationA = locationA; }
	
	/**
	 * @return The second location point
	 */
	Location getLocationB(){ return locationB; }
	
	/**
	 * @param locationB The second location point
	 */
	void setLocationB(Location locationB) { this.locationB = locationB; }

	/**
	 * Define a new region
	 * @param plugin The EvilBook parent
	 * @param regionName The name of the region
	 * @param locationA The first location point of the region
	 * @param locationB The second location point of the region
	 * @param isProtected If protection is enabled in the region
	 * @param ownerName The region owner's name
	 * @param welcomeMessage The welcome message of the region
	 * @param leaveMessage The leave message of the region
	 * @param allowedPlayers The players who have rights to the region
	 */
	public Region(EvilBook plugin, String regionName, Location locationA, Location locationB, Boolean isProtected, String ownerName, String welcomeMessage, String leaveMessage, String allowedPlayers)
	{
		this.regionName = regionName;
		this.locationA = locationA;
		this.locationB = locationB;
		this.isProtected = isProtected;
		this.ownerName = ownerName;
		if (welcomeMessage != null) this.welcomeMessage = plugin.toFormattedString(welcomeMessage);
		if (leaveMessage != null) this.leaveMessage = plugin.toFormattedString(leaveMessage);
		this.allowedPlayers = allowedPlayers;
	}
}